// @generated
//  This file was automatically generated and should not be edited.

import Apollo
import Foundation

/// GQL namespace
public extension GQL {
  final class GetCartQuery: GraphQLQuery {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      query getCart($cartHash: String) {
        Cart(Request: {CartHash: $cartHash}) {
          __typename
          ...cartResponseFields
        }
      }
      """

    public let operationName: String = "getCart"

    public let operationIdentifier: String? = "1efa394d240330090b7c9f32cf18646bcf2c7e2f8fc08f69e99aba5641e181c1"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartResponseFields.fragmentDefinition)
      document.append("\n" + CartItemFields.fragmentDefinition)
      document.append("\n" + OrderVariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeValueAtrributeFields.fragmentDefinition)
      document.append("\n" + AttibuteValueAttributeAttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeGroupFields.fragmentDefinition)
      document.append("\n" + VariantPriceFields.fragmentDefinition)
      document.append("\n" + VariantPriceDiscountFeilds.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + ProductFields.fragmentDefinition)
      document.append("\n" + CategoryFields.fragmentDefinition)
      document.append("\n" + BadgeFields.fragmentDefinition)
      document.append("\n" + FileFields.fragmentDefinition)
      document.append("\n" + StaticPageFields.fragmentDefinition)
      document.append("\n" + VariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueImageFields.fragmentDefinition)
      document.append("\n" + ReviewProviderFields.fragmentDefinition)
      document.append("\n" + ReviewsSummaryFields.fragmentDefinition)
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      return document
    }

    public var cartHash: String?

    public init(cartHash: String? = nil) {
      self.cartHash = cartHash
    }

    public var variables: GraphQLMap? {
      return ["cartHash": cartHash]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Query"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("Cart", arguments: ["Request": ["CartHash": GraphQLVariable("cartHash")]], type: .object(Cart.selections)),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(cart: Cart? = nil) {
        self.init(unsafeResultMap: ["__typename": "Query", "Cart": cart.flatMap { (value: Cart) -> ResultMap in value.resultMap }])
      }

      public var cart: Cart? {
        get {
          return (resultMap["Cart"] as? ResultMap).flatMap { Cart(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Cart")
        }
      }

      public struct Cart: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Items", type: .list(.nonNull(.object(Item.selections)))),
            GraphQLField("Info", type: .nonNull(.object(Info.selections))),
            GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(items: [Item]? = nil, info: Info, errors: [Error]? = nil) {
          self.init(unsafeResultMap: ["__typename": "CartResponse", "Items": items.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, "Info": info.resultMap, "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var items: [Item]? {
          get {
            return (resultMap["Items"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Item] in value.map { (value: ResultMap) -> Item in Item(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, forKey: "Items")
          }
        }

        public var info: Info {
          get {
            return Info(unsafeResultMap: resultMap["Info"]! as! ResultMap)
          }
          set {
            resultMap.updateValue(newValue.resultMap, forKey: "Info")
          }
        }

        public var errors: [Error]? {
          get {
            return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartResponseFields: CartResponseFields {
            get {
              return CartResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Item: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartItem"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
              GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
              GraphQLField("CartToken", type: .scalar(String.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var cartId: Uint64 {
            get {
              return resultMap["CartID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartID")
            }
          }

          public var variant: Variant {
            get {
              return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Variant")
            }
          }

          public var variantId: FID {
            get {
              return resultMap["VariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantID")
            }
          }

          public var variantPriceId: Uint64 {
            get {
              return resultMap["VariantPriceID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantPriceID")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var discountAmount: Double {
            get {
              return resultMap["DiscountAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountAmount")
            }
          }

          public var quantity: Int {
            get {
              return resultMap["Quantity"]! as! Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Quantity")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var isSubscription: Bool {
            get {
              return resultMap["IsSubscription"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsSubscription")
            }
          }

          public var orderShipments: [Time] {
            get {
              return resultMap["OrderShipments"]! as! [Time]
            }
            set {
              resultMap.updateValue(newValue, forKey: "OrderShipments")
            }
          }

          public var cartToken: String? {
            get {
              return resultMap["CartToken"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartToken")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartItemFields: CartItemFields {
              get {
                return CartItemFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Variant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Product", type: .object(Product.selections)),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var product: Product? {
              get {
                return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Product")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var orderVariantFields: OrderVariantFields {
                get {
                  return OrderVariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct Product: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Product"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Status", type: .nonNull(.scalar(String.self))),
                  GraphQLField("SingleShipping", type: .scalar(Bool.self)),
                  GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
                  GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Category", type: .nonNull(.object(Category.selections))),
                  GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
                  GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                  GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
                  GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
                  GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
                  GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
                  GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
                  GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                  GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
                  GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
                  GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
                  GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
                  GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
                self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: FID {
                get {
                  return resultMap["ID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var status: String {
                get {
                  return resultMap["Status"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Status")
                }
              }

              public var singleShipping: Bool? {
                get {
                  return resultMap["SingleShipping"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SingleShipping")
                }
              }

              public var type: TypeAll {
                get {
                  return resultMap["Type"]! as! TypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var categoryId: Uint64 {
                get {
                  return resultMap["CategoryID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CategoryID")
                }
              }

              public var category: Category {
                get {
                  return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
                }
                set {
                  resultMap.updateValue(newValue.resultMap, forKey: "Category")
                }
              }

              public var tags: [String] {
                get {
                  return resultMap["Tags"]! as! [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Tags")
                }
              }

              public var attributesValues: [AttributesValue]? {
                get {
                  return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                }
              }

              public var badge: [Badge]? {
                get {
                  return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
                }
              }

              public var noteIDs: [Uint64] {
                get {
                  return resultMap["NoteIDs"]! as! [Uint64]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "NoteIDs")
                }
              }

              public var notes: [Note] {
                get {
                  return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
                }
                set {
                  resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
                }
              }

              public var defaultVariantId: FID {
                get {
                  return resultMap["DefaultVariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DefaultVariantID")
                }
              }

              public var defaultVariant: DefaultVariant? {
                get {
                  return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
                }
              }

              public var variants: [Variant]? {
                get {
                  return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
                }
              }

              public var likes: Uint64 {
                get {
                  return resultMap["Likes"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Likes")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var images: [Image]? {
                get {
                  return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
                }
              }

              public var attributeValueImages: [AttributeValueImage]? {
                get {
                  return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
                }
              }

              public var reviewProvider: ReviewProvider? {
                get {
                  return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
                }
              }

              public var reviewsSummary: ReviewsSummary? {
                get {
                  return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
                }
              }

              public var productLink: String {
                get {
                  return resultMap["ProductLink"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ProductLink")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var productFields: ProductFields {
                  get {
                    return ProductFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Category: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Category"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("MainParent", type: .object(MainParent.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var mainParent: MainParent? {
                  get {
                    return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var categoryFields: CategoryFields {
                    get {
                      return CategoryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct MainParent: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Category"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, description: String) {
                    self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }
                }
              }

              public struct AttributesValue: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("Attribute", type: .object(Attribute.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var attribute: Attribute? {
                  get {
                    return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueFields: AttributeValueFields {
                    get {
                      return AttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Attribute: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Attribute"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("DisplayName", type: .scalar(String.self)),
                      GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                      GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                      GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                      GraphQLField("ParentID", type: .scalar(Uint64.self)),
                      GraphQLField("GroupID", type: .scalar(Uint64.self)),
                      GraphQLField("Group", type: .object(Group.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                    self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var displayName: String? {
                    get {
                      return resultMap["DisplayName"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DisplayName")
                    }
                  }

                  public var values: [Value]? {
                    get {
                      return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var inputType: InputTypeAll {
                    get {
                      return resultMap["InputType"]! as! InputTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "InputType")
                    }
                  }

                  public var `required`: Bool {
                    get {
                      return resultMap["Required"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Required")
                    }
                  }

                  public var hasThumbnail: Bool? {
                    get {
                      return resultMap["HasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "HasThumbnail")
                    }
                  }

                  public var attributeType: AttributeTypeAll {
                    get {
                      return resultMap["AttributeType"]! as! AttributeTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeType")
                    }
                  }

                  public var parentId: Uint64? {
                    get {
                      return resultMap["ParentID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ParentID")
                    }
                  }

                  public var groupId: Uint64? {
                    get {
                      return resultMap["GroupID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "GroupID")
                    }
                  }

                  public var group: Group? {
                    get {
                      return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                      get {
                        return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Value: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeValue"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .scalar(Uint64.self)),
                        GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                        GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                      self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64? {
                      get {
                        return resultMap["ID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var value: String {
                      get {
                        return resultMap["Value"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Value")
                      }
                    }

                    public var attributeId: Uint64 {
                      get {
                        return resultMap["AttributeID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeID")
                      }
                    }

                    public var attributeHasThumbnail: Bool? {
                      get {
                        return resultMap["AttributeHasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var isVariationAttributeValue: Bool {
                      get {
                        return resultMap["IsVariationAttributeValue"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                        get {
                          return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }

                  public struct Group: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeGroup"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, sort: Uint64) {
                      self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeGroupFields: AttributeGroupFields {
                        get {
                          return AttributeGroupFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }
                }
              }

              public struct Badge: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Badge"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("Image", type: .nonNull(.object(Image.selections))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String? = nil, image: Image) {
                  self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var image: Image {
                  get {
                    return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
                  }
                  set {
                    resultMap.updateValue(newValue.resultMap, forKey: "Image")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var badgeFields: BadgeFields {
                    get {
                      return BadgeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct Note: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["StaticPage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Position", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Content", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, position: String, content: String) {
                  self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var position: String {
                  get {
                    return resultMap["Position"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Position")
                  }
                }

                public var content: String {
                  get {
                    return resultMap["Content"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Content")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var staticPageFields: StaticPageFields {
                    get {
                      return StaticPageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct DefaultVariant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Variant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Image: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["File"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                    GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                    GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                  self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var url: String {
                  get {
                    return resultMap["URL"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "URL")
                  }
                }

                public var idType: FileIDType {
                  get {
                    return resultMap["IDType"]! as! FileIDType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IDType")
                  }
                }

                public var category: FileCategoryAll {
                  get {
                    return resultMap["Category"]! as! FileCategoryAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Category")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var fileFields: FileFields {
                    get {
                      return FileFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct AttributeValueImage: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValueImage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Key", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(key: String, images: [Image]) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var key: String {
                  get {
                    return resultMap["Key"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Key")
                  }
                }

                public var images: [Image] {
                  get {
                    return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
                  }
                  set {
                    resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueImageFields: AttributeValueImageFields {
                    get {
                      return AttributeValueImageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct ReviewProvider: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewProvider"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
                    GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
                  self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var platform: ReviewProviderPlatformAll {
                  get {
                    return resultMap["Platform"]! as! ReviewProviderPlatformAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Platform")
                  }
                }

                public var type: ProductReviewTypeAll {
                  get {
                    return resultMap["Type"]! as! ProductReviewTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Type")
                  }
                }

                public var id: String {
                  get {
                    return resultMap["ID"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewProviderFields: ReviewProviderFields {
                    get {
                      return ReviewProviderFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct ReviewsSummary: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewsSummary"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(total: Uint64, stars: Double) {
                  self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var total: Uint64 {
                  get {
                    return resultMap["Total"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Total")
                  }
                }

                public var stars: Double {
                  get {
                    return resultMap["Stars"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Stars")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewsSummaryFields: ReviewsSummaryFields {
                    get {
                      return ReviewsSummaryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Info: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Cart"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Discount", type: .object(Discount.selections)),
              GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
              GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
              GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
              GraphQLField("ZipCode", type: .scalar(String.self)),
              GraphQLField("ClosedAt", type: .scalar(Time.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var payablePrice: Double {
            get {
              return resultMap["PayablePrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "PayablePrice")
            }
          }

          public var totalAmount: Double {
            get {
              return resultMap["TotalAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "TotalAmount")
            }
          }

          public var discountCodeAmount: Double {
            get {
              return resultMap["DiscountCodeAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
            }
          }

          public var hasDiscount: Bool {
            get {
              return resultMap["HasDiscount"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "HasDiscount")
            }
          }

          public var discount: Discount? {
            get {
              return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
            }
          }

          public var discounts: [Discount]? {
            get {
              return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
            }
          }

          public var deliveryDiscount: DeliveryDiscount? {
            get {
              return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
            }
          }

          public var status: CartStatusAll {
            get {
              return resultMap["Status"]! as! CartStatusAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Status")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var sourceClose: SourceAll? {
            get {
              return resultMap["SourceClose"] as? SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "SourceClose")
            }
          }

          public var zipCode: String? {
            get {
              return resultMap["ZipCode"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ZipCode")
            }
          }

          public var closedAt: Time? {
            get {
              return resultMap["ClosedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "ClosedAt")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartFields: CartFields {
              get {
                return CartFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct DeliveryDiscount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Error: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  final class GetCartResellingPricesQuery: GraphQLQuery {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      query GetCartResellingPrices($cartHash: String) {
        CartResellingPrices(Request: {CartHash: $cartHash}) {
          __typename
          ...ResellingPriceFields
        }
      }
      """

    public let operationName: String = "GetCartResellingPrices"

    public let operationIdentifier: String? = "6f83b7828f6c23f452c1daf86de702c30929d0020dd2b712d88805f310bf94f3"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + ResellingPriceFields.fragmentDefinition)
      return document
    }

    public var cartHash: String?

    public init(cartHash: String? = nil) {
      self.cartHash = cartHash
    }

    public var variables: GraphQLMap? {
      return ["cartHash": cartHash]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Query"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("CartResellingPrices", arguments: ["Request": ["CartHash": GraphQLVariable("cartHash")]], type: .nonNull(.list(.nonNull(.object(CartResellingPrice.selections))))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(cartResellingPrices: [CartResellingPrice]) {
        self.init(unsafeResultMap: ["__typename": "Query", "CartResellingPrices": cartResellingPrices.map { (value: CartResellingPrice) -> ResultMap in value.resultMap }])
      }

      public var cartResellingPrices: [CartResellingPrice] {
        get {
          return (resultMap["CartResellingPrices"] as! [ResultMap]).map { (value: ResultMap) -> CartResellingPrice in CartResellingPrice(unsafeResultMap: value) }
        }
        set {
          resultMap.updateValue(newValue.map { (value: CartResellingPrice) -> ResultMap in value.resultMap }, forKey: "CartResellingPrices")
        }
      }

      public struct CartResellingPrice: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["ResellingPrice"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("CartItemID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Price", type: .nonNull(.scalar(Double.self))),
            GraphQLField("ResellerPrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("SetAt", type: .scalar(Time.self)),
            GraphQLField("IsSet", type: .nonNull(.scalar(Bool.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(cartItemId: Uint64, price: Double, resellerPrice: Double, setAt: Time? = nil, isSet: Bool) {
          self.init(unsafeResultMap: ["__typename": "ResellingPrice", "CartItemID": cartItemId, "Price": price, "ResellerPrice": resellerPrice, "SetAt": setAt, "IsSet": isSet])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var cartItemId: Uint64 {
          get {
            return resultMap["CartItemID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "CartItemID")
          }
        }

        public var price: Double {
          get {
            return resultMap["Price"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "Price")
          }
        }

        public var resellerPrice: Double {
          get {
            return resultMap["ResellerPrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "ResellerPrice")
          }
        }

        public var setAt: Time? {
          get {
            return resultMap["SetAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "SetAt")
          }
        }

        public var isSet: Bool {
          get {
            return resultMap["IsSet"]! as! Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "IsSet")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var resellingPriceFields: ResellingPriceFields {
            get {
              return ResellingPriceFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }
    }
  }

  final class AddItemToCartMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation addItemToCart($variantId: FID!, $variantPriceID: Uint64!, $cartHash: String, $quantity: Uint64!, $source: SourceAll!, $orderShipments: [Time!]!) {
        AddItem(
          Request: {VariantID: $variantId, VariantPriceID: $variantPriceID, CartHash: $cartHash, Quantity: $quantity, Source: $source, OrderShipments: $orderShipments}
        ) {
          __typename
          ...cartResponseFields
        }
      }
      """

    public let operationName: String = "addItemToCart"

    public let operationIdentifier: String? = "2513eab19fdda403a18d86ceef2d90891c93cb41ec7384527dbc255d2c4fea97"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartResponseFields.fragmentDefinition)
      document.append("\n" + CartItemFields.fragmentDefinition)
      document.append("\n" + OrderVariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeValueAtrributeFields.fragmentDefinition)
      document.append("\n" + AttibuteValueAttributeAttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeGroupFields.fragmentDefinition)
      document.append("\n" + VariantPriceFields.fragmentDefinition)
      document.append("\n" + VariantPriceDiscountFeilds.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + ProductFields.fragmentDefinition)
      document.append("\n" + CategoryFields.fragmentDefinition)
      document.append("\n" + BadgeFields.fragmentDefinition)
      document.append("\n" + FileFields.fragmentDefinition)
      document.append("\n" + StaticPageFields.fragmentDefinition)
      document.append("\n" + VariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueImageFields.fragmentDefinition)
      document.append("\n" + ReviewProviderFields.fragmentDefinition)
      document.append("\n" + ReviewsSummaryFields.fragmentDefinition)
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      return document
    }

    public var variantId: FID
    public var variantPriceID: Uint64
    public var cartHash: String?
    public var quantity: Uint64
    public var source: SourceAll
    public var orderShipments: [Time]

    public init(variantId: FID, variantPriceID: Uint64, cartHash: String? = nil, quantity: Uint64, source: SourceAll, orderShipments: [Time]) {
      self.variantId = variantId
      self.variantPriceID = variantPriceID
      self.cartHash = cartHash
      self.quantity = quantity
      self.source = source
      self.orderShipments = orderShipments
    }

    public var variables: GraphQLMap? {
      return ["variantId": variantId, "variantPriceID": variantPriceID, "cartHash": cartHash, "quantity": quantity, "source": source, "orderShipments": orderShipments]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("AddItem", arguments: ["Request": ["VariantID": GraphQLVariable("variantId"), "VariantPriceID": GraphQLVariable("variantPriceID"), "CartHash": GraphQLVariable("cartHash"), "Quantity": GraphQLVariable("quantity"), "Source": GraphQLVariable("source"), "OrderShipments": GraphQLVariable("orderShipments")]], type: .nonNull(.object(AddItem.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(addItem: AddItem) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "AddItem": addItem.resultMap])
      }

      public var addItem: AddItem {
        get {
          return AddItem(unsafeResultMap: resultMap["AddItem"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "AddItem")
        }
      }

      public struct AddItem: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Items", type: .list(.nonNull(.object(Item.selections)))),
            GraphQLField("Info", type: .nonNull(.object(Info.selections))),
            GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(items: [Item]? = nil, info: Info, errors: [Error]? = nil) {
          self.init(unsafeResultMap: ["__typename": "CartResponse", "Items": items.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, "Info": info.resultMap, "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var items: [Item]? {
          get {
            return (resultMap["Items"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Item] in value.map { (value: ResultMap) -> Item in Item(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, forKey: "Items")
          }
        }

        public var info: Info {
          get {
            return Info(unsafeResultMap: resultMap["Info"]! as! ResultMap)
          }
          set {
            resultMap.updateValue(newValue.resultMap, forKey: "Info")
          }
        }

        public var errors: [Error]? {
          get {
            return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartResponseFields: CartResponseFields {
            get {
              return CartResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Item: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartItem"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
              GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
              GraphQLField("CartToken", type: .scalar(String.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var cartId: Uint64 {
            get {
              return resultMap["CartID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartID")
            }
          }

          public var variant: Variant {
            get {
              return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Variant")
            }
          }

          public var variantId: FID {
            get {
              return resultMap["VariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantID")
            }
          }

          public var variantPriceId: Uint64 {
            get {
              return resultMap["VariantPriceID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantPriceID")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var discountAmount: Double {
            get {
              return resultMap["DiscountAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountAmount")
            }
          }

          public var quantity: Int {
            get {
              return resultMap["Quantity"]! as! Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Quantity")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var isSubscription: Bool {
            get {
              return resultMap["IsSubscription"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsSubscription")
            }
          }

          public var orderShipments: [Time] {
            get {
              return resultMap["OrderShipments"]! as! [Time]
            }
            set {
              resultMap.updateValue(newValue, forKey: "OrderShipments")
            }
          }

          public var cartToken: String? {
            get {
              return resultMap["CartToken"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartToken")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartItemFields: CartItemFields {
              get {
                return CartItemFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Variant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Product", type: .object(Product.selections)),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var product: Product? {
              get {
                return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Product")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var orderVariantFields: OrderVariantFields {
                get {
                  return OrderVariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct Product: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Product"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Status", type: .nonNull(.scalar(String.self))),
                  GraphQLField("SingleShipping", type: .scalar(Bool.self)),
                  GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
                  GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Category", type: .nonNull(.object(Category.selections))),
                  GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
                  GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                  GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
                  GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
                  GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
                  GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
                  GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
                  GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                  GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
                  GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
                  GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
                  GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
                  GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
                self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: FID {
                get {
                  return resultMap["ID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var status: String {
                get {
                  return resultMap["Status"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Status")
                }
              }

              public var singleShipping: Bool? {
                get {
                  return resultMap["SingleShipping"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SingleShipping")
                }
              }

              public var type: TypeAll {
                get {
                  return resultMap["Type"]! as! TypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var categoryId: Uint64 {
                get {
                  return resultMap["CategoryID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CategoryID")
                }
              }

              public var category: Category {
                get {
                  return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
                }
                set {
                  resultMap.updateValue(newValue.resultMap, forKey: "Category")
                }
              }

              public var tags: [String] {
                get {
                  return resultMap["Tags"]! as! [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Tags")
                }
              }

              public var attributesValues: [AttributesValue]? {
                get {
                  return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                }
              }

              public var badge: [Badge]? {
                get {
                  return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
                }
              }

              public var noteIDs: [Uint64] {
                get {
                  return resultMap["NoteIDs"]! as! [Uint64]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "NoteIDs")
                }
              }

              public var notes: [Note] {
                get {
                  return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
                }
                set {
                  resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
                }
              }

              public var defaultVariantId: FID {
                get {
                  return resultMap["DefaultVariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DefaultVariantID")
                }
              }

              public var defaultVariant: DefaultVariant? {
                get {
                  return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
                }
              }

              public var variants: [Variant]? {
                get {
                  return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
                }
              }

              public var likes: Uint64 {
                get {
                  return resultMap["Likes"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Likes")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var images: [Image]? {
                get {
                  return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
                }
              }

              public var attributeValueImages: [AttributeValueImage]? {
                get {
                  return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
                }
              }

              public var reviewProvider: ReviewProvider? {
                get {
                  return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
                }
              }

              public var reviewsSummary: ReviewsSummary? {
                get {
                  return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
                }
              }

              public var productLink: String {
                get {
                  return resultMap["ProductLink"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ProductLink")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var productFields: ProductFields {
                  get {
                    return ProductFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Category: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Category"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("MainParent", type: .object(MainParent.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var mainParent: MainParent? {
                  get {
                    return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var categoryFields: CategoryFields {
                    get {
                      return CategoryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct MainParent: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Category"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, description: String) {
                    self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }
                }
              }

              public struct AttributesValue: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("Attribute", type: .object(Attribute.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var attribute: Attribute? {
                  get {
                    return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueFields: AttributeValueFields {
                    get {
                      return AttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Attribute: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Attribute"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("DisplayName", type: .scalar(String.self)),
                      GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                      GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                      GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                      GraphQLField("ParentID", type: .scalar(Uint64.self)),
                      GraphQLField("GroupID", type: .scalar(Uint64.self)),
                      GraphQLField("Group", type: .object(Group.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                    self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var displayName: String? {
                    get {
                      return resultMap["DisplayName"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DisplayName")
                    }
                  }

                  public var values: [Value]? {
                    get {
                      return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var inputType: InputTypeAll {
                    get {
                      return resultMap["InputType"]! as! InputTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "InputType")
                    }
                  }

                  public var `required`: Bool {
                    get {
                      return resultMap["Required"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Required")
                    }
                  }

                  public var hasThumbnail: Bool? {
                    get {
                      return resultMap["HasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "HasThumbnail")
                    }
                  }

                  public var attributeType: AttributeTypeAll {
                    get {
                      return resultMap["AttributeType"]! as! AttributeTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeType")
                    }
                  }

                  public var parentId: Uint64? {
                    get {
                      return resultMap["ParentID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ParentID")
                    }
                  }

                  public var groupId: Uint64? {
                    get {
                      return resultMap["GroupID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "GroupID")
                    }
                  }

                  public var group: Group? {
                    get {
                      return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                      get {
                        return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Value: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeValue"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .scalar(Uint64.self)),
                        GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                        GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                      self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64? {
                      get {
                        return resultMap["ID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var value: String {
                      get {
                        return resultMap["Value"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Value")
                      }
                    }

                    public var attributeId: Uint64 {
                      get {
                        return resultMap["AttributeID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeID")
                      }
                    }

                    public var attributeHasThumbnail: Bool? {
                      get {
                        return resultMap["AttributeHasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var isVariationAttributeValue: Bool {
                      get {
                        return resultMap["IsVariationAttributeValue"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                        get {
                          return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }

                  public struct Group: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeGroup"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, sort: Uint64) {
                      self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeGroupFields: AttributeGroupFields {
                        get {
                          return AttributeGroupFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }
                }
              }

              public struct Badge: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Badge"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("Image", type: .nonNull(.object(Image.selections))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String? = nil, image: Image) {
                  self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var image: Image {
                  get {
                    return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
                  }
                  set {
                    resultMap.updateValue(newValue.resultMap, forKey: "Image")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var badgeFields: BadgeFields {
                    get {
                      return BadgeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct Note: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["StaticPage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Position", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Content", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, position: String, content: String) {
                  self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var position: String {
                  get {
                    return resultMap["Position"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Position")
                  }
                }

                public var content: String {
                  get {
                    return resultMap["Content"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Content")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var staticPageFields: StaticPageFields {
                    get {
                      return StaticPageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct DefaultVariant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Variant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Image: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["File"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                    GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                    GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                  self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var url: String {
                  get {
                    return resultMap["URL"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "URL")
                  }
                }

                public var idType: FileIDType {
                  get {
                    return resultMap["IDType"]! as! FileIDType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IDType")
                  }
                }

                public var category: FileCategoryAll {
                  get {
                    return resultMap["Category"]! as! FileCategoryAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Category")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var fileFields: FileFields {
                    get {
                      return FileFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct AttributeValueImage: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValueImage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Key", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(key: String, images: [Image]) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var key: String {
                  get {
                    return resultMap["Key"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Key")
                  }
                }

                public var images: [Image] {
                  get {
                    return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
                  }
                  set {
                    resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueImageFields: AttributeValueImageFields {
                    get {
                      return AttributeValueImageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct ReviewProvider: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewProvider"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
                    GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
                  self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var platform: ReviewProviderPlatformAll {
                  get {
                    return resultMap["Platform"]! as! ReviewProviderPlatformAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Platform")
                  }
                }

                public var type: ProductReviewTypeAll {
                  get {
                    return resultMap["Type"]! as! ProductReviewTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Type")
                  }
                }

                public var id: String {
                  get {
                    return resultMap["ID"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewProviderFields: ReviewProviderFields {
                    get {
                      return ReviewProviderFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct ReviewsSummary: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewsSummary"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(total: Uint64, stars: Double) {
                  self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var total: Uint64 {
                  get {
                    return resultMap["Total"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Total")
                  }
                }

                public var stars: Double {
                  get {
                    return resultMap["Stars"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Stars")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewsSummaryFields: ReviewsSummaryFields {
                    get {
                      return ReviewsSummaryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Info: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Cart"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Discount", type: .object(Discount.selections)),
              GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
              GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
              GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
              GraphQLField("ZipCode", type: .scalar(String.self)),
              GraphQLField("ClosedAt", type: .scalar(Time.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var payablePrice: Double {
            get {
              return resultMap["PayablePrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "PayablePrice")
            }
          }

          public var totalAmount: Double {
            get {
              return resultMap["TotalAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "TotalAmount")
            }
          }

          public var discountCodeAmount: Double {
            get {
              return resultMap["DiscountCodeAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
            }
          }

          public var hasDiscount: Bool {
            get {
              return resultMap["HasDiscount"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "HasDiscount")
            }
          }

          public var discount: Discount? {
            get {
              return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
            }
          }

          public var discounts: [Discount]? {
            get {
              return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
            }
          }

          public var deliveryDiscount: DeliveryDiscount? {
            get {
              return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
            }
          }

          public var status: CartStatusAll {
            get {
              return resultMap["Status"]! as! CartStatusAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Status")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var sourceClose: SourceAll? {
            get {
              return resultMap["SourceClose"] as? SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "SourceClose")
            }
          }

          public var zipCode: String? {
            get {
              return resultMap["ZipCode"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ZipCode")
            }
          }

          public var closedAt: Time? {
            get {
              return resultMap["ClosedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "ClosedAt")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartFields: CartFields {
              get {
                return CartFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct DeliveryDiscount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Error: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  final class RemoveItemFromCartMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation removeItemFromCart($id: Uint64!, $cartHash: String) {
        RemoveItem(Request: {ID: $id, CartHash: $cartHash}) {
          __typename
          ...cartResponseFields
        }
      }
      """

    public let operationName: String = "removeItemFromCart"

    public let operationIdentifier: String? = "69e37b85e8755316fb708465cde8314e813a9c00aa4996a94cf39a9e04ddbf8a"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartResponseFields.fragmentDefinition)
      document.append("\n" + CartItemFields.fragmentDefinition)
      document.append("\n" + OrderVariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeValueAtrributeFields.fragmentDefinition)
      document.append("\n" + AttibuteValueAttributeAttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeGroupFields.fragmentDefinition)
      document.append("\n" + VariantPriceFields.fragmentDefinition)
      document.append("\n" + VariantPriceDiscountFeilds.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + ProductFields.fragmentDefinition)
      document.append("\n" + CategoryFields.fragmentDefinition)
      document.append("\n" + BadgeFields.fragmentDefinition)
      document.append("\n" + FileFields.fragmentDefinition)
      document.append("\n" + StaticPageFields.fragmentDefinition)
      document.append("\n" + VariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueImageFields.fragmentDefinition)
      document.append("\n" + ReviewProviderFields.fragmentDefinition)
      document.append("\n" + ReviewsSummaryFields.fragmentDefinition)
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      return document
    }

    public var id: Uint64
    public var cartHash: String?

    public init(id: Uint64, cartHash: String? = nil) {
      self.id = id
      self.cartHash = cartHash
    }

    public var variables: GraphQLMap? {
      return ["id": id, "cartHash": cartHash]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("RemoveItem", arguments: ["Request": ["ID": GraphQLVariable("id"), "CartHash": GraphQLVariable("cartHash")]], type: .nonNull(.object(RemoveItem.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(removeItem: RemoveItem) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "RemoveItem": removeItem.resultMap])
      }

      public var removeItem: RemoveItem {
        get {
          return RemoveItem(unsafeResultMap: resultMap["RemoveItem"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "RemoveItem")
        }
      }

      public struct RemoveItem: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Items", type: .list(.nonNull(.object(Item.selections)))),
            GraphQLField("Info", type: .nonNull(.object(Info.selections))),
            GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(items: [Item]? = nil, info: Info, errors: [Error]? = nil) {
          self.init(unsafeResultMap: ["__typename": "CartResponse", "Items": items.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, "Info": info.resultMap, "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var items: [Item]? {
          get {
            return (resultMap["Items"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Item] in value.map { (value: ResultMap) -> Item in Item(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, forKey: "Items")
          }
        }

        public var info: Info {
          get {
            return Info(unsafeResultMap: resultMap["Info"]! as! ResultMap)
          }
          set {
            resultMap.updateValue(newValue.resultMap, forKey: "Info")
          }
        }

        public var errors: [Error]? {
          get {
            return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartResponseFields: CartResponseFields {
            get {
              return CartResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Item: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartItem"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
              GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
              GraphQLField("CartToken", type: .scalar(String.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var cartId: Uint64 {
            get {
              return resultMap["CartID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartID")
            }
          }

          public var variant: Variant {
            get {
              return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Variant")
            }
          }

          public var variantId: FID {
            get {
              return resultMap["VariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantID")
            }
          }

          public var variantPriceId: Uint64 {
            get {
              return resultMap["VariantPriceID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantPriceID")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var discountAmount: Double {
            get {
              return resultMap["DiscountAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountAmount")
            }
          }

          public var quantity: Int {
            get {
              return resultMap["Quantity"]! as! Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Quantity")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var isSubscription: Bool {
            get {
              return resultMap["IsSubscription"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsSubscription")
            }
          }

          public var orderShipments: [Time] {
            get {
              return resultMap["OrderShipments"]! as! [Time]
            }
            set {
              resultMap.updateValue(newValue, forKey: "OrderShipments")
            }
          }

          public var cartToken: String? {
            get {
              return resultMap["CartToken"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartToken")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartItemFields: CartItemFields {
              get {
                return CartItemFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Variant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Product", type: .object(Product.selections)),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var product: Product? {
              get {
                return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Product")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var orderVariantFields: OrderVariantFields {
                get {
                  return OrderVariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct Product: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Product"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Status", type: .nonNull(.scalar(String.self))),
                  GraphQLField("SingleShipping", type: .scalar(Bool.self)),
                  GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
                  GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Category", type: .nonNull(.object(Category.selections))),
                  GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
                  GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                  GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
                  GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
                  GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
                  GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
                  GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
                  GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                  GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
                  GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
                  GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
                  GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
                  GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
                self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: FID {
                get {
                  return resultMap["ID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var status: String {
                get {
                  return resultMap["Status"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Status")
                }
              }

              public var singleShipping: Bool? {
                get {
                  return resultMap["SingleShipping"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SingleShipping")
                }
              }

              public var type: TypeAll {
                get {
                  return resultMap["Type"]! as! TypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var categoryId: Uint64 {
                get {
                  return resultMap["CategoryID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CategoryID")
                }
              }

              public var category: Category {
                get {
                  return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
                }
                set {
                  resultMap.updateValue(newValue.resultMap, forKey: "Category")
                }
              }

              public var tags: [String] {
                get {
                  return resultMap["Tags"]! as! [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Tags")
                }
              }

              public var attributesValues: [AttributesValue]? {
                get {
                  return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                }
              }

              public var badge: [Badge]? {
                get {
                  return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
                }
              }

              public var noteIDs: [Uint64] {
                get {
                  return resultMap["NoteIDs"]! as! [Uint64]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "NoteIDs")
                }
              }

              public var notes: [Note] {
                get {
                  return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
                }
                set {
                  resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
                }
              }

              public var defaultVariantId: FID {
                get {
                  return resultMap["DefaultVariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DefaultVariantID")
                }
              }

              public var defaultVariant: DefaultVariant? {
                get {
                  return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
                }
              }

              public var variants: [Variant]? {
                get {
                  return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
                }
              }

              public var likes: Uint64 {
                get {
                  return resultMap["Likes"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Likes")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var images: [Image]? {
                get {
                  return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
                }
              }

              public var attributeValueImages: [AttributeValueImage]? {
                get {
                  return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
                }
              }

              public var reviewProvider: ReviewProvider? {
                get {
                  return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
                }
              }

              public var reviewsSummary: ReviewsSummary? {
                get {
                  return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
                }
              }

              public var productLink: String {
                get {
                  return resultMap["ProductLink"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ProductLink")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var productFields: ProductFields {
                  get {
                    return ProductFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Category: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Category"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("MainParent", type: .object(MainParent.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var mainParent: MainParent? {
                  get {
                    return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var categoryFields: CategoryFields {
                    get {
                      return CategoryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct MainParent: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Category"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, description: String) {
                    self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }
                }
              }

              public struct AttributesValue: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("Attribute", type: .object(Attribute.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var attribute: Attribute? {
                  get {
                    return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueFields: AttributeValueFields {
                    get {
                      return AttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Attribute: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Attribute"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("DisplayName", type: .scalar(String.self)),
                      GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                      GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                      GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                      GraphQLField("ParentID", type: .scalar(Uint64.self)),
                      GraphQLField("GroupID", type: .scalar(Uint64.self)),
                      GraphQLField("Group", type: .object(Group.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                    self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var displayName: String? {
                    get {
                      return resultMap["DisplayName"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DisplayName")
                    }
                  }

                  public var values: [Value]? {
                    get {
                      return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var inputType: InputTypeAll {
                    get {
                      return resultMap["InputType"]! as! InputTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "InputType")
                    }
                  }

                  public var `required`: Bool {
                    get {
                      return resultMap["Required"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Required")
                    }
                  }

                  public var hasThumbnail: Bool? {
                    get {
                      return resultMap["HasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "HasThumbnail")
                    }
                  }

                  public var attributeType: AttributeTypeAll {
                    get {
                      return resultMap["AttributeType"]! as! AttributeTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeType")
                    }
                  }

                  public var parentId: Uint64? {
                    get {
                      return resultMap["ParentID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ParentID")
                    }
                  }

                  public var groupId: Uint64? {
                    get {
                      return resultMap["GroupID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "GroupID")
                    }
                  }

                  public var group: Group? {
                    get {
                      return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                      get {
                        return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Value: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeValue"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .scalar(Uint64.self)),
                        GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                        GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                      self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64? {
                      get {
                        return resultMap["ID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var value: String {
                      get {
                        return resultMap["Value"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Value")
                      }
                    }

                    public var attributeId: Uint64 {
                      get {
                        return resultMap["AttributeID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeID")
                      }
                    }

                    public var attributeHasThumbnail: Bool? {
                      get {
                        return resultMap["AttributeHasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var isVariationAttributeValue: Bool {
                      get {
                        return resultMap["IsVariationAttributeValue"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                        get {
                          return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }

                  public struct Group: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeGroup"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, sort: Uint64) {
                      self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeGroupFields: AttributeGroupFields {
                        get {
                          return AttributeGroupFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }
                }
              }

              public struct Badge: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Badge"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("Image", type: .nonNull(.object(Image.selections))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String? = nil, image: Image) {
                  self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var image: Image {
                  get {
                    return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
                  }
                  set {
                    resultMap.updateValue(newValue.resultMap, forKey: "Image")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var badgeFields: BadgeFields {
                    get {
                      return BadgeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct Note: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["StaticPage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Position", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Content", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, position: String, content: String) {
                  self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var position: String {
                  get {
                    return resultMap["Position"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Position")
                  }
                }

                public var content: String {
                  get {
                    return resultMap["Content"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Content")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var staticPageFields: StaticPageFields {
                    get {
                      return StaticPageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct DefaultVariant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Variant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Image: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["File"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                    GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                    GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                  self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var url: String {
                  get {
                    return resultMap["URL"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "URL")
                  }
                }

                public var idType: FileIDType {
                  get {
                    return resultMap["IDType"]! as! FileIDType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IDType")
                  }
                }

                public var category: FileCategoryAll {
                  get {
                    return resultMap["Category"]! as! FileCategoryAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Category")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var fileFields: FileFields {
                    get {
                      return FileFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct AttributeValueImage: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValueImage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Key", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(key: String, images: [Image]) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var key: String {
                  get {
                    return resultMap["Key"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Key")
                  }
                }

                public var images: [Image] {
                  get {
                    return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
                  }
                  set {
                    resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueImageFields: AttributeValueImageFields {
                    get {
                      return AttributeValueImageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct ReviewProvider: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewProvider"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
                    GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
                  self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var platform: ReviewProviderPlatformAll {
                  get {
                    return resultMap["Platform"]! as! ReviewProviderPlatformAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Platform")
                  }
                }

                public var type: ProductReviewTypeAll {
                  get {
                    return resultMap["Type"]! as! ProductReviewTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Type")
                  }
                }

                public var id: String {
                  get {
                    return resultMap["ID"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewProviderFields: ReviewProviderFields {
                    get {
                      return ReviewProviderFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct ReviewsSummary: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewsSummary"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(total: Uint64, stars: Double) {
                  self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var total: Uint64 {
                  get {
                    return resultMap["Total"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Total")
                  }
                }

                public var stars: Double {
                  get {
                    return resultMap["Stars"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Stars")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewsSummaryFields: ReviewsSummaryFields {
                    get {
                      return ReviewsSummaryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Info: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Cart"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Discount", type: .object(Discount.selections)),
              GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
              GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
              GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
              GraphQLField("ZipCode", type: .scalar(String.self)),
              GraphQLField("ClosedAt", type: .scalar(Time.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var payablePrice: Double {
            get {
              return resultMap["PayablePrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "PayablePrice")
            }
          }

          public var totalAmount: Double {
            get {
              return resultMap["TotalAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "TotalAmount")
            }
          }

          public var discountCodeAmount: Double {
            get {
              return resultMap["DiscountCodeAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
            }
          }

          public var hasDiscount: Bool {
            get {
              return resultMap["HasDiscount"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "HasDiscount")
            }
          }

          public var discount: Discount? {
            get {
              return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
            }
          }

          public var discounts: [Discount]? {
            get {
              return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
            }
          }

          public var deliveryDiscount: DeliveryDiscount? {
            get {
              return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
            }
          }

          public var status: CartStatusAll {
            get {
              return resultMap["Status"]! as! CartStatusAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Status")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var sourceClose: SourceAll? {
            get {
              return resultMap["SourceClose"] as? SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "SourceClose")
            }
          }

          public var zipCode: String? {
            get {
              return resultMap["ZipCode"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ZipCode")
            }
          }

          public var closedAt: Time? {
            get {
              return resultMap["ClosedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "ClosedAt")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartFields: CartFields {
              get {
                return CartFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct DeliveryDiscount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Error: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  final class RemoveAllItemsFromCartMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation removeAllItemsFromCart($cartHash: String) {
        RemoveAllItems(Request: {CartHash: $cartHash}) {
          __typename
          ...cartResponseFields
        }
      }
      """

    public let operationName: String = "removeAllItemsFromCart"

    public let operationIdentifier: String? = "4233c1e6393cdeab307e0a807261fcecaa32645a43a59ab808a026f4590f7bb7"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartResponseFields.fragmentDefinition)
      document.append("\n" + CartItemFields.fragmentDefinition)
      document.append("\n" + OrderVariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeValueAtrributeFields.fragmentDefinition)
      document.append("\n" + AttibuteValueAttributeAttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeGroupFields.fragmentDefinition)
      document.append("\n" + VariantPriceFields.fragmentDefinition)
      document.append("\n" + VariantPriceDiscountFeilds.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + ProductFields.fragmentDefinition)
      document.append("\n" + CategoryFields.fragmentDefinition)
      document.append("\n" + BadgeFields.fragmentDefinition)
      document.append("\n" + FileFields.fragmentDefinition)
      document.append("\n" + StaticPageFields.fragmentDefinition)
      document.append("\n" + VariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueImageFields.fragmentDefinition)
      document.append("\n" + ReviewProviderFields.fragmentDefinition)
      document.append("\n" + ReviewsSummaryFields.fragmentDefinition)
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      return document
    }

    public var cartHash: String?

    public init(cartHash: String? = nil) {
      self.cartHash = cartHash
    }

    public var variables: GraphQLMap? {
      return ["cartHash": cartHash]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("RemoveAllItems", arguments: ["Request": ["CartHash": GraphQLVariable("cartHash")]], type: .nonNull(.object(RemoveAllItem.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(removeAllItems: RemoveAllItem) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "RemoveAllItems": removeAllItems.resultMap])
      }

      public var removeAllItems: RemoveAllItem {
        get {
          return RemoveAllItem(unsafeResultMap: resultMap["RemoveAllItems"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "RemoveAllItems")
        }
      }

      public struct RemoveAllItem: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Items", type: .list(.nonNull(.object(Item.selections)))),
            GraphQLField("Info", type: .nonNull(.object(Info.selections))),
            GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(items: [Item]? = nil, info: Info, errors: [Error]? = nil) {
          self.init(unsafeResultMap: ["__typename": "CartResponse", "Items": items.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, "Info": info.resultMap, "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var items: [Item]? {
          get {
            return (resultMap["Items"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Item] in value.map { (value: ResultMap) -> Item in Item(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, forKey: "Items")
          }
        }

        public var info: Info {
          get {
            return Info(unsafeResultMap: resultMap["Info"]! as! ResultMap)
          }
          set {
            resultMap.updateValue(newValue.resultMap, forKey: "Info")
          }
        }

        public var errors: [Error]? {
          get {
            return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartResponseFields: CartResponseFields {
            get {
              return CartResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Item: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartItem"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
              GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
              GraphQLField("CartToken", type: .scalar(String.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var cartId: Uint64 {
            get {
              return resultMap["CartID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartID")
            }
          }

          public var variant: Variant {
            get {
              return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Variant")
            }
          }

          public var variantId: FID {
            get {
              return resultMap["VariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantID")
            }
          }

          public var variantPriceId: Uint64 {
            get {
              return resultMap["VariantPriceID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantPriceID")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var discountAmount: Double {
            get {
              return resultMap["DiscountAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountAmount")
            }
          }

          public var quantity: Int {
            get {
              return resultMap["Quantity"]! as! Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Quantity")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var isSubscription: Bool {
            get {
              return resultMap["IsSubscription"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsSubscription")
            }
          }

          public var orderShipments: [Time] {
            get {
              return resultMap["OrderShipments"]! as! [Time]
            }
            set {
              resultMap.updateValue(newValue, forKey: "OrderShipments")
            }
          }

          public var cartToken: String? {
            get {
              return resultMap["CartToken"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartToken")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartItemFields: CartItemFields {
              get {
                return CartItemFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Variant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Product", type: .object(Product.selections)),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var product: Product? {
              get {
                return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Product")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var orderVariantFields: OrderVariantFields {
                get {
                  return OrderVariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct Product: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Product"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Status", type: .nonNull(.scalar(String.self))),
                  GraphQLField("SingleShipping", type: .scalar(Bool.self)),
                  GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
                  GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Category", type: .nonNull(.object(Category.selections))),
                  GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
                  GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                  GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
                  GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
                  GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
                  GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
                  GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
                  GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                  GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
                  GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
                  GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
                  GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
                  GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
                self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: FID {
                get {
                  return resultMap["ID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var status: String {
                get {
                  return resultMap["Status"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Status")
                }
              }

              public var singleShipping: Bool? {
                get {
                  return resultMap["SingleShipping"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SingleShipping")
                }
              }

              public var type: TypeAll {
                get {
                  return resultMap["Type"]! as! TypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var categoryId: Uint64 {
                get {
                  return resultMap["CategoryID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CategoryID")
                }
              }

              public var category: Category {
                get {
                  return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
                }
                set {
                  resultMap.updateValue(newValue.resultMap, forKey: "Category")
                }
              }

              public var tags: [String] {
                get {
                  return resultMap["Tags"]! as! [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Tags")
                }
              }

              public var attributesValues: [AttributesValue]? {
                get {
                  return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                }
              }

              public var badge: [Badge]? {
                get {
                  return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
                }
              }

              public var noteIDs: [Uint64] {
                get {
                  return resultMap["NoteIDs"]! as! [Uint64]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "NoteIDs")
                }
              }

              public var notes: [Note] {
                get {
                  return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
                }
                set {
                  resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
                }
              }

              public var defaultVariantId: FID {
                get {
                  return resultMap["DefaultVariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DefaultVariantID")
                }
              }

              public var defaultVariant: DefaultVariant? {
                get {
                  return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
                }
              }

              public var variants: [Variant]? {
                get {
                  return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
                }
              }

              public var likes: Uint64 {
                get {
                  return resultMap["Likes"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Likes")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var images: [Image]? {
                get {
                  return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
                }
              }

              public var attributeValueImages: [AttributeValueImage]? {
                get {
                  return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
                }
              }

              public var reviewProvider: ReviewProvider? {
                get {
                  return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
                }
              }

              public var reviewsSummary: ReviewsSummary? {
                get {
                  return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
                }
              }

              public var productLink: String {
                get {
                  return resultMap["ProductLink"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ProductLink")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var productFields: ProductFields {
                  get {
                    return ProductFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Category: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Category"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("MainParent", type: .object(MainParent.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var mainParent: MainParent? {
                  get {
                    return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var categoryFields: CategoryFields {
                    get {
                      return CategoryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct MainParent: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Category"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, description: String) {
                    self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }
                }
              }

              public struct AttributesValue: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("Attribute", type: .object(Attribute.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var attribute: Attribute? {
                  get {
                    return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueFields: AttributeValueFields {
                    get {
                      return AttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Attribute: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Attribute"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("DisplayName", type: .scalar(String.self)),
                      GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                      GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                      GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                      GraphQLField("ParentID", type: .scalar(Uint64.self)),
                      GraphQLField("GroupID", type: .scalar(Uint64.self)),
                      GraphQLField("Group", type: .object(Group.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                    self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var displayName: String? {
                    get {
                      return resultMap["DisplayName"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DisplayName")
                    }
                  }

                  public var values: [Value]? {
                    get {
                      return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var inputType: InputTypeAll {
                    get {
                      return resultMap["InputType"]! as! InputTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "InputType")
                    }
                  }

                  public var `required`: Bool {
                    get {
                      return resultMap["Required"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Required")
                    }
                  }

                  public var hasThumbnail: Bool? {
                    get {
                      return resultMap["HasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "HasThumbnail")
                    }
                  }

                  public var attributeType: AttributeTypeAll {
                    get {
                      return resultMap["AttributeType"]! as! AttributeTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeType")
                    }
                  }

                  public var parentId: Uint64? {
                    get {
                      return resultMap["ParentID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ParentID")
                    }
                  }

                  public var groupId: Uint64? {
                    get {
                      return resultMap["GroupID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "GroupID")
                    }
                  }

                  public var group: Group? {
                    get {
                      return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                      get {
                        return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Value: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeValue"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .scalar(Uint64.self)),
                        GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                        GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                      self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64? {
                      get {
                        return resultMap["ID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var value: String {
                      get {
                        return resultMap["Value"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Value")
                      }
                    }

                    public var attributeId: Uint64 {
                      get {
                        return resultMap["AttributeID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeID")
                      }
                    }

                    public var attributeHasThumbnail: Bool? {
                      get {
                        return resultMap["AttributeHasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var isVariationAttributeValue: Bool {
                      get {
                        return resultMap["IsVariationAttributeValue"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                        get {
                          return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }

                  public struct Group: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeGroup"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, sort: Uint64) {
                      self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeGroupFields: AttributeGroupFields {
                        get {
                          return AttributeGroupFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }
                }
              }

              public struct Badge: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Badge"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("Image", type: .nonNull(.object(Image.selections))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String? = nil, image: Image) {
                  self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var image: Image {
                  get {
                    return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
                  }
                  set {
                    resultMap.updateValue(newValue.resultMap, forKey: "Image")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var badgeFields: BadgeFields {
                    get {
                      return BadgeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct Note: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["StaticPage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Position", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Content", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, position: String, content: String) {
                  self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var position: String {
                  get {
                    return resultMap["Position"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Position")
                  }
                }

                public var content: String {
                  get {
                    return resultMap["Content"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Content")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var staticPageFields: StaticPageFields {
                    get {
                      return StaticPageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct DefaultVariant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Variant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Image: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["File"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                    GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                    GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                  self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var url: String {
                  get {
                    return resultMap["URL"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "URL")
                  }
                }

                public var idType: FileIDType {
                  get {
                    return resultMap["IDType"]! as! FileIDType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IDType")
                  }
                }

                public var category: FileCategoryAll {
                  get {
                    return resultMap["Category"]! as! FileCategoryAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Category")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var fileFields: FileFields {
                    get {
                      return FileFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct AttributeValueImage: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValueImage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Key", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(key: String, images: [Image]) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var key: String {
                  get {
                    return resultMap["Key"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Key")
                  }
                }

                public var images: [Image] {
                  get {
                    return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
                  }
                  set {
                    resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueImageFields: AttributeValueImageFields {
                    get {
                      return AttributeValueImageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct ReviewProvider: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewProvider"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
                    GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
                  self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var platform: ReviewProviderPlatformAll {
                  get {
                    return resultMap["Platform"]! as! ReviewProviderPlatformAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Platform")
                  }
                }

                public var type: ProductReviewTypeAll {
                  get {
                    return resultMap["Type"]! as! ProductReviewTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Type")
                  }
                }

                public var id: String {
                  get {
                    return resultMap["ID"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewProviderFields: ReviewProviderFields {
                    get {
                      return ReviewProviderFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct ReviewsSummary: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewsSummary"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(total: Uint64, stars: Double) {
                  self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var total: Uint64 {
                  get {
                    return resultMap["Total"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Total")
                  }
                }

                public var stars: Double {
                  get {
                    return resultMap["Stars"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Stars")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewsSummaryFields: ReviewsSummaryFields {
                    get {
                      return ReviewsSummaryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Info: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Cart"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Discount", type: .object(Discount.selections)),
              GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
              GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
              GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
              GraphQLField("ZipCode", type: .scalar(String.self)),
              GraphQLField("ClosedAt", type: .scalar(Time.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var payablePrice: Double {
            get {
              return resultMap["PayablePrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "PayablePrice")
            }
          }

          public var totalAmount: Double {
            get {
              return resultMap["TotalAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "TotalAmount")
            }
          }

          public var discountCodeAmount: Double {
            get {
              return resultMap["DiscountCodeAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
            }
          }

          public var hasDiscount: Bool {
            get {
              return resultMap["HasDiscount"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "HasDiscount")
            }
          }

          public var discount: Discount? {
            get {
              return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
            }
          }

          public var discounts: [Discount]? {
            get {
              return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
            }
          }

          public var deliveryDiscount: DeliveryDiscount? {
            get {
              return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
            }
          }

          public var status: CartStatusAll {
            get {
              return resultMap["Status"]! as! CartStatusAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Status")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var sourceClose: SourceAll? {
            get {
              return resultMap["SourceClose"] as? SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "SourceClose")
            }
          }

          public var zipCode: String? {
            get {
              return resultMap["ZipCode"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ZipCode")
            }
          }

          public var closedAt: Time? {
            get {
              return resultMap["ClosedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "ClosedAt")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartFields: CartFields {
              get {
                return CartFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct DeliveryDiscount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Error: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  final class ChangeCartItemQuantityMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation changeCartItemQuantity($id: Uint64!, $count: Int!, $cartHash: String) {
        ChangeItemQuantity(Request: {ID: $id, Count: $count, CartHash: $cartHash}) {
          __typename
          ...cartResponseFields
        }
      }
      """

    public let operationName: String = "changeCartItemQuantity"

    public let operationIdentifier: String? = "2c3351bb7f19f0ae0b0dc100c07a0586b2cfbf7485dfab40885517e8afd8c31d"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartResponseFields.fragmentDefinition)
      document.append("\n" + CartItemFields.fragmentDefinition)
      document.append("\n" + OrderVariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeValueAtrributeFields.fragmentDefinition)
      document.append("\n" + AttibuteValueAttributeAttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeGroupFields.fragmentDefinition)
      document.append("\n" + VariantPriceFields.fragmentDefinition)
      document.append("\n" + VariantPriceDiscountFeilds.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + ProductFields.fragmentDefinition)
      document.append("\n" + CategoryFields.fragmentDefinition)
      document.append("\n" + BadgeFields.fragmentDefinition)
      document.append("\n" + FileFields.fragmentDefinition)
      document.append("\n" + StaticPageFields.fragmentDefinition)
      document.append("\n" + VariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueImageFields.fragmentDefinition)
      document.append("\n" + ReviewProviderFields.fragmentDefinition)
      document.append("\n" + ReviewsSummaryFields.fragmentDefinition)
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      return document
    }

    public var id: Uint64
    public var count: Int
    public var cartHash: String?

    public init(id: Uint64, count: Int, cartHash: String? = nil) {
      self.id = id
      self.count = count
      self.cartHash = cartHash
    }

    public var variables: GraphQLMap? {
      return ["id": id, "count": count, "cartHash": cartHash]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("ChangeItemQuantity", arguments: ["Request": ["ID": GraphQLVariable("id"), "Count": GraphQLVariable("count"), "CartHash": GraphQLVariable("cartHash")]], type: .nonNull(.object(ChangeItemQuantity.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(changeItemQuantity: ChangeItemQuantity) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "ChangeItemQuantity": changeItemQuantity.resultMap])
      }

      public var changeItemQuantity: ChangeItemQuantity {
        get {
          return ChangeItemQuantity(unsafeResultMap: resultMap["ChangeItemQuantity"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "ChangeItemQuantity")
        }
      }

      public struct ChangeItemQuantity: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Items", type: .list(.nonNull(.object(Item.selections)))),
            GraphQLField("Info", type: .nonNull(.object(Info.selections))),
            GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(items: [Item]? = nil, info: Info, errors: [Error]? = nil) {
          self.init(unsafeResultMap: ["__typename": "CartResponse", "Items": items.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, "Info": info.resultMap, "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var items: [Item]? {
          get {
            return (resultMap["Items"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Item] in value.map { (value: ResultMap) -> Item in Item(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, forKey: "Items")
          }
        }

        public var info: Info {
          get {
            return Info(unsafeResultMap: resultMap["Info"]! as! ResultMap)
          }
          set {
            resultMap.updateValue(newValue.resultMap, forKey: "Info")
          }
        }

        public var errors: [Error]? {
          get {
            return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartResponseFields: CartResponseFields {
            get {
              return CartResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Item: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartItem"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
              GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
              GraphQLField("CartToken", type: .scalar(String.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var cartId: Uint64 {
            get {
              return resultMap["CartID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartID")
            }
          }

          public var variant: Variant {
            get {
              return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Variant")
            }
          }

          public var variantId: FID {
            get {
              return resultMap["VariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantID")
            }
          }

          public var variantPriceId: Uint64 {
            get {
              return resultMap["VariantPriceID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantPriceID")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var discountAmount: Double {
            get {
              return resultMap["DiscountAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountAmount")
            }
          }

          public var quantity: Int {
            get {
              return resultMap["Quantity"]! as! Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Quantity")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var isSubscription: Bool {
            get {
              return resultMap["IsSubscription"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsSubscription")
            }
          }

          public var orderShipments: [Time] {
            get {
              return resultMap["OrderShipments"]! as! [Time]
            }
            set {
              resultMap.updateValue(newValue, forKey: "OrderShipments")
            }
          }

          public var cartToken: String? {
            get {
              return resultMap["CartToken"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartToken")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartItemFields: CartItemFields {
              get {
                return CartItemFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Variant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Product", type: .object(Product.selections)),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var product: Product? {
              get {
                return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Product")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var orderVariantFields: OrderVariantFields {
                get {
                  return OrderVariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct Product: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Product"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Status", type: .nonNull(.scalar(String.self))),
                  GraphQLField("SingleShipping", type: .scalar(Bool.self)),
                  GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
                  GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Category", type: .nonNull(.object(Category.selections))),
                  GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
                  GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                  GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
                  GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
                  GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
                  GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
                  GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
                  GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                  GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
                  GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
                  GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
                  GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
                  GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
                self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: FID {
                get {
                  return resultMap["ID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var status: String {
                get {
                  return resultMap["Status"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Status")
                }
              }

              public var singleShipping: Bool? {
                get {
                  return resultMap["SingleShipping"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SingleShipping")
                }
              }

              public var type: TypeAll {
                get {
                  return resultMap["Type"]! as! TypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var categoryId: Uint64 {
                get {
                  return resultMap["CategoryID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CategoryID")
                }
              }

              public var category: Category {
                get {
                  return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
                }
                set {
                  resultMap.updateValue(newValue.resultMap, forKey: "Category")
                }
              }

              public var tags: [String] {
                get {
                  return resultMap["Tags"]! as! [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Tags")
                }
              }

              public var attributesValues: [AttributesValue]? {
                get {
                  return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                }
              }

              public var badge: [Badge]? {
                get {
                  return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
                }
              }

              public var noteIDs: [Uint64] {
                get {
                  return resultMap["NoteIDs"]! as! [Uint64]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "NoteIDs")
                }
              }

              public var notes: [Note] {
                get {
                  return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
                }
                set {
                  resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
                }
              }

              public var defaultVariantId: FID {
                get {
                  return resultMap["DefaultVariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DefaultVariantID")
                }
              }

              public var defaultVariant: DefaultVariant? {
                get {
                  return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
                }
              }

              public var variants: [Variant]? {
                get {
                  return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
                }
              }

              public var likes: Uint64 {
                get {
                  return resultMap["Likes"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Likes")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var images: [Image]? {
                get {
                  return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
                }
              }

              public var attributeValueImages: [AttributeValueImage]? {
                get {
                  return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
                }
              }

              public var reviewProvider: ReviewProvider? {
                get {
                  return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
                }
              }

              public var reviewsSummary: ReviewsSummary? {
                get {
                  return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
                }
              }

              public var productLink: String {
                get {
                  return resultMap["ProductLink"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ProductLink")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var productFields: ProductFields {
                  get {
                    return ProductFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Category: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Category"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("MainParent", type: .object(MainParent.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var mainParent: MainParent? {
                  get {
                    return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var categoryFields: CategoryFields {
                    get {
                      return CategoryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct MainParent: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Category"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, description: String) {
                    self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }
                }
              }

              public struct AttributesValue: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("Attribute", type: .object(Attribute.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var attribute: Attribute? {
                  get {
                    return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueFields: AttributeValueFields {
                    get {
                      return AttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Attribute: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Attribute"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("DisplayName", type: .scalar(String.self)),
                      GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                      GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                      GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                      GraphQLField("ParentID", type: .scalar(Uint64.self)),
                      GraphQLField("GroupID", type: .scalar(Uint64.self)),
                      GraphQLField("Group", type: .object(Group.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                    self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var displayName: String? {
                    get {
                      return resultMap["DisplayName"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DisplayName")
                    }
                  }

                  public var values: [Value]? {
                    get {
                      return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var inputType: InputTypeAll {
                    get {
                      return resultMap["InputType"]! as! InputTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "InputType")
                    }
                  }

                  public var `required`: Bool {
                    get {
                      return resultMap["Required"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Required")
                    }
                  }

                  public var hasThumbnail: Bool? {
                    get {
                      return resultMap["HasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "HasThumbnail")
                    }
                  }

                  public var attributeType: AttributeTypeAll {
                    get {
                      return resultMap["AttributeType"]! as! AttributeTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeType")
                    }
                  }

                  public var parentId: Uint64? {
                    get {
                      return resultMap["ParentID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ParentID")
                    }
                  }

                  public var groupId: Uint64? {
                    get {
                      return resultMap["GroupID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "GroupID")
                    }
                  }

                  public var group: Group? {
                    get {
                      return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                      get {
                        return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Value: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeValue"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .scalar(Uint64.self)),
                        GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                        GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                      self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64? {
                      get {
                        return resultMap["ID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var value: String {
                      get {
                        return resultMap["Value"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Value")
                      }
                    }

                    public var attributeId: Uint64 {
                      get {
                        return resultMap["AttributeID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeID")
                      }
                    }

                    public var attributeHasThumbnail: Bool? {
                      get {
                        return resultMap["AttributeHasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var isVariationAttributeValue: Bool {
                      get {
                        return resultMap["IsVariationAttributeValue"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                        get {
                          return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }

                  public struct Group: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeGroup"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, sort: Uint64) {
                      self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeGroupFields: AttributeGroupFields {
                        get {
                          return AttributeGroupFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }
                }
              }

              public struct Badge: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Badge"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("Image", type: .nonNull(.object(Image.selections))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String? = nil, image: Image) {
                  self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var image: Image {
                  get {
                    return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
                  }
                  set {
                    resultMap.updateValue(newValue.resultMap, forKey: "Image")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var badgeFields: BadgeFields {
                    get {
                      return BadgeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct Note: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["StaticPage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Position", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Content", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, position: String, content: String) {
                  self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var position: String {
                  get {
                    return resultMap["Position"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Position")
                  }
                }

                public var content: String {
                  get {
                    return resultMap["Content"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Content")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var staticPageFields: StaticPageFields {
                    get {
                      return StaticPageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct DefaultVariant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Variant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Image: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["File"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                    GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                    GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                  self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var url: String {
                  get {
                    return resultMap["URL"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "URL")
                  }
                }

                public var idType: FileIDType {
                  get {
                    return resultMap["IDType"]! as! FileIDType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IDType")
                  }
                }

                public var category: FileCategoryAll {
                  get {
                    return resultMap["Category"]! as! FileCategoryAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Category")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var fileFields: FileFields {
                    get {
                      return FileFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct AttributeValueImage: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValueImage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Key", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(key: String, images: [Image]) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var key: String {
                  get {
                    return resultMap["Key"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Key")
                  }
                }

                public var images: [Image] {
                  get {
                    return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
                  }
                  set {
                    resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueImageFields: AttributeValueImageFields {
                    get {
                      return AttributeValueImageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct ReviewProvider: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewProvider"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
                    GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
                  self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var platform: ReviewProviderPlatformAll {
                  get {
                    return resultMap["Platform"]! as! ReviewProviderPlatformAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Platform")
                  }
                }

                public var type: ProductReviewTypeAll {
                  get {
                    return resultMap["Type"]! as! ProductReviewTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Type")
                  }
                }

                public var id: String {
                  get {
                    return resultMap["ID"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewProviderFields: ReviewProviderFields {
                    get {
                      return ReviewProviderFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct ReviewsSummary: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewsSummary"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(total: Uint64, stars: Double) {
                  self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var total: Uint64 {
                  get {
                    return resultMap["Total"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Total")
                  }
                }

                public var stars: Double {
                  get {
                    return resultMap["Stars"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Stars")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewsSummaryFields: ReviewsSummaryFields {
                    get {
                      return ReviewsSummaryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Info: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Cart"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Discount", type: .object(Discount.selections)),
              GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
              GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
              GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
              GraphQLField("ZipCode", type: .scalar(String.self)),
              GraphQLField("ClosedAt", type: .scalar(Time.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var payablePrice: Double {
            get {
              return resultMap["PayablePrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "PayablePrice")
            }
          }

          public var totalAmount: Double {
            get {
              return resultMap["TotalAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "TotalAmount")
            }
          }

          public var discountCodeAmount: Double {
            get {
              return resultMap["DiscountCodeAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
            }
          }

          public var hasDiscount: Bool {
            get {
              return resultMap["HasDiscount"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "HasDiscount")
            }
          }

          public var discount: Discount? {
            get {
              return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
            }
          }

          public var discounts: [Discount]? {
            get {
              return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
            }
          }

          public var deliveryDiscount: DeliveryDiscount? {
            get {
              return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
            }
          }

          public var status: CartStatusAll {
            get {
              return resultMap["Status"]! as! CartStatusAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Status")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var sourceClose: SourceAll? {
            get {
              return resultMap["SourceClose"] as? SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "SourceClose")
            }
          }

          public var zipCode: String? {
            get {
              return resultMap["ZipCode"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ZipCode")
            }
          }

          public var closedAt: Time? {
            get {
              return resultMap["ClosedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "ClosedAt")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartFields: CartFields {
              get {
                return CartFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct DeliveryDiscount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Error: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  final class ApplyDiscountToCartMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation applyDiscountToCart($code: String!) {
        ApplyDiscountCode(Request: {Code: $code}) {
          __typename
          ...cartFields
        }
      }
      """

    public let operationName: String = "applyDiscountToCart"

    public let operationIdentifier: String? = "a95ff1428c95cfc26800d01a28cf092f4eaf8d6cc3036154a03a0a4fff5af839"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      return document
    }

    public var code: String

    public init(code: String) {
      self.code = code
    }

    public var variables: GraphQLMap? {
      return ["code": code]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("ApplyDiscountCode", arguments: ["Request": ["Code": GraphQLVariable("code")]], type: .nonNull(.object(ApplyDiscountCode.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(applyDiscountCode: ApplyDiscountCode) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "ApplyDiscountCode": applyDiscountCode.resultMap])
      }

      public var applyDiscountCode: ApplyDiscountCode {
        get {
          return ApplyDiscountCode(unsafeResultMap: resultMap["ApplyDiscountCode"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "ApplyDiscountCode")
        }
      }

      public struct ApplyDiscountCode: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["Cart"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
            GraphQLField("Discount", type: .object(Discount.selections)),
            GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
            GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
            GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
            GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
            GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
            GraphQLField("ZipCode", type: .scalar(String.self)),
            GraphQLField("ClosedAt", type: .scalar(Time.self)),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
          self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var payablePrice: Double {
          get {
            return resultMap["PayablePrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "PayablePrice")
          }
        }

        public var totalAmount: Double {
          get {
            return resultMap["TotalAmount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "TotalAmount")
          }
        }

        public var discountCodeAmount: Double {
          get {
            return resultMap["DiscountCodeAmount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
          }
        }

        public var hasDiscount: Bool {
          get {
            return resultMap["HasDiscount"]! as! Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "HasDiscount")
          }
        }

        public var discount: Discount? {
          get {
            return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
          }
        }

        public var discounts: [Discount]? {
          get {
            return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
          }
        }

        public var deliveryDiscount: DeliveryDiscount? {
          get {
            return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
          }
        }

        public var status: CartStatusAll {
          get {
            return resultMap["Status"]! as! CartStatusAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Status")
          }
        }

        public var source: SourceAll {
          get {
            return resultMap["Source"]! as! SourceAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Source")
          }
        }

        public var sourceClose: SourceAll? {
          get {
            return resultMap["SourceClose"] as? SourceAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "SourceClose")
          }
        }

        public var zipCode: String? {
          get {
            return resultMap["ZipCode"] as? String
          }
          set {
            resultMap.updateValue(newValue, forKey: "ZipCode")
          }
        }

        public var closedAt: Time? {
          get {
            return resultMap["ClosedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "ClosedAt")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var createdAt: Time {
          get {
            return resultMap["CreatedAt"]! as! Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "CreatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartFields: CartFields {
            get {
              return CartFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Discount: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Discount"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .object(Description.selections)),
              GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
              GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("PublicCode", type: .object(PublicCode.selections)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: Description? {
            get {
              return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Description")
            }
          }

          public var type: DiscountTypeAll {
            get {
              return resultMap["Type"]! as! DiscountTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var amount: Double {
            get {
              return resultMap["Amount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Amount")
            }
          }

          public var publicCode: PublicCode? {
            get {
              return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountFields: DiscountFields {
              get {
                return DiscountFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Description: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountDescription"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(template: String, parameters: [String]? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var template: String {
              get {
                return resultMap["Template"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Template")
              }
            }

            public var parameters: [String]? {
              get {
                return resultMap["Parameters"] as? [String]
              }
              set {
                resultMap.updateValue(newValue, forKey: "Parameters")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountDescriptionFields: DiscountDescriptionFields {
                get {
                  return DiscountDescriptionFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct PublicCode: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountCode"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, code: String, updatedAt: Time? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var code: String {
              get {
                return resultMap["Code"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Code")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountCodeFields: DiscountCodeFields {
                get {
                  return DiscountCodeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }

        public struct Discount: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Discount"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .object(Description.selections)),
              GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
              GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("PublicCode", type: .object(PublicCode.selections)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: Description? {
            get {
              return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Description")
            }
          }

          public var type: DiscountTypeAll {
            get {
              return resultMap["Type"]! as! DiscountTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var amount: Double {
            get {
              return resultMap["Amount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Amount")
            }
          }

          public var publicCode: PublicCode? {
            get {
              return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountFields: DiscountFields {
              get {
                return DiscountFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Description: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountDescription"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(template: String, parameters: [String]? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var template: String {
              get {
                return resultMap["Template"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Template")
              }
            }

            public var parameters: [String]? {
              get {
                return resultMap["Parameters"] as? [String]
              }
              set {
                resultMap.updateValue(newValue, forKey: "Parameters")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountDescriptionFields: DiscountDescriptionFields {
                get {
                  return DiscountDescriptionFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct PublicCode: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountCode"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, code: String, updatedAt: Time? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var code: String {
              get {
                return resultMap["Code"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Code")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountCodeFields: DiscountCodeFields {
                get {
                  return DiscountCodeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }

        public struct DeliveryDiscount: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Discount"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .object(Description.selections)),
              GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
              GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("PublicCode", type: .object(PublicCode.selections)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: Description? {
            get {
              return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Description")
            }
          }

          public var type: DiscountTypeAll {
            get {
              return resultMap["Type"]! as! DiscountTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var amount: Double {
            get {
              return resultMap["Amount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Amount")
            }
          }

          public var publicCode: PublicCode? {
            get {
              return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountFields: DiscountFields {
              get {
                return DiscountFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Description: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountDescription"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(template: String, parameters: [String]? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var template: String {
              get {
                return resultMap["Template"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Template")
              }
            }

            public var parameters: [String]? {
              get {
                return resultMap["Parameters"] as? [String]
              }
              set {
                resultMap.updateValue(newValue, forKey: "Parameters")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountDescriptionFields: DiscountDescriptionFields {
                get {
                  return DiscountDescriptionFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct PublicCode: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountCode"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, code: String, updatedAt: Time? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var code: String {
              get {
                return resultMap["Code"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Code")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountCodeFields: DiscountCodeFields {
                get {
                  return DiscountCodeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }
      }
    }
  }

  final class RemoveDiscountFromCartMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation removeDiscountFromCart {
        RemoveDiscountCode {
          __typename
          ...cartFields
        }
      }
      """

    public let operationName: String = "removeDiscountFromCart"

    public let operationIdentifier: String? = "9412486d2b1168f9240a2f185cf18c98483df1258e6307e3c9baf68e9520d0d0"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      return document
    }

    public init() {
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("RemoveDiscountCode", type: .nonNull(.object(RemoveDiscountCode.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(removeDiscountCode: RemoveDiscountCode) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "RemoveDiscountCode": removeDiscountCode.resultMap])
      }

      public var removeDiscountCode: RemoveDiscountCode {
        get {
          return RemoveDiscountCode(unsafeResultMap: resultMap["RemoveDiscountCode"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "RemoveDiscountCode")
        }
      }

      public struct RemoveDiscountCode: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["Cart"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
            GraphQLField("Discount", type: .object(Discount.selections)),
            GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
            GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
            GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
            GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
            GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
            GraphQLField("ZipCode", type: .scalar(String.self)),
            GraphQLField("ClosedAt", type: .scalar(Time.self)),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
          self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var payablePrice: Double {
          get {
            return resultMap["PayablePrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "PayablePrice")
          }
        }

        public var totalAmount: Double {
          get {
            return resultMap["TotalAmount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "TotalAmount")
          }
        }

        public var discountCodeAmount: Double {
          get {
            return resultMap["DiscountCodeAmount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
          }
        }

        public var hasDiscount: Bool {
          get {
            return resultMap["HasDiscount"]! as! Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "HasDiscount")
          }
        }

        public var discount: Discount? {
          get {
            return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
          }
        }

        public var discounts: [Discount]? {
          get {
            return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
          }
        }

        public var deliveryDiscount: DeliveryDiscount? {
          get {
            return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
          }
        }

        public var status: CartStatusAll {
          get {
            return resultMap["Status"]! as! CartStatusAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Status")
          }
        }

        public var source: SourceAll {
          get {
            return resultMap["Source"]! as! SourceAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Source")
          }
        }

        public var sourceClose: SourceAll? {
          get {
            return resultMap["SourceClose"] as? SourceAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "SourceClose")
          }
        }

        public var zipCode: String? {
          get {
            return resultMap["ZipCode"] as? String
          }
          set {
            resultMap.updateValue(newValue, forKey: "ZipCode")
          }
        }

        public var closedAt: Time? {
          get {
            return resultMap["ClosedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "ClosedAt")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var createdAt: Time {
          get {
            return resultMap["CreatedAt"]! as! Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "CreatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartFields: CartFields {
            get {
              return CartFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Discount: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Discount"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .object(Description.selections)),
              GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
              GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("PublicCode", type: .object(PublicCode.selections)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: Description? {
            get {
              return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Description")
            }
          }

          public var type: DiscountTypeAll {
            get {
              return resultMap["Type"]! as! DiscountTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var amount: Double {
            get {
              return resultMap["Amount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Amount")
            }
          }

          public var publicCode: PublicCode? {
            get {
              return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountFields: DiscountFields {
              get {
                return DiscountFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Description: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountDescription"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(template: String, parameters: [String]? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var template: String {
              get {
                return resultMap["Template"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Template")
              }
            }

            public var parameters: [String]? {
              get {
                return resultMap["Parameters"] as? [String]
              }
              set {
                resultMap.updateValue(newValue, forKey: "Parameters")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountDescriptionFields: DiscountDescriptionFields {
                get {
                  return DiscountDescriptionFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct PublicCode: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountCode"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, code: String, updatedAt: Time? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var code: String {
              get {
                return resultMap["Code"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Code")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountCodeFields: DiscountCodeFields {
                get {
                  return DiscountCodeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }

        public struct Discount: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Discount"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .object(Description.selections)),
              GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
              GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("PublicCode", type: .object(PublicCode.selections)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: Description? {
            get {
              return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Description")
            }
          }

          public var type: DiscountTypeAll {
            get {
              return resultMap["Type"]! as! DiscountTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var amount: Double {
            get {
              return resultMap["Amount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Amount")
            }
          }

          public var publicCode: PublicCode? {
            get {
              return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountFields: DiscountFields {
              get {
                return DiscountFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Description: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountDescription"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(template: String, parameters: [String]? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var template: String {
              get {
                return resultMap["Template"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Template")
              }
            }

            public var parameters: [String]? {
              get {
                return resultMap["Parameters"] as? [String]
              }
              set {
                resultMap.updateValue(newValue, forKey: "Parameters")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountDescriptionFields: DiscountDescriptionFields {
                get {
                  return DiscountDescriptionFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct PublicCode: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountCode"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, code: String, updatedAt: Time? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var code: String {
              get {
                return resultMap["Code"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Code")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountCodeFields: DiscountCodeFields {
                get {
                  return DiscountCodeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }

        public struct DeliveryDiscount: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Discount"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .object(Description.selections)),
              GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
              GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("PublicCode", type: .object(PublicCode.selections)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: Description? {
            get {
              return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Description")
            }
          }

          public var type: DiscountTypeAll {
            get {
              return resultMap["Type"]! as! DiscountTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var amount: Double {
            get {
              return resultMap["Amount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Amount")
            }
          }

          public var publicCode: PublicCode? {
            get {
              return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountFields: DiscountFields {
              get {
                return DiscountFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Description: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountDescription"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(template: String, parameters: [String]? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var template: String {
              get {
                return resultMap["Template"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Template")
              }
            }

            public var parameters: [String]? {
              get {
                return resultMap["Parameters"] as? [String]
              }
              set {
                resultMap.updateValue(newValue, forKey: "Parameters")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountDescriptionFields: DiscountDescriptionFields {
                get {
                  return DiscountDescriptionFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct PublicCode: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountCode"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, code: String, updatedAt: Time? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var code: String {
              get {
                return resultMap["Code"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Code")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountCodeFields: DiscountCodeFields {
                get {
                  return DiscountCodeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }
      }
    }
  }

  final class GetMultiDeliveryCartBillingMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation GetMultiDeliveryCartBilling($useVoucher: Boolean!, $deliveryConfig: [DeliveryConfig!]!) {
        CalculateCartBillingMultiDelivery(
          Request: {UseVoucher: $useVoucher, DeliveryConfig: $deliveryConfig}
        ) {
          __typename
          ...CartBillingFields
        }
      }
      """

    public let operationName: String = "GetMultiDeliveryCartBilling"

    public let operationIdentifier: String? = "0a6d9734315865f422b50006c18e1275e85855e4f76ff18c0011bfdf24cf899d"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartBillingFields.fragmentDefinition)
      return document
    }

    public var useVoucher: Bool
    public var deliveryConfig: [DeliveryConfig]

    public init(useVoucher: Bool, deliveryConfig: [DeliveryConfig]) {
      self.useVoucher = useVoucher
      self.deliveryConfig = deliveryConfig
    }

    public var variables: GraphQLMap? {
      return ["useVoucher": useVoucher, "deliveryConfig": deliveryConfig]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("CalculateCartBillingMultiDelivery", arguments: ["Request": ["UseVoucher": GraphQLVariable("useVoucher"), "DeliveryConfig": GraphQLVariable("deliveryConfig")]], type: .nonNull(.object(CalculateCartBillingMultiDelivery.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(calculateCartBillingMultiDelivery: CalculateCartBillingMultiDelivery) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "CalculateCartBillingMultiDelivery": calculateCartBillingMultiDelivery.resultMap])
      }

      public var calculateCartBillingMultiDelivery: CalculateCartBillingMultiDelivery {
        get {
          return CalculateCartBillingMultiDelivery(unsafeResultMap: resultMap["CalculateCartBillingMultiDelivery"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "CalculateCartBillingMultiDelivery")
        }
      }

      public struct CalculateCartBillingMultiDelivery: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartBillingDetail"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("VoucherAmount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("UsedVoucher", type: .nonNull(.scalar(Double.self))),
            GraphQLField("ShippingCost", type: .nonNull(.scalar(Double.self))),
            GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(totalAmount: Double, payablePrice: Double, discountCodeAmount: Double, voucherAmount: Double, usedVoucher: Double, shippingCost: Double, hasDiscount: Bool) {
          self.init(unsafeResultMap: ["__typename": "CartBillingDetail", "TotalAmount": totalAmount, "PayablePrice": payablePrice, "DiscountCodeAmount": discountCodeAmount, "VoucherAmount": voucherAmount, "UsedVoucher": usedVoucher, "ShippingCost": shippingCost, "HasDiscount": hasDiscount])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var totalAmount: Double {
          get {
            return resultMap["TotalAmount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "TotalAmount")
          }
        }

        public var payablePrice: Double {
          get {
            return resultMap["PayablePrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "PayablePrice")
          }
        }

        public var discountCodeAmount: Double {
          get {
            return resultMap["DiscountCodeAmount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
          }
        }

        public var voucherAmount: Double {
          get {
            return resultMap["VoucherAmount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "VoucherAmount")
          }
        }

        public var usedVoucher: Double {
          get {
            return resultMap["UsedVoucher"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "UsedVoucher")
          }
        }

        public var shippingCost: Double {
          get {
            return resultMap["ShippingCost"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "ShippingCost")
          }
        }

        public var hasDiscount: Bool {
          get {
            return resultMap["HasDiscount"]! as! Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "HasDiscount")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartBillingFields: CartBillingFields {
            get {
              return CartBillingFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }
    }
  }

  final class SetCartPostCodeMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation SetCartPostCode($zipCode: String!) {
        CartSetZipCode(Request: {ZipCode: $zipCode, Source: ios}) {
          __typename
          ...cartResponseFields
        }
      }
      """

    public let operationName: String = "SetCartPostCode"

    public let operationIdentifier: String? = "9d23181fedc196f18a3772d0a9f2ee33e20b8aab5a555637b4e3a50602d06a7b"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartResponseFields.fragmentDefinition)
      document.append("\n" + CartItemFields.fragmentDefinition)
      document.append("\n" + OrderVariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeValueAtrributeFields.fragmentDefinition)
      document.append("\n" + AttibuteValueAttributeAttributeValueFields.fragmentDefinition)
      document.append("\n" + AttributeGroupFields.fragmentDefinition)
      document.append("\n" + VariantPriceFields.fragmentDefinition)
      document.append("\n" + VariantPriceDiscountFeilds.fragmentDefinition)
      document.append("\n" + DiscountDescriptionFields.fragmentDefinition)
      document.append("\n" + ProductFields.fragmentDefinition)
      document.append("\n" + CategoryFields.fragmentDefinition)
      document.append("\n" + BadgeFields.fragmentDefinition)
      document.append("\n" + FileFields.fragmentDefinition)
      document.append("\n" + StaticPageFields.fragmentDefinition)
      document.append("\n" + VariantFields.fragmentDefinition)
      document.append("\n" + AttributeValueImageFields.fragmentDefinition)
      document.append("\n" + ReviewProviderFields.fragmentDefinition)
      document.append("\n" + ReviewsSummaryFields.fragmentDefinition)
      document.append("\n" + CartFields.fragmentDefinition)
      document.append("\n" + DiscountFields.fragmentDefinition)
      document.append("\n" + DiscountCodeFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      return document
    }

    public var zipCode: String

    public init(zipCode: String) {
      self.zipCode = zipCode
    }

    public var variables: GraphQLMap? {
      return ["zipCode": zipCode]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("CartSetZipCode", arguments: ["Request": ["ZipCode": GraphQLVariable("zipCode"), "Source": "ios"]], type: .nonNull(.object(CartSetZipCode.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(cartSetZipCode: CartSetZipCode) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "CartSetZipCode": cartSetZipCode.resultMap])
      }

      public var cartSetZipCode: CartSetZipCode {
        get {
          return CartSetZipCode(unsafeResultMap: resultMap["CartSetZipCode"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "CartSetZipCode")
        }
      }

      public struct CartSetZipCode: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Items", type: .list(.nonNull(.object(Item.selections)))),
            GraphQLField("Info", type: .nonNull(.object(Info.selections))),
            GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(items: [Item]? = nil, info: Info, errors: [Error]? = nil) {
          self.init(unsafeResultMap: ["__typename": "CartResponse", "Items": items.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, "Info": info.resultMap, "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var items: [Item]? {
          get {
            return (resultMap["Items"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Item] in value.map { (value: ResultMap) -> Item in Item(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, forKey: "Items")
          }
        }

        public var info: Info {
          get {
            return Info(unsafeResultMap: resultMap["Info"]! as! ResultMap)
          }
          set {
            resultMap.updateValue(newValue.resultMap, forKey: "Info")
          }
        }

        public var errors: [Error]? {
          get {
            return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartResponseFields: CartResponseFields {
            get {
              return CartResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Item: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartItem"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
              GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
              GraphQLField("CartToken", type: .scalar(String.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var cartId: Uint64 {
            get {
              return resultMap["CartID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartID")
            }
          }

          public var variant: Variant {
            get {
              return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Variant")
            }
          }

          public var variantId: FID {
            get {
              return resultMap["VariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantID")
            }
          }

          public var variantPriceId: Uint64 {
            get {
              return resultMap["VariantPriceID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantPriceID")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var discountAmount: Double {
            get {
              return resultMap["DiscountAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountAmount")
            }
          }

          public var quantity: Int {
            get {
              return resultMap["Quantity"]! as! Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Quantity")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var isSubscription: Bool {
            get {
              return resultMap["IsSubscription"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsSubscription")
            }
          }

          public var orderShipments: [Time] {
            get {
              return resultMap["OrderShipments"]! as! [Time]
            }
            set {
              resultMap.updateValue(newValue, forKey: "OrderShipments")
            }
          }

          public var cartToken: String? {
            get {
              return resultMap["CartToken"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartToken")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartItemFields: CartItemFields {
              get {
                return CartItemFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Variant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Product", type: .object(Product.selections)),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var product: Product? {
              get {
                return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Product")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var orderVariantFields: OrderVariantFields {
                get {
                  return OrderVariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct Product: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Product"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Status", type: .nonNull(.scalar(String.self))),
                  GraphQLField("SingleShipping", type: .scalar(Bool.self)),
                  GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
                  GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Category", type: .nonNull(.object(Category.selections))),
                  GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
                  GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                  GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
                  GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
                  GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
                  GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
                  GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
                  GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                  GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
                  GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
                  GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
                  GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
                  GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
                self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: FID {
                get {
                  return resultMap["ID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var status: String {
                get {
                  return resultMap["Status"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Status")
                }
              }

              public var singleShipping: Bool? {
                get {
                  return resultMap["SingleShipping"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SingleShipping")
                }
              }

              public var type: TypeAll {
                get {
                  return resultMap["Type"]! as! TypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var categoryId: Uint64 {
                get {
                  return resultMap["CategoryID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CategoryID")
                }
              }

              public var category: Category {
                get {
                  return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
                }
                set {
                  resultMap.updateValue(newValue.resultMap, forKey: "Category")
                }
              }

              public var tags: [String] {
                get {
                  return resultMap["Tags"]! as! [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Tags")
                }
              }

              public var attributesValues: [AttributesValue]? {
                get {
                  return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                }
              }

              public var badge: [Badge]? {
                get {
                  return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
                }
              }

              public var noteIDs: [Uint64] {
                get {
                  return resultMap["NoteIDs"]! as! [Uint64]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "NoteIDs")
                }
              }

              public var notes: [Note] {
                get {
                  return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
                }
                set {
                  resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
                }
              }

              public var defaultVariantId: FID {
                get {
                  return resultMap["DefaultVariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DefaultVariantID")
                }
              }

              public var defaultVariant: DefaultVariant? {
                get {
                  return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
                }
              }

              public var variants: [Variant]? {
                get {
                  return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
                }
              }

              public var likes: Uint64 {
                get {
                  return resultMap["Likes"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Likes")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var images: [Image]? {
                get {
                  return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
                }
              }

              public var attributeValueImages: [AttributeValueImage]? {
                get {
                  return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
                }
              }

              public var reviewProvider: ReviewProvider? {
                get {
                  return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
                }
              }

              public var reviewsSummary: ReviewsSummary? {
                get {
                  return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
                }
              }

              public var productLink: String {
                get {
                  return resultMap["ProductLink"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ProductLink")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var productFields: ProductFields {
                  get {
                    return ProductFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Category: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Category"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("MainParent", type: .object(MainParent.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var mainParent: MainParent? {
                  get {
                    return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var categoryFields: CategoryFields {
                    get {
                      return CategoryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct MainParent: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Category"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, description: String) {
                    self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }
                }
              }

              public struct AttributesValue: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("Attribute", type: .object(Attribute.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var attribute: Attribute? {
                  get {
                    return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueFields: AttributeValueFields {
                    get {
                      return AttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Attribute: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["Attribute"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("DisplayName", type: .scalar(String.self)),
                      GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                      GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                      GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                      GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                      GraphQLField("ParentID", type: .scalar(Uint64.self)),
                      GraphQLField("GroupID", type: .scalar(Uint64.self)),
                      GraphQLField("Group", type: .object(Group.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                    self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var displayName: String? {
                    get {
                      return resultMap["DisplayName"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DisplayName")
                    }
                  }

                  public var values: [Value]? {
                    get {
                      return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                    }
                  }

                  public var description: String {
                    get {
                      return resultMap["Description"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var inputType: InputTypeAll {
                    get {
                      return resultMap["InputType"]! as! InputTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "InputType")
                    }
                  }

                  public var `required`: Bool {
                    get {
                      return resultMap["Required"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Required")
                    }
                  }

                  public var hasThumbnail: Bool? {
                    get {
                      return resultMap["HasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "HasThumbnail")
                    }
                  }

                  public var attributeType: AttributeTypeAll {
                    get {
                      return resultMap["AttributeType"]! as! AttributeTypeAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeType")
                    }
                  }

                  public var parentId: Uint64? {
                    get {
                      return resultMap["ParentID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ParentID")
                    }
                  }

                  public var groupId: Uint64? {
                    get {
                      return resultMap["GroupID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "GroupID")
                    }
                  }

                  public var group: Group? {
                    get {
                      return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                      get {
                        return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Value: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeValue"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .scalar(Uint64.self)),
                        GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                        GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                      self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64? {
                      get {
                        return resultMap["ID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var value: String {
                      get {
                        return resultMap["Value"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Value")
                      }
                    }

                    public var attributeId: Uint64 {
                      get {
                        return resultMap["AttributeID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeID")
                      }
                    }

                    public var attributeHasThumbnail: Bool? {
                      get {
                        return resultMap["AttributeHasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var isVariationAttributeValue: Bool {
                      get {
                        return resultMap["IsVariationAttributeValue"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                        get {
                          return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }

                  public struct Group: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["AttributeGroup"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, sort: Uint64) {
                      self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var sort: Uint64 {
                      get {
                        return resultMap["Sort"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Sort")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeGroupFields: AttributeGroupFields {
                        get {
                          return AttributeGroupFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }
                  }
                }
              }

              public struct Badge: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Badge"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("Image", type: .nonNull(.object(Image.selections))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, description: String? = nil, image: Image) {
                  self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var image: Image {
                  get {
                    return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
                  }
                  set {
                    resultMap.updateValue(newValue.resultMap, forKey: "Image")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var badgeFields: BadgeFields {
                    get {
                      return BadgeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct Note: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["StaticPage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Position", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Content", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, position: String, content: String) {
                  self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var position: String {
                  get {
                    return resultMap["Position"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Position")
                  }
                }

                public var content: String {
                  get {
                    return resultMap["Content"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Content")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var staticPageFields: StaticPageFields {
                    get {
                      return StaticPageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct DefaultVariant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Variant: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Variant"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                    GraphQLField("Description", type: .scalar(String.self)),
                    GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                    GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                    GraphQLField("Inventory", type: .scalar(Int.self)),
                    GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: FID {
                  get {
                    return resultMap["ID"]! as! FID
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var description: String? {
                  get {
                    return resultMap["Description"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var attributesValues: [AttributesValue]? {
                  get {
                    return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
                  }
                }

                public var variantPrices: [VariantPrice]? {
                  get {
                    return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
                  }
                }

                public var inventory: Int? {
                  get {
                    return resultMap["Inventory"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Inventory")
                  }
                }

                public var inventoryIsLow: Bool? {
                  get {
                    return resultMap["InventoryIsLow"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InventoryIsLow")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantFields: VariantFields {
                    get {
                      return VariantFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct AttributesValue: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                      GraphQLField("Attribute", type: .object(Attribute.selections)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var attribute: Attribute? {
                    get {
                      return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                    }
                    set {
                      resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeValueFields: AttributeValueFields {
                      get {
                        return AttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Attribute: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["Attribute"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                        GraphQLField("DisplayName", type: .scalar(String.self)),
                        GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                        GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                        GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                        GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                        GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                        GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                        GraphQLField("ParentID", type: .scalar(Uint64.self)),
                        GraphQLField("GroupID", type: .scalar(Uint64.self)),
                        GraphQLField("Group", type: .object(Group.selections)),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                      self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var name: String {
                      get {
                        return resultMap["Name"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Name")
                      }
                    }

                    public var displayName: String? {
                      get {
                        return resultMap["DisplayName"] as? String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DisplayName")
                      }
                    }

                    public var values: [Value]? {
                      get {
                        return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                      }
                      set {
                        resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                      }
                    }

                    public var description: String {
                      get {
                        return resultMap["Description"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Description")
                      }
                    }

                    public var inputType: InputTypeAll {
                      get {
                        return resultMap["InputType"]! as! InputTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "InputType")
                      }
                    }

                    public var `required`: Bool {
                      get {
                        return resultMap["Required"]! as! Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "Required")
                      }
                    }

                    public var hasThumbnail: Bool? {
                      get {
                        return resultMap["HasThumbnail"] as? Bool
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "HasThumbnail")
                      }
                    }

                    public var attributeType: AttributeTypeAll {
                      get {
                        return resultMap["AttributeType"]! as! AttributeTypeAll
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "AttributeType")
                      }
                    }

                    public var parentId: Uint64? {
                      get {
                        return resultMap["ParentID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ParentID")
                      }
                    }

                    public var groupId: Uint64? {
                      get {
                        return resultMap["GroupID"] as? Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "GroupID")
                      }
                    }

                    public var group: Group? {
                      get {
                        return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                        get {
                          return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Value: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeValue"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .scalar(Uint64.self)),
                          GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                          GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                        self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64? {
                        get {
                          return resultMap["ID"] as? Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var value: String {
                        get {
                          return resultMap["Value"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Value")
                        }
                      }

                      public var attributeId: Uint64 {
                        get {
                          return resultMap["AttributeID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeID")
                        }
                      }

                      public var attributeHasThumbnail: Bool? {
                        get {
                          return resultMap["AttributeHasThumbnail"] as? Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var isVariationAttributeValue: Bool {
                        get {
                          return resultMap["IsVariationAttributeValue"]! as! Bool
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                          get {
                            return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }

                    public struct Group: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["AttributeGroup"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(id: Uint64, name: String, sort: Uint64) {
                        self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var id: Uint64 {
                        get {
                          return resultMap["ID"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "ID")
                        }
                      }

                      public var name: String {
                        get {
                          return resultMap["Name"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Name")
                        }
                      }

                      public var sort: Uint64 {
                        get {
                          return resultMap["Sort"]! as! Uint64
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Sort")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var attributeGroupFields: AttributeGroupFields {
                          get {
                            return AttributeGroupFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }

                public struct VariantPrice: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["VariantPrice"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                      GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                      GraphQLField("Description", type: .scalar(String.self)),
                      GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                      GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                      GraphQLField("RRPPrice", type: .scalar(Double.self)),
                      GraphQLField("BasePrice", type: .scalar(Double.self)),
                      GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                      GraphQLField("Commission", type: .scalar(Double.self)),
                      GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                      GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                    self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var variantId: FID {
                    get {
                      return resultMap["VariantID"]! as! FID
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "VariantID")
                    }
                  }

                  public var type: VariantPriceType {
                    get {
                      return resultMap["Type"]! as! VariantPriceType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Type")
                    }
                  }

                  public var description: String? {
                    get {
                      return resultMap["Description"] as? String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Description")
                    }
                  }

                  public var sellingPrice: Double {
                    get {
                      return resultMap["SellingPrice"]! as! Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "SellingPrice")
                    }
                  }

                  public var minResellingPrice: Double? {
                    get {
                      return resultMap["MinResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                    }
                  }

                  public var maxResellingPrice: Double? {
                    get {
                      return resultMap["MaxResellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                    }
                  }

                  public var rrpPrice: Double? {
                    get {
                      return resultMap["RRPPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "RRPPrice")
                    }
                  }

                  public var basePrice: Double? {
                    get {
                      return resultMap["BasePrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "BasePrice")
                    }
                  }

                  public var discounts: [Discount]? {
                    get {
                      return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                    }
                    set {
                      resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                    }
                  }

                  public var commission: Double? {
                    get {
                      return resultMap["Commission"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Commission")
                    }
                  }

                  public var discountPercentage: Double? {
                    get {
                      return resultMap["DiscountPercentage"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                    }
                  }

                  public var discountedSellingPrice: Double? {
                    get {
                      return resultMap["DiscountedSellingPrice"] as? Double
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var variantPriceFields: VariantPriceFields {
                      get {
                        return VariantPriceFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }

                  public struct Discount: GraphQLSelectionSet {
                    public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                    public static var selections: [GraphQLSelection] {
                      return [
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                        GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                        GraphQLField("StartCount", type: .scalar(Int.self)),
                        GraphQLField("EndCount", type: .scalar(Int.self)),
                        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                        GraphQLField("Description", type: .object(Description.selections)),
                        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                      ]
                    }

                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                      self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                    }

                    public var __typename: String {
                      get {
                        return resultMap["__typename"]! as! String
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "__typename")
                      }
                    }

                    public var id: Uint64 {
                      get {
                        return resultMap["ID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "ID")
                      }
                    }

                    public var countType: VariantPriceDiscountCountType {
                      get {
                        return resultMap["CountType"]! as! VariantPriceDiscountCountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CountType")
                      }
                    }

                    public var discountType: VariantPriceDiscountDiscountType {
                      get {
                        return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountType")
                      }
                    }

                    public var startCount: Int? {
                      get {
                        return resultMap["StartCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "StartCount")
                      }
                    }

                    public var endCount: Int? {
                      get {
                        return resultMap["EndCount"] as? Int
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "EndCount")
                      }
                    }

                    public var variantPriceId: Uint64 {
                      get {
                        return resultMap["VariantPriceID"]! as! Uint64
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "VariantPriceID")
                      }
                    }

                    public var discountAmount: Double {
                      get {
                        return resultMap["DiscountAmount"]! as! Double
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "DiscountAmount")
                      }
                    }

                    public var description: Description? {
                      get {
                        return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                      }
                      set {
                        resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                      }
                    }

                    public var createdAt: Time {
                      get {
                        return resultMap["CreatedAt"]! as! Time
                      }
                      set {
                        resultMap.updateValue(newValue, forKey: "CreatedAt")
                      }
                    }

                    public var fragments: Fragments {
                      get {
                        return Fragments(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }

                    public struct Fragments {
                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                        get {
                          return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }
                    }

                    public struct Description: GraphQLSelectionSet {
                      public static let possibleTypes: [String] = ["DiscountDescription"]

                      public static var selections: [GraphQLSelection] {
                        return [
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                          GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                        ]
                      }

                      public private(set) var resultMap: ResultMap

                      public init(unsafeResultMap: ResultMap) {
                        self.resultMap = unsafeResultMap
                      }

                      public init(template: String, parameters: [String]? = nil) {
                        self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                      }

                      public var __typename: String {
                        get {
                          return resultMap["__typename"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "__typename")
                        }
                      }

                      public var template: String {
                        get {
                          return resultMap["Template"]! as! String
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Template")
                        }
                      }

                      public var parameters: [String]? {
                        get {
                          return resultMap["Parameters"] as? [String]
                        }
                        set {
                          resultMap.updateValue(newValue, forKey: "Parameters")
                        }
                      }

                      public var fragments: Fragments {
                        get {
                          return Fragments(unsafeResultMap: resultMap)
                        }
                        set {
                          resultMap += newValue.resultMap
                        }
                      }

                      public struct Fragments {
                        public private(set) var resultMap: ResultMap

                        public init(unsafeResultMap: ResultMap) {
                          self.resultMap = unsafeResultMap
                        }

                        public var discountDescriptionFields: DiscountDescriptionFields {
                          get {
                            return DiscountDescriptionFields(unsafeResultMap: resultMap)
                          }
                          set {
                            resultMap += newValue.resultMap
                          }
                        }
                      }
                    }
                  }
                }
              }

              public struct Image: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["File"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                    GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                    GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                  self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var url: String {
                  get {
                    return resultMap["URL"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "URL")
                  }
                }

                public var idType: FileIDType {
                  get {
                    return resultMap["IDType"]! as! FileIDType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IDType")
                  }
                }

                public var category: FileCategoryAll {
                  get {
                    return resultMap["Category"]! as! FileCategoryAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Category")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var fileFields: FileFields {
                    get {
                      return FileFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct AttributeValueImage: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValueImage"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Key", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(key: String, images: [Image]) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var key: String {
                  get {
                    return resultMap["Key"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Key")
                  }
                }

                public var images: [Image] {
                  get {
                    return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
                  }
                  set {
                    resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueImageFields: AttributeValueImageFields {
                    get {
                      return AttributeValueImageFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Image: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["File"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                      GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                      GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                    self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var url: String {
                    get {
                      return resultMap["URL"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "URL")
                    }
                  }

                  public var idType: FileIDType {
                    get {
                      return resultMap["IDType"]! as! FileIDType
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IDType")
                    }
                  }

                  public var category: FileCategoryAll {
                    get {
                      return resultMap["Category"]! as! FileCategoryAll
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Category")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var fileFields: FileFields {
                      get {
                        return FileFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }

              public struct ReviewProvider: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewProvider"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
                    GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(String.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
                  self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var platform: ReviewProviderPlatformAll {
                  get {
                    return resultMap["Platform"]! as! ReviewProviderPlatformAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Platform")
                  }
                }

                public var type: ProductReviewTypeAll {
                  get {
                    return resultMap["Type"]! as! ProductReviewTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Type")
                  }
                }

                public var id: String {
                  get {
                    return resultMap["ID"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewProviderFields: ReviewProviderFields {
                    get {
                      return ReviewProviderFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct ReviewsSummary: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["ReviewsSummary"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(total: Uint64, stars: Double) {
                  self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var total: Uint64 {
                  get {
                    return resultMap["Total"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Total")
                  }
                }

                public var stars: Double {
                  get {
                    return resultMap["Stars"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Stars")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var reviewsSummaryFields: ReviewsSummaryFields {
                    get {
                      return ReviewsSummaryFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Info: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Cart"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Discount", type: .object(Discount.selections)),
              GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
              GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
              GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
              GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
              GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
              GraphQLField("ZipCode", type: .scalar(String.self)),
              GraphQLField("ClosedAt", type: .scalar(Time.self)),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var payablePrice: Double {
            get {
              return resultMap["PayablePrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "PayablePrice")
            }
          }

          public var totalAmount: Double {
            get {
              return resultMap["TotalAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "TotalAmount")
            }
          }

          public var discountCodeAmount: Double {
            get {
              return resultMap["DiscountCodeAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
            }
          }

          public var hasDiscount: Bool {
            get {
              return resultMap["HasDiscount"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "HasDiscount")
            }
          }

          public var discount: Discount? {
            get {
              return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
            }
          }

          public var discounts: [Discount]? {
            get {
              return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
            }
          }

          public var deliveryDiscount: DeliveryDiscount? {
            get {
              return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
            }
          }

          public var status: CartStatusAll {
            get {
              return resultMap["Status"]! as! CartStatusAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Status")
            }
          }

          public var source: SourceAll {
            get {
              return resultMap["Source"]! as! SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Source")
            }
          }

          public var sourceClose: SourceAll? {
            get {
              return resultMap["SourceClose"] as? SourceAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "SourceClose")
            }
          }

          public var zipCode: String? {
            get {
              return resultMap["ZipCode"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ZipCode")
            }
          }

          public var closedAt: Time? {
            get {
              return resultMap["ClosedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "ClosedAt")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartFields: CartFields {
              get {
                return CartFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct DeliveryDiscount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Discount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
                GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("PublicCode", type: .object(PublicCode.selections)),
                GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var type: DiscountTypeAll {
              get {
                return resultMap["Type"]! as! DiscountTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var amount: Double {
              get {
                return resultMap["Amount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Amount")
              }
            }

            public var publicCode: PublicCode? {
              get {
                return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
              }
            }

            public var updatedAt: Time? {
              get {
                return resultMap["UpdatedAt"] as? Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "UpdatedAt")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountFields: DiscountFields {
                get {
                  return DiscountFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct PublicCode: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountCode"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Code", type: .nonNull(.scalar(String.self))),
                  GraphQLField("UpdatedAt", type: .scalar(Time.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, code: String, updatedAt: Time? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var code: String {
                get {
                  return resultMap["Code"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Code")
                }
              }

              public var updatedAt: Time? {
                get {
                  return resultMap["UpdatedAt"] as? Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "UpdatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountCodeFields: DiscountCodeFields {
                  get {
                    return DiscountCodeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Error: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  final class ListAvailableShippingQuery: GraphQLQuery {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      query ListAvailableShipping($variantID: FID!, $variantPriceID: Uint64!, $from: Time!, $to: Time!) {
        GetAvailableShippingDates(
          Request: {VariantID: $variantID, VariantPriceID: $variantPriceID, From: $from, To: $to}
        ) {
          __typename
          ...AvailableShippingDateFields
        }
      }
      """

    public let operationName: String = "ListAvailableShipping"

    public let operationIdentifier: String? = "8ef7c92f75ce2f306fd5fcaa6f37b79d3bcbd75a8724bf5f98f0589cbfa8877b"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + AvailableShippingDateFields.fragmentDefinition)
      return document
    }

    public var variantID: FID
    public var variantPriceID: Uint64
    public var from: Time
    public var to: Time

    public init(variantID: FID, variantPriceID: Uint64, from: Time, to: Time) {
      self.variantID = variantID
      self.variantPriceID = variantPriceID
      self.from = from
      self.to = to
    }

    public var variables: GraphQLMap? {
      return ["variantID": variantID, "variantPriceID": variantPriceID, "from": from, "to": to]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Query"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("GetAvailableShippingDates", arguments: ["Request": ["VariantID": GraphQLVariable("variantID"), "VariantPriceID": GraphQLVariable("variantPriceID"), "From": GraphQLVariable("from"), "To": GraphQLVariable("to")]], type: .nonNull(.list(.nonNull(.object(GetAvailableShippingDate.selections))))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(getAvailableShippingDates: [GetAvailableShippingDate]) {
        self.init(unsafeResultMap: ["__typename": "Query", "GetAvailableShippingDates": getAvailableShippingDates.map { (value: GetAvailableShippingDate) -> ResultMap in value.resultMap }])
      }

      public var getAvailableShippingDates: [GetAvailableShippingDate] {
        get {
          return (resultMap["GetAvailableShippingDates"] as! [ResultMap]).map { (value: ResultMap) -> GetAvailableShippingDate in GetAvailableShippingDate(unsafeResultMap: value) }
        }
        set {
          resultMap.updateValue(newValue.map { (value: GetAvailableShippingDate) -> ResultMap in value.resultMap }, forKey: "GetAvailableShippingDates")
        }
      }

      public struct GetAvailableShippingDate: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["AvailableShipping"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Date", type: .nonNull(.scalar(Time.self))),
            GraphQLField("DeliveryDate", type: .scalar(Time.self)),
            GraphQLField("IsAvailable", type: .nonNull(.scalar(Bool.self))),
            GraphQLField("Reason", type: .nonNull(.scalar(String.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(date: Time, deliveryDate: Time? = nil, isAvailable: Bool, reason: String) {
          self.init(unsafeResultMap: ["__typename": "AvailableShipping", "Date": date, "DeliveryDate": deliveryDate, "IsAvailable": isAvailable, "Reason": reason])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var date: Time {
          get {
            return resultMap["Date"]! as! Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "Date")
          }
        }

        public var deliveryDate: Time? {
          get {
            return resultMap["DeliveryDate"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "DeliveryDate")
          }
        }

        public var isAvailable: Bool {
          get {
            return resultMap["IsAvailable"]! as! Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "IsAvailable")
          }
        }

        public var reason: String {
          get {
            return resultMap["Reason"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Reason")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var availableShippingDateFields: AvailableShippingDateFields {
            get {
              return AvailableShippingDateFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }
    }
  }

  final class SetResellingPriceMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation SetResellingPrice($resellingPrices: [ResellingPriceData!]!, $cartHash: String) {
        SetResellingPrice(
          Request: {ResellingPrices: $resellingPrices, CartHash: $cartHash}
        ) {
          __typename
          ...ResellingPriceResponseFields
        }
      }
      """

    public let operationName: String = "SetResellingPrice"

    public let operationIdentifier: String? = "49ed48acbe95562feeef8741f179c14087b8dc202cbae459b52c9af8e55322e8"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + ResellingPriceResponseFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      document.append("\n" + ResellingPriceFields.fragmentDefinition)
      return document
    }

    public var resellingPrices: [ResellingPriceData]
    public var cartHash: String?

    public init(resellingPrices: [ResellingPriceData], cartHash: String? = nil) {
      self.resellingPrices = resellingPrices
      self.cartHash = cartHash
    }

    public var variables: GraphQLMap? {
      return ["resellingPrices": resellingPrices, "cartHash": cartHash]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("SetResellingPrice", arguments: ["Request": ["ResellingPrices": GraphQLVariable("resellingPrices"), "CartHash": GraphQLVariable("cartHash")]], type: .nonNull(.object(SetResellingPrice.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(setResellingPrice: SetResellingPrice) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "SetResellingPrice": setResellingPrice.resultMap])
      }

      public var setResellingPrice: SetResellingPrice {
        get {
          return SetResellingPrice(unsafeResultMap: resultMap["SetResellingPrice"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "SetResellingPrice")
        }
      }

      public struct SetResellingPrice: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["ResellingPriceResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
            GraphQLField("ResellingPrices", type: .nonNull(.list(.nonNull(.object(ResellingPrice.selections))))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(errors: [Error]? = nil, resellingPrices: [ResellingPrice]) {
          self.init(unsafeResultMap: ["__typename": "ResellingPriceResponse", "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, "ResellingPrices": resellingPrices.map { (value: ResellingPrice) -> ResultMap in value.resultMap }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var errors: [Error]? {
          get {
            return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
          }
        }

        public var resellingPrices: [ResellingPrice] {
          get {
            return (resultMap["ResellingPrices"] as! [ResultMap]).map { (value: ResultMap) -> ResellingPrice in ResellingPrice(unsafeResultMap: value) }
          }
          set {
            resultMap.updateValue(newValue.map { (value: ResellingPrice) -> ResultMap in value.resultMap }, forKey: "ResellingPrices")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var resellingPriceResponseFields: ResellingPriceResponseFields {
            get {
              return ResellingPriceResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Error: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct ResellingPrice: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["ResellingPrice"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("CartItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Price", type: .nonNull(.scalar(Double.self))),
              GraphQLField("ResellerPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("SetAt", type: .scalar(Time.self)),
              GraphQLField("IsSet", type: .nonNull(.scalar(Bool.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(cartItemId: Uint64, price: Double, resellerPrice: Double, setAt: Time? = nil, isSet: Bool) {
            self.init(unsafeResultMap: ["__typename": "ResellingPrice", "CartItemID": cartItemId, "Price": price, "ResellerPrice": resellerPrice, "SetAt": setAt, "IsSet": isSet])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var cartItemId: Uint64 {
            get {
              return resultMap["CartItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CartItemID")
            }
          }

          public var price: Double {
            get {
              return resultMap["Price"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Price")
            }
          }

          public var resellerPrice: Double {
            get {
              return resultMap["ResellerPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "ResellerPrice")
            }
          }

          public var setAt: Time? {
            get {
              return resultMap["SetAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "SetAt")
            }
          }

          public var isSet: Bool {
            get {
              return resultMap["IsSet"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsSet")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var resellingPriceFields: ResellingPriceFields {
              get {
                return ResellingPriceFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  final class CartSummaryRequestMutation: GraphQLMutation {
    /// The raw GraphQL definition of this operation.
    public let operationDefinition: String =
      """
      mutation CartSummaryRequest($addressID: Uint64, $cartItemDetails: [CardItemDetail!]!, $WithResellingPrice: Boolean!) {
        CartSummary(
          Request: {AddressID: $addressID, CartItemDetails: $cartItemDetails, WithResselingPrice: $WithResellingPrice}
        ) {
          __typename
          ...CartSummaryResponseFields
        }
      }
      """

    public let operationName: String = "CartSummaryRequest"

    public let operationIdentifier: String? = "cd41872719425350fc2cf670d9c77572e945957e6f64ec5697449c8ece6e947c"

    public var queryDocument: String {
      var document: String = operationDefinition
      document.append("\n" + CartSummaryResponseFields.fragmentDefinition)
      document.append("\n" + CartErrorFields.fragmentDefinition)
      return document
    }

    public var addressID: Uint64?
    public var cartItemDetails: [CardItemDetail]
    public var WithResellingPrice: Bool

    public init(addressID: Uint64? = nil, cartItemDetails: [CardItemDetail], WithResellingPrice: Bool) {
      self.addressID = addressID
      self.cartItemDetails = cartItemDetails
      self.WithResellingPrice = WithResellingPrice
    }

    public var variables: GraphQLMap? {
      return ["addressID": addressID, "cartItemDetails": cartItemDetails, "WithResellingPrice": WithResellingPrice]
    }

    public struct Data: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Mutation"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("CartSummary", arguments: ["Request": ["AddressID": GraphQLVariable("addressID"), "CartItemDetails": GraphQLVariable("cartItemDetails"), "WithResselingPrice": GraphQLVariable("WithResellingPrice")]], type: .nonNull(.object(CartSummary.selections))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(cartSummary: CartSummary) {
        self.init(unsafeResultMap: ["__typename": "Mutation", "CartSummary": cartSummary.resultMap])
      }

      public var cartSummary: CartSummary {
        get {
          return CartSummary(unsafeResultMap: resultMap["CartSummary"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "CartSummary")
        }
      }

      public struct CartSummary: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["CartSummaryResponse"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ShipmentCost", type: .nonNull(.scalar(Double.self))),
            GraphQLField("Discount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("TotalRRPPrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("TotalSellingPrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("TotalCommission", type: .nonNull(.scalar(Double.self))),
            GraphQLField("OrderTotal", type: .nonNull(.scalar(Double.self))),
            GraphQLField("CartErrors", type: .list(.nonNull(.object(CartError.selections)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(shipmentCost: Double, discount: Double, totalRrpPrice: Double, totalSellingPrice: Double, totalCommission: Double, orderTotal: Double, cartErrors: [CartError]? = nil) {
          self.init(unsafeResultMap: ["__typename": "CartSummaryResponse", "ShipmentCost": shipmentCost, "Discount": discount, "TotalRRPPrice": totalRrpPrice, "TotalSellingPrice": totalSellingPrice, "TotalCommission": totalCommission, "OrderTotal": orderTotal, "CartErrors": cartErrors.flatMap { (value: [CartError]) -> [ResultMap] in value.map { (value: CartError) -> ResultMap in value.resultMap } }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var shipmentCost: Double {
          get {
            return resultMap["ShipmentCost"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "ShipmentCost")
          }
        }

        public var discount: Double {
          get {
            return resultMap["Discount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "Discount")
          }
        }

        public var totalRrpPrice: Double {
          get {
            return resultMap["TotalRRPPrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "TotalRRPPrice")
          }
        }

        public var totalSellingPrice: Double {
          get {
            return resultMap["TotalSellingPrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "TotalSellingPrice")
          }
        }

        public var totalCommission: Double {
          get {
            return resultMap["TotalCommission"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "TotalCommission")
          }
        }

        public var orderTotal: Double {
          get {
            return resultMap["OrderTotal"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "OrderTotal")
          }
        }

        public var cartErrors: [CartError]? {
          get {
            return (resultMap["CartErrors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [CartError] in value.map { (value: ResultMap) -> CartError in CartError(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [CartError]) -> [ResultMap] in value.map { (value: CartError) -> ResultMap in value.resultMap } }, forKey: "CartErrors")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var cartSummaryResponseFields: CartSummaryResponseFields {
            get {
              return CartSummaryResponseFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct CartError: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["CartError"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Message", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(itemId: Uint64, message: String) {
            self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var itemId: Uint64 {
            get {
              return resultMap["ItemID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ItemID")
            }
          }

          public var message: String {
            get {
              return resultMap["Message"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Message")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var cartErrorFields: CartErrorFields {
              get {
                return CartErrorFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  struct CartItemFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment cartItemFields on CartItem {
        __typename
        ID
        CartID
        Variant {
          __typename
          ...OrderVariantFields
        }
        VariantID
        VariantPriceID
        SellingPrice
        DiscountAmount
        Quantity
        Source
        IsSubscription
        OrderShipments
        CartToken
        UpdatedAt
        CreatedAt
      }
      """

    public static let possibleTypes: [String] = ["CartItem"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
        GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
        GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
        GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
        GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
        GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
        GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
        GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
        GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
        GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
        GraphQLField("CartToken", type: .scalar(String.self)),
        GraphQLField("UpdatedAt", type: .scalar(Time.self)),
        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
      self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var id: Uint64 {
      get {
        return resultMap["ID"]! as! Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "ID")
      }
    }

    public var cartId: Uint64 {
      get {
        return resultMap["CartID"]! as! Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "CartID")
      }
    }

    public var variant: Variant {
      get {
        return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
      }
      set {
        resultMap.updateValue(newValue.resultMap, forKey: "Variant")
      }
    }

    public var variantId: FID {
      get {
        return resultMap["VariantID"]! as! FID
      }
      set {
        resultMap.updateValue(newValue, forKey: "VariantID")
      }
    }

    public var variantPriceId: Uint64 {
      get {
        return resultMap["VariantPriceID"]! as! Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "VariantPriceID")
      }
    }

    public var sellingPrice: Double {
      get {
        return resultMap["SellingPrice"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "SellingPrice")
      }
    }

    public var discountAmount: Double {
      get {
        return resultMap["DiscountAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "DiscountAmount")
      }
    }

    public var quantity: Int {
      get {
        return resultMap["Quantity"]! as! Int
      }
      set {
        resultMap.updateValue(newValue, forKey: "Quantity")
      }
    }

    public var source: SourceAll {
      get {
        return resultMap["Source"]! as! SourceAll
      }
      set {
        resultMap.updateValue(newValue, forKey: "Source")
      }
    }

    public var isSubscription: Bool {
      get {
        return resultMap["IsSubscription"]! as! Bool
      }
      set {
        resultMap.updateValue(newValue, forKey: "IsSubscription")
      }
    }

    public var orderShipments: [Time] {
      get {
        return resultMap["OrderShipments"]! as! [Time]
      }
      set {
        resultMap.updateValue(newValue, forKey: "OrderShipments")
      }
    }

    public var cartToken: String? {
      get {
        return resultMap["CartToken"] as? String
      }
      set {
        resultMap.updateValue(newValue, forKey: "CartToken")
      }
    }

    public var updatedAt: Time? {
      get {
        return resultMap["UpdatedAt"] as? Time
      }
      set {
        resultMap.updateValue(newValue, forKey: "UpdatedAt")
      }
    }

    public var createdAt: Time {
      get {
        return resultMap["CreatedAt"]! as! Time
      }
      set {
        resultMap.updateValue(newValue, forKey: "CreatedAt")
      }
    }

    public struct Variant: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Variant"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
          GraphQLField("Description", type: .scalar(String.self)),
          GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
          GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
          GraphQLField("Product", type: .object(Product.selections)),
          GraphQLField("Inventory", type: .scalar(Int.self)),
          GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
        self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var id: FID {
        get {
          return resultMap["ID"]! as! FID
        }
        set {
          resultMap.updateValue(newValue, forKey: "ID")
        }
      }

      public var description: String? {
        get {
          return resultMap["Description"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Description")
        }
      }

      public var attributesValues: [AttributesValue]? {
        get {
          return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
        }
        set {
          resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
        }
      }

      public var variantPrices: [VariantPrice]? {
        get {
          return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
        }
        set {
          resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
        }
      }

      public var product: Product? {
        get {
          return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Product")
        }
      }

      public var inventory: Int? {
        get {
          return resultMap["Inventory"] as? Int
        }
        set {
          resultMap.updateValue(newValue, forKey: "Inventory")
        }
      }

      public var inventoryIsLow: Bool? {
        get {
          return resultMap["InventoryIsLow"] as? Bool
        }
        set {
          resultMap.updateValue(newValue, forKey: "InventoryIsLow")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var orderVariantFields: OrderVariantFields {
          get {
            return OrderVariantFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }

      public struct AttributesValue: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["AttributeValue"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .scalar(Uint64.self)),
            GraphQLField("Value", type: .nonNull(.scalar(String.self))),
            GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
            GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
            GraphQLField("Attribute", type: .object(Attribute.selections)),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
          self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64? {
          get {
            return resultMap["ID"] as? Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var value: String {
          get {
            return resultMap["Value"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Value")
          }
        }

        public var attributeId: Uint64 {
          get {
            return resultMap["AttributeID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "AttributeID")
          }
        }

        public var attributeHasThumbnail: Bool? {
          get {
            return resultMap["AttributeHasThumbnail"] as? Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
          }
        }

        public var sort: Uint64 {
          get {
            return resultMap["Sort"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "Sort")
          }
        }

        public var isVariationAttributeValue: Bool {
          get {
            return resultMap["IsVariationAttributeValue"]! as! Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
          }
        }

        public var attribute: Attribute? {
          get {
            return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var attributeValueFields: AttributeValueFields {
            get {
              return AttributeValueFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Attribute: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Attribute"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("DisplayName", type: .scalar(String.self)),
              GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
              GraphQLField("Description", type: .nonNull(.scalar(String.self))),
              GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
              GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
              GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
              GraphQLField("ParentID", type: .scalar(Uint64.self)),
              GraphQLField("GroupID", type: .scalar(Uint64.self)),
              GraphQLField("Group", type: .object(Group.selections)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
            self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var displayName: String? {
            get {
              return resultMap["DisplayName"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "DisplayName")
            }
          }

          public var values: [Value]? {
            get {
              return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
            }
          }

          public var description: String {
            get {
              return resultMap["Description"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Description")
            }
          }

          public var inputType: InputTypeAll {
            get {
              return resultMap["InputType"]! as! InputTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "InputType")
            }
          }

          public var `required`: Bool {
            get {
              return resultMap["Required"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "Required")
            }
          }

          public var hasThumbnail: Bool? {
            get {
              return resultMap["HasThumbnail"] as? Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "HasThumbnail")
            }
          }

          public var attributeType: AttributeTypeAll {
            get {
              return resultMap["AttributeType"]! as! AttributeTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "AttributeType")
            }
          }

          public var parentId: Uint64? {
            get {
              return resultMap["ParentID"] as? Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ParentID")
            }
          }

          public var groupId: Uint64? {
            get {
              return resultMap["GroupID"] as? Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "GroupID")
            }
          }

          public var group: Group? {
            get {
              return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Group")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
              get {
                return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Value: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["AttributeValue"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .scalar(Uint64.self)),
                GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
              self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64? {
              get {
                return resultMap["ID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var value: String {
              get {
                return resultMap["Value"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Value")
              }
            }

            public var attributeId: Uint64 {
              get {
                return resultMap["AttributeID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeID")
              }
            }

            public var attributeHasThumbnail: Bool? {
              get {
                return resultMap["AttributeHasThumbnail"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
              }
            }

            public var sort: Uint64 {
              get {
                return resultMap["Sort"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "Sort")
              }
            }

            public var isVariationAttributeValue: Bool {
              get {
                return resultMap["IsVariationAttributeValue"]! as! Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                get {
                  return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct Group: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["AttributeGroup"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, sort: Uint64) {
              self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var sort: Uint64 {
              get {
                return resultMap["Sort"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "Sort")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attributeGroupFields: AttributeGroupFields {
                get {
                  return AttributeGroupFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }
      }

      public struct VariantPrice: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["VariantPrice"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
            GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
            GraphQLField("Description", type: .scalar(String.self)),
            GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
            GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
            GraphQLField("RRPPrice", type: .scalar(Double.self)),
            GraphQLField("BasePrice", type: .scalar(Double.self)),
            GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
            GraphQLField("Commission", type: .scalar(Double.self)),
            GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
            GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
          self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var variantId: FID {
          get {
            return resultMap["VariantID"]! as! FID
          }
          set {
            resultMap.updateValue(newValue, forKey: "VariantID")
          }
        }

        public var type: VariantPriceType {
          get {
            return resultMap["Type"]! as! VariantPriceType
          }
          set {
            resultMap.updateValue(newValue, forKey: "Type")
          }
        }

        public var description: String? {
          get {
            return resultMap["Description"] as? String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Description")
          }
        }

        public var sellingPrice: Double {
          get {
            return resultMap["SellingPrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "SellingPrice")
          }
        }

        public var minResellingPrice: Double? {
          get {
            return resultMap["MinResellingPrice"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "MinResellingPrice")
          }
        }

        public var maxResellingPrice: Double? {
          get {
            return resultMap["MaxResellingPrice"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
          }
        }

        public var rrpPrice: Double? {
          get {
            return resultMap["RRPPrice"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "RRPPrice")
          }
        }

        public var basePrice: Double? {
          get {
            return resultMap["BasePrice"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "BasePrice")
          }
        }

        public var discounts: [Discount]? {
          get {
            return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
          }
        }

        public var commission: Double? {
          get {
            return resultMap["Commission"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "Commission")
          }
        }

        public var discountPercentage: Double? {
          get {
            return resultMap["DiscountPercentage"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "DiscountPercentage")
          }
        }

        public var discountedSellingPrice: Double? {
          get {
            return resultMap["DiscountedSellingPrice"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var variantPriceFields: VariantPriceFields {
            get {
              return VariantPriceFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Discount: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["VariantPriceDiscount"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
              GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
              GraphQLField("StartCount", type: .scalar(Int.self)),
              GraphQLField("EndCount", type: .scalar(Int.self)),
              GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Description", type: .object(Description.selections)),
              GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
            self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var countType: VariantPriceDiscountCountType {
            get {
              return resultMap["CountType"]! as! VariantPriceDiscountCountType
            }
            set {
              resultMap.updateValue(newValue, forKey: "CountType")
            }
          }

          public var discountType: VariantPriceDiscountDiscountType {
            get {
              return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountType")
            }
          }

          public var startCount: Int? {
            get {
              return resultMap["StartCount"] as? Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "StartCount")
            }
          }

          public var endCount: Int? {
            get {
              return resultMap["EndCount"] as? Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "EndCount")
            }
          }

          public var variantPriceId: Uint64 {
            get {
              return resultMap["VariantPriceID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantPriceID")
            }
          }

          public var discountAmount: Double {
            get {
              return resultMap["DiscountAmount"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountAmount")
            }
          }

          public var description: Description? {
            get {
              return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Description")
            }
          }

          public var createdAt: Time {
            get {
              return resultMap["CreatedAt"]! as! Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "CreatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
              get {
                return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Description: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["DiscountDescription"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(template: String, parameters: [String]? = nil) {
              self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var template: String {
              get {
                return resultMap["Template"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Template")
              }
            }

            public var parameters: [String]? {
              get {
                return resultMap["Parameters"] as? [String]
              }
              set {
                resultMap.updateValue(newValue, forKey: "Parameters")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var discountDescriptionFields: DiscountDescriptionFields {
                get {
                  return DiscountDescriptionFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }
      }

      public struct Product: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["Product"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
            GraphQLField("Name", type: .nonNull(.scalar(String.self))),
            GraphQLField("Description", type: .nonNull(.scalar(String.self))),
            GraphQLField("Status", type: .nonNull(.scalar(String.self))),
            GraphQLField("SingleShipping", type: .scalar(Bool.self)),
            GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
            GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Category", type: .nonNull(.object(Category.selections))),
            GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
            GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
            GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
            GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
            GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
            GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
            GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
            GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
            GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
            GraphQLField("RRPPrice", type: .scalar(Double.self)),
            GraphQLField("Commission", type: .scalar(Double.self)),
            GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
            GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
            GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
            GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
            GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
            GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
            GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
          self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: FID {
          get {
            return resultMap["ID"]! as! FID
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var name: String {
          get {
            return resultMap["Name"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Name")
          }
        }

        public var description: String {
          get {
            return resultMap["Description"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Description")
          }
        }

        public var status: String {
          get {
            return resultMap["Status"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Status")
          }
        }

        public var singleShipping: Bool? {
          get {
            return resultMap["SingleShipping"] as? Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "SingleShipping")
          }
        }

        public var type: TypeAll {
          get {
            return resultMap["Type"]! as! TypeAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Type")
          }
        }

        public var categoryId: Uint64 {
          get {
            return resultMap["CategoryID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "CategoryID")
          }
        }

        public var category: Category {
          get {
            return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
          }
          set {
            resultMap.updateValue(newValue.resultMap, forKey: "Category")
          }
        }

        public var tags: [String] {
          get {
            return resultMap["Tags"]! as! [String]
          }
          set {
            resultMap.updateValue(newValue, forKey: "Tags")
          }
        }

        public var attributesValues: [AttributesValue]? {
          get {
            return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
          }
        }

        public var badge: [Badge]? {
          get {
            return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
          }
        }

        public var noteIDs: [Uint64] {
          get {
            return resultMap["NoteIDs"]! as! [Uint64]
          }
          set {
            resultMap.updateValue(newValue, forKey: "NoteIDs")
          }
        }

        public var notes: [Note] {
          get {
            return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
          }
          set {
            resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
          }
        }

        public var defaultVariantId: FID {
          get {
            return resultMap["DefaultVariantID"]! as! FID
          }
          set {
            resultMap.updateValue(newValue, forKey: "DefaultVariantID")
          }
        }

        public var defaultVariant: DefaultVariant? {
          get {
            return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
          }
        }

        public var variants: [Variant]? {
          get {
            return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
          }
        }

        public var likes: Uint64 {
          get {
            return resultMap["Likes"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "Likes")
          }
        }

        public var sellingPrice: Double {
          get {
            return resultMap["SellingPrice"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "SellingPrice")
          }
        }

        public var rrpPrice: Double? {
          get {
            return resultMap["RRPPrice"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "RRPPrice")
          }
        }

        public var commission: Double? {
          get {
            return resultMap["Commission"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "Commission")
          }
        }

        public var discountPercentage: Double? {
          get {
            return resultMap["DiscountPercentage"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "DiscountPercentage")
          }
        }

        public var discountedSellingPrice: Double? {
          get {
            return resultMap["DiscountedSellingPrice"] as? Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
          }
        }

        public var images: [Image]? {
          get {
            return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
          }
        }

        public var attributeValueImages: [AttributeValueImage]? {
          get {
            return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
          }
        }

        public var reviewProvider: ReviewProvider? {
          get {
            return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
          }
        }

        public var reviewsSummary: ReviewsSummary? {
          get {
            return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
          }
        }

        public var productLink: String {
          get {
            return resultMap["ProductLink"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "ProductLink")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var productFields: ProductFields {
            get {
              return ProductFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Category: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Category"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .nonNull(.scalar(String.self))),
              GraphQLField("MainParent", type: .object(MainParent.selections)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
            self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: String {
            get {
              return resultMap["Description"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Description")
            }
          }

          public var mainParent: MainParent? {
            get {
              return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var categoryFields: CategoryFields {
              get {
                return CategoryFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct MainParent: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Category"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .nonNull(.scalar(String.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: String) {
              self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: String {
              get {
                return resultMap["Description"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }
          }
        }

        public struct AttributesValue: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["AttributeValue"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .scalar(Uint64.self)),
              GraphQLField("Value", type: .nonNull(.scalar(String.self))),
              GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
              GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Attribute", type: .object(Attribute.selections)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
            self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64? {
            get {
              return resultMap["ID"] as? Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var value: String {
            get {
              return resultMap["Value"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Value")
            }
          }

          public var attributeId: Uint64 {
            get {
              return resultMap["AttributeID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "AttributeID")
            }
          }

          public var attributeHasThumbnail: Bool? {
            get {
              return resultMap["AttributeHasThumbnail"] as? Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
            }
          }

          public var sort: Uint64 {
            get {
              return resultMap["Sort"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "Sort")
            }
          }

          public var isVariationAttributeValue: Bool {
            get {
              return resultMap["IsVariationAttributeValue"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
            }
          }

          public var attribute: Attribute? {
            get {
              return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var attributeValueFields: AttributeValueFields {
              get {
                return AttributeValueFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Attribute: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Attribute"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("DisplayName", type: .scalar(String.self)),
                GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                GraphQLField("ParentID", type: .scalar(Uint64.self)),
                GraphQLField("GroupID", type: .scalar(Uint64.self)),
                GraphQLField("Group", type: .object(Group.selections)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
              self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var displayName: String? {
              get {
                return resultMap["DisplayName"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "DisplayName")
              }
            }

            public var values: [Value]? {
              get {
                return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
              }
            }

            public var description: String {
              get {
                return resultMap["Description"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var inputType: InputTypeAll {
              get {
                return resultMap["InputType"]! as! InputTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "InputType")
              }
            }

            public var `required`: Bool {
              get {
                return resultMap["Required"]! as! Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "Required")
              }
            }

            public var hasThumbnail: Bool? {
              get {
                return resultMap["HasThumbnail"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "HasThumbnail")
              }
            }

            public var attributeType: AttributeTypeAll {
              get {
                return resultMap["AttributeType"]! as! AttributeTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeType")
              }
            }

            public var parentId: Uint64? {
              get {
                return resultMap["ParentID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ParentID")
              }
            }

            public var groupId: Uint64? {
              get {
                return resultMap["GroupID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "GroupID")
              }
            }

            public var group: Group? {
              get {
                return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Group")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                get {
                  return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Value: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                  get {
                    return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct Group: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeGroup"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, name: String, sort: Uint64) {
                self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeGroupFields: AttributeGroupFields {
                  get {
                    return AttributeGroupFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Badge: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Badge"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .scalar(String.self)),
              GraphQLField("Image", type: .nonNull(.object(Image.selections))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, description: String? = nil, image: Image) {
            self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: String? {
            get {
              return resultMap["Description"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Description")
            }
          }

          public var image: Image {
            get {
              return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Image")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var badgeFields: BadgeFields {
              get {
                return BadgeFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Image: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["File"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
              self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var url: String {
              get {
                return resultMap["URL"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "URL")
              }
            }

            public var idType: FileIDType {
              get {
                return resultMap["IDType"]! as! FileIDType
              }
              set {
                resultMap.updateValue(newValue, forKey: "IDType")
              }
            }

            public var category: FileCategoryAll {
              get {
                return resultMap["Category"]! as! FileCategoryAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Category")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var fileFields: FileFields {
                get {
                  return FileFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }

        public struct Note: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["StaticPage"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Position", type: .nonNull(.scalar(String.self))),
              GraphQLField("Content", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, name: String, position: String, content: String) {
            self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var position: String {
            get {
              return resultMap["Position"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Position")
            }
          }

          public var content: String {
            get {
              return resultMap["Content"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Content")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var staticPageFields: StaticPageFields {
              get {
                return StaticPageFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct DefaultVariant: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Variant"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("Description", type: .scalar(String.self)),
              GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
              GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
              GraphQLField("Inventory", type: .scalar(Int.self)),
              GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
            self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: FID {
            get {
              return resultMap["ID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var description: String? {
            get {
              return resultMap["Description"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Description")
            }
          }

          public var attributesValues: [AttributesValue]? {
            get {
              return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
            }
          }

          public var variantPrices: [VariantPrice]? {
            get {
              return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
            }
          }

          public var inventory: Int? {
            get {
              return resultMap["Inventory"] as? Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Inventory")
            }
          }

          public var inventoryIsLow: Bool? {
            get {
              return resultMap["InventoryIsLow"] as? Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "InventoryIsLow")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var variantFields: VariantFields {
              get {
                return VariantFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct AttributesValue: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["AttributeValue"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .scalar(Uint64.self)),
                GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                GraphQLField("Attribute", type: .object(Attribute.selections)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
              self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64? {
              get {
                return resultMap["ID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var value: String {
              get {
                return resultMap["Value"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Value")
              }
            }

            public var attributeId: Uint64 {
              get {
                return resultMap["AttributeID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeID")
              }
            }

            public var attributeHasThumbnail: Bool? {
              get {
                return resultMap["AttributeHasThumbnail"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
              }
            }

            public var sort: Uint64 {
              get {
                return resultMap["Sort"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "Sort")
              }
            }

            public var isVariationAttributeValue: Bool {
              get {
                return resultMap["IsVariationAttributeValue"]! as! Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
              }
            }

            public var attribute: Attribute? {
              get {
                return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attributeValueFields: AttributeValueFields {
                get {
                  return AttributeValueFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Attribute: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Attribute"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("DisplayName", type: .scalar(String.self)),
                  GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                  GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                  GraphQLField("ParentID", type: .scalar(Uint64.self)),
                  GraphQLField("GroupID", type: .scalar(Uint64.self)),
                  GraphQLField("Group", type: .object(Group.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var displayName: String? {
                get {
                  return resultMap["DisplayName"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DisplayName")
                }
              }

              public var values: [Value]? {
                get {
                  return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var inputType: InputTypeAll {
                get {
                  return resultMap["InputType"]! as! InputTypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "InputType")
                }
              }

              public var `required`: Bool {
                get {
                  return resultMap["Required"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Required")
                }
              }

              public var hasThumbnail: Bool? {
                get {
                  return resultMap["HasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "HasThumbnail")
                }
              }

              public var attributeType: AttributeTypeAll {
                get {
                  return resultMap["AttributeType"]! as! AttributeTypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeType")
                }
              }

              public var parentId: Uint64? {
                get {
                  return resultMap["ParentID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ParentID")
                }
              }

              public var groupId: Uint64? {
                get {
                  return resultMap["GroupID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "GroupID")
                }
              }

              public var group: Group? {
                get {
                  return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                  get {
                    return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Value: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                    get {
                      return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct Group: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeGroup"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, sort: Uint64) {
                  self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeGroupFields: AttributeGroupFields {
                    get {
                      return AttributeGroupFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }

          public struct VariantPrice: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["VariantPrice"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                GraphQLField("RRPPrice", type: .scalar(Double.self)),
                GraphQLField("BasePrice", type: .scalar(Double.self)),
                GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                GraphQLField("Commission", type: .scalar(Double.self)),
                GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
              self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var variantId: FID {
              get {
                return resultMap["VariantID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "VariantID")
              }
            }

            public var type: VariantPriceType {
              get {
                return resultMap["Type"]! as! VariantPriceType
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var sellingPrice: Double {
              get {
                return resultMap["SellingPrice"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "SellingPrice")
              }
            }

            public var minResellingPrice: Double? {
              get {
                return resultMap["MinResellingPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "MinResellingPrice")
              }
            }

            public var maxResellingPrice: Double? {
              get {
                return resultMap["MaxResellingPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
              }
            }

            public var rrpPrice: Double? {
              get {
                return resultMap["RRPPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "RRPPrice")
              }
            }

            public var basePrice: Double? {
              get {
                return resultMap["BasePrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "BasePrice")
              }
            }

            public var discounts: [Discount]? {
              get {
                return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
              }
            }

            public var commission: Double? {
              get {
                return resultMap["Commission"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Commission")
              }
            }

            public var discountPercentage: Double? {
              get {
                return resultMap["DiscountPercentage"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "DiscountPercentage")
              }
            }

            public var discountedSellingPrice: Double? {
              get {
                return resultMap["DiscountedSellingPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var variantPriceFields: VariantPriceFields {
                get {
                  return VariantPriceFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Discount: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPriceDiscount"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                  GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                  GraphQLField("StartCount", type: .scalar(Int.self)),
                  GraphQLField("EndCount", type: .scalar(Int.self)),
                  GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("Description", type: .object(Description.selections)),
                  GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var countType: VariantPriceDiscountCountType {
                get {
                  return resultMap["CountType"]! as! VariantPriceDiscountCountType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CountType")
                }
              }

              public var discountType: VariantPriceDiscountDiscountType {
                get {
                  return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountType")
                }
              }

              public var startCount: Int? {
                get {
                  return resultMap["StartCount"] as? Int
                }
                set {
                  resultMap.updateValue(newValue, forKey: "StartCount")
                }
              }

              public var endCount: Int? {
                get {
                  return resultMap["EndCount"] as? Int
                }
                set {
                  resultMap.updateValue(newValue, forKey: "EndCount")
                }
              }

              public var variantPriceId: Uint64 {
                get {
                  return resultMap["VariantPriceID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantPriceID")
                }
              }

              public var discountAmount: Double {
                get {
                  return resultMap["DiscountAmount"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountAmount")
                }
              }

              public var description: Description? {
                get {
                  return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                }
              }

              public var createdAt: Time {
                get {
                  return resultMap["CreatedAt"]! as! Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CreatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                  get {
                    return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Description: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["DiscountDescription"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(template: String, parameters: [String]? = nil) {
                  self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var template: String {
                  get {
                    return resultMap["Template"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Template")
                  }
                }

                public var parameters: [String]? {
                  get {
                    return resultMap["Parameters"] as? [String]
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Parameters")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var discountDescriptionFields: DiscountDescriptionFields {
                    get {
                      return DiscountDescriptionFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Variant: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Variant"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("Description", type: .scalar(String.self)),
              GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
              GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
              GraphQLField("Inventory", type: .scalar(Int.self)),
              GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
            self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: FID {
            get {
              return resultMap["ID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var description: String? {
            get {
              return resultMap["Description"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Description")
            }
          }

          public var attributesValues: [AttributesValue]? {
            get {
              return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
            }
          }

          public var variantPrices: [VariantPrice]? {
            get {
              return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
            }
          }

          public var inventory: Int? {
            get {
              return resultMap["Inventory"] as? Int
            }
            set {
              resultMap.updateValue(newValue, forKey: "Inventory")
            }
          }

          public var inventoryIsLow: Bool? {
            get {
              return resultMap["InventoryIsLow"] as? Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "InventoryIsLow")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var variantFields: VariantFields {
              get {
                return VariantFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct AttributesValue: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["AttributeValue"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .scalar(Uint64.self)),
                GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                GraphQLField("Attribute", type: .object(Attribute.selections)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
              self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64? {
              get {
                return resultMap["ID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var value: String {
              get {
                return resultMap["Value"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Value")
              }
            }

            public var attributeId: Uint64 {
              get {
                return resultMap["AttributeID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeID")
              }
            }

            public var attributeHasThumbnail: Bool? {
              get {
                return resultMap["AttributeHasThumbnail"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
              }
            }

            public var sort: Uint64 {
              get {
                return resultMap["Sort"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "Sort")
              }
            }

            public var isVariationAttributeValue: Bool {
              get {
                return resultMap["IsVariationAttributeValue"]! as! Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
              }
            }

            public var attribute: Attribute? {
              get {
                return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attributeValueFields: AttributeValueFields {
                get {
                  return AttributeValueFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Attribute: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Attribute"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("DisplayName", type: .scalar(String.self)),
                  GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                  GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                  GraphQLField("ParentID", type: .scalar(Uint64.self)),
                  GraphQLField("GroupID", type: .scalar(Uint64.self)),
                  GraphQLField("Group", type: .object(Group.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var displayName: String? {
                get {
                  return resultMap["DisplayName"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DisplayName")
                }
              }

              public var values: [Value]? {
                get {
                  return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var inputType: InputTypeAll {
                get {
                  return resultMap["InputType"]! as! InputTypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "InputType")
                }
              }

              public var `required`: Bool {
                get {
                  return resultMap["Required"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Required")
                }
              }

              public var hasThumbnail: Bool? {
                get {
                  return resultMap["HasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "HasThumbnail")
                }
              }

              public var attributeType: AttributeTypeAll {
                get {
                  return resultMap["AttributeType"]! as! AttributeTypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeType")
                }
              }

              public var parentId: Uint64? {
                get {
                  return resultMap["ParentID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ParentID")
                }
              }

              public var groupId: Uint64? {
                get {
                  return resultMap["GroupID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "GroupID")
                }
              }

              public var group: Group? {
                get {
                  return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                  get {
                    return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Value: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                    get {
                      return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct Group: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeGroup"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, sort: Uint64) {
                  self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeGroupFields: AttributeGroupFields {
                    get {
                      return AttributeGroupFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }

          public struct VariantPrice: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["VariantPrice"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                GraphQLField("RRPPrice", type: .scalar(Double.self)),
                GraphQLField("BasePrice", type: .scalar(Double.self)),
                GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                GraphQLField("Commission", type: .scalar(Double.self)),
                GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
              self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var variantId: FID {
              get {
                return resultMap["VariantID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "VariantID")
              }
            }

            public var type: VariantPriceType {
              get {
                return resultMap["Type"]! as! VariantPriceType
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var sellingPrice: Double {
              get {
                return resultMap["SellingPrice"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "SellingPrice")
              }
            }

            public var minResellingPrice: Double? {
              get {
                return resultMap["MinResellingPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "MinResellingPrice")
              }
            }

            public var maxResellingPrice: Double? {
              get {
                return resultMap["MaxResellingPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
              }
            }

            public var rrpPrice: Double? {
              get {
                return resultMap["RRPPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "RRPPrice")
              }
            }

            public var basePrice: Double? {
              get {
                return resultMap["BasePrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "BasePrice")
              }
            }

            public var discounts: [Discount]? {
              get {
                return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
              }
            }

            public var commission: Double? {
              get {
                return resultMap["Commission"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Commission")
              }
            }

            public var discountPercentage: Double? {
              get {
                return resultMap["DiscountPercentage"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "DiscountPercentage")
              }
            }

            public var discountedSellingPrice: Double? {
              get {
                return resultMap["DiscountedSellingPrice"] as? Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var variantPriceFields: VariantPriceFields {
                get {
                  return VariantPriceFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Discount: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPriceDiscount"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                  GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                  GraphQLField("StartCount", type: .scalar(Int.self)),
                  GraphQLField("EndCount", type: .scalar(Int.self)),
                  GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("Description", type: .object(Description.selections)),
                  GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var countType: VariantPriceDiscountCountType {
                get {
                  return resultMap["CountType"]! as! VariantPriceDiscountCountType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CountType")
                }
              }

              public var discountType: VariantPriceDiscountDiscountType {
                get {
                  return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountType")
                }
              }

              public var startCount: Int? {
                get {
                  return resultMap["StartCount"] as? Int
                }
                set {
                  resultMap.updateValue(newValue, forKey: "StartCount")
                }
              }

              public var endCount: Int? {
                get {
                  return resultMap["EndCount"] as? Int
                }
                set {
                  resultMap.updateValue(newValue, forKey: "EndCount")
                }
              }

              public var variantPriceId: Uint64 {
                get {
                  return resultMap["VariantPriceID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantPriceID")
                }
              }

              public var discountAmount: Double {
                get {
                  return resultMap["DiscountAmount"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountAmount")
                }
              }

              public var description: Description? {
                get {
                  return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                }
              }

              public var createdAt: Time {
                get {
                  return resultMap["CreatedAt"]! as! Time
                }
                set {
                  resultMap.updateValue(newValue, forKey: "CreatedAt")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                  get {
                    return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Description: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["DiscountDescription"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(template: String, parameters: [String]? = nil) {
                  self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var template: String {
                  get {
                    return resultMap["Template"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Template")
                  }
                }

                public var parameters: [String]? {
                  get {
                    return resultMap["Parameters"] as? [String]
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Parameters")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var discountDescriptionFields: DiscountDescriptionFields {
                    get {
                      return DiscountDescriptionFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }
        }

        public struct Image: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["File"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("URL", type: .nonNull(.scalar(String.self))),
              GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
              GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
            self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var url: String {
            get {
              return resultMap["URL"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "URL")
            }
          }

          public var idType: FileIDType {
            get {
              return resultMap["IDType"]! as! FileIDType
            }
            set {
              resultMap.updateValue(newValue, forKey: "IDType")
            }
          }

          public var category: FileCategoryAll {
            get {
              return resultMap["Category"]! as! FileCategoryAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Category")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var fileFields: FileFields {
              get {
                return FileFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct AttributeValueImage: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["AttributeValueImage"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Key", type: .nonNull(.scalar(String.self))),
              GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(key: String, images: [Image]) {
            self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var key: String {
            get {
              return resultMap["Key"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Key")
            }
          }

          public var images: [Image] {
            get {
              return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
            }
            set {
              resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var attributeValueImageFields: AttributeValueImageFields {
              get {
                return AttributeValueImageFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Image: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["File"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
              self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var url: String {
              get {
                return resultMap["URL"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "URL")
              }
            }

            public var idType: FileIDType {
              get {
                return resultMap["IDType"]! as! FileIDType
              }
              set {
                resultMap.updateValue(newValue, forKey: "IDType")
              }
            }

            public var category: FileCategoryAll {
              get {
                return resultMap["Category"]! as! FileCategoryAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Category")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var fileFields: FileFields {
                get {
                  return FileFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }

        public struct ReviewProvider: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["ReviewProvider"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
              GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
              GraphQLField("ID", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
            self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var platform: ReviewProviderPlatformAll {
            get {
              return resultMap["Platform"]! as! ReviewProviderPlatformAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Platform")
            }
          }

          public var type: ProductReviewTypeAll {
            get {
              return resultMap["Type"]! as! ProductReviewTypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var id: String {
            get {
              return resultMap["ID"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var reviewProviderFields: ReviewProviderFields {
              get {
                return ReviewProviderFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct ReviewsSummary: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["ReviewsSummary"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(total: Uint64, stars: Double) {
            self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var total: Uint64 {
            get {
              return resultMap["Total"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "Total")
            }
          }

          public var stars: Double {
            get {
              return resultMap["Stars"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Stars")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var reviewsSummaryFields: ReviewsSummaryFields {
              get {
                return ReviewsSummaryFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }
  }

  struct VoucherFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment VoucherFields on Voucher {
        __typename
        ID
        UserID
        User {
          __typename
          ...UserFields
        }
        Name
        Description
        Code
        TotalAmount
        UsedAmount
        LeftAmount
        ExpireAt
        Status
        IsExpired
      }
      """

    public static let possibleTypes: [String] = ["Voucher"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
        GraphQLField("UserID", type: .scalar(Uint64.self)),
        GraphQLField("User", type: .object(User.selections)),
        GraphQLField("Name", type: .scalar(String.self)),
        GraphQLField("Description", type: .scalar(String.self)),
        GraphQLField("Code", type: .nonNull(.scalar(String.self))),
        GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("UsedAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("LeftAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("ExpireAt", type: .scalar(Time.self)),
        GraphQLField("Status", type: .nonNull(.scalar(String.self))),
        GraphQLField("IsExpired", type: .nonNull(.scalar(Bool.self))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(id: Uint64, userId: Uint64? = nil, user: User? = nil, name: String? = nil, description: String? = nil, code: String, totalAmount: Double, usedAmount: Double, leftAmount: Double, expireAt: Time? = nil, status: String, isExpired: Bool) {
      self.init(unsafeResultMap: ["__typename": "Voucher", "ID": id, "UserID": userId, "User": user.flatMap { (value: User) -> ResultMap in value.resultMap }, "Name": name, "Description": description, "Code": code, "TotalAmount": totalAmount, "UsedAmount": usedAmount, "LeftAmount": leftAmount, "ExpireAt": expireAt, "Status": status, "IsExpired": isExpired])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var id: Uint64 {
      get {
        return resultMap["ID"]! as! Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "ID")
      }
    }

    public var userId: Uint64? {
      get {
        return resultMap["UserID"] as? Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "UserID")
      }
    }

    public var user: User? {
      get {
        return (resultMap["User"] as? ResultMap).flatMap { User(unsafeResultMap: $0) }
      }
      set {
        resultMap.updateValue(newValue?.resultMap, forKey: "User")
      }
    }

    public var name: String? {
      get {
        return resultMap["Name"] as? String
      }
      set {
        resultMap.updateValue(newValue, forKey: "Name")
      }
    }

    public var description: String? {
      get {
        return resultMap["Description"] as? String
      }
      set {
        resultMap.updateValue(newValue, forKey: "Description")
      }
    }

    public var code: String {
      get {
        return resultMap["Code"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "Code")
      }
    }

    public var totalAmount: Double {
      get {
        return resultMap["TotalAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "TotalAmount")
      }
    }

    public var usedAmount: Double {
      get {
        return resultMap["UsedAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "UsedAmount")
      }
    }

    public var leftAmount: Double {
      get {
        return resultMap["LeftAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "LeftAmount")
      }
    }

    public var expireAt: Time? {
      get {
        return resultMap["ExpireAt"] as? Time
      }
      set {
        resultMap.updateValue(newValue, forKey: "ExpireAt")
      }
    }

    public var status: String {
      get {
        return resultMap["Status"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "Status")
      }
    }

    public var isExpired: Bool {
      get {
        return resultMap["IsExpired"]! as! Bool
      }
      set {
        resultMap.updateValue(newValue, forKey: "IsExpired")
      }
    }

    public struct User: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["User"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
          GraphQLField("Mobile", type: .scalar(String.self)),
          GraphQLField("MobileCountryCode", type: .scalar(String.self)),
          GraphQLField("IsMobileVerified", type: .scalar(Bool.self)),
          GraphQLField("SecondMobile", type: .scalar(String.self)),
          GraphQLField("SecondMobileCountryCode", type: .scalar(String.self)),
          GraphQLField("Email", type: .scalar(String.self)),
          GraphQLField("IsEmailVerified", type: .scalar(Bool.self)),
          GraphQLField("Avatar", type: .object(Avatar.selections)),
          GraphQLField("Profile", type: .object(Profile.selections)),
          GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
          GraphQLField("ResellerInformation", type: .object(ResellerInformation.selections)),
          GraphQLField("IsUserOnboardingCompleted", type: .scalar(Bool.self)),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(id: Uint64, name: String, mobile: String? = nil, mobileCountryCode: String? = nil, isMobileVerified: Bool? = nil, secondMobile: String? = nil, secondMobileCountryCode: String? = nil, email: String? = nil, isEmailVerified: Bool? = nil, avatar: Avatar? = nil, profile: Profile? = nil, createdAt: Time, resellerInformation: ResellerInformation? = nil, isUserOnboardingCompleted: Bool? = nil) {
        self.init(unsafeResultMap: ["__typename": "User", "ID": id, "Name": name, "Mobile": mobile, "MobileCountryCode": mobileCountryCode, "IsMobileVerified": isMobileVerified, "SecondMobile": secondMobile, "SecondMobileCountryCode": secondMobileCountryCode, "Email": email, "IsEmailVerified": isEmailVerified, "Avatar": avatar.flatMap { (value: Avatar) -> ResultMap in value.resultMap }, "Profile": profile.flatMap { (value: Profile) -> ResultMap in value.resultMap }, "CreatedAt": createdAt, "ResellerInformation": resellerInformation.flatMap { (value: ResellerInformation) -> ResultMap in value.resultMap }, "IsUserOnboardingCompleted": isUserOnboardingCompleted])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var id: Uint64 {
        get {
          return resultMap["ID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ID")
        }
      }

      public var name: String {
        get {
          return resultMap["Name"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Name")
        }
      }

      public var mobile: String? {
        get {
          return resultMap["Mobile"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Mobile")
        }
      }

      public var mobileCountryCode: String? {
        get {
          return resultMap["MobileCountryCode"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "MobileCountryCode")
        }
      }

      public var isMobileVerified: Bool? {
        get {
          return resultMap["IsMobileVerified"] as? Bool
        }
        set {
          resultMap.updateValue(newValue, forKey: "IsMobileVerified")
        }
      }

      public var secondMobile: String? {
        get {
          return resultMap["SecondMobile"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "SecondMobile")
        }
      }

      public var secondMobileCountryCode: String? {
        get {
          return resultMap["SecondMobileCountryCode"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "SecondMobileCountryCode")
        }
      }

      public var email: String? {
        get {
          return resultMap["Email"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Email")
        }
      }

      public var isEmailVerified: Bool? {
        get {
          return resultMap["IsEmailVerified"] as? Bool
        }
        set {
          resultMap.updateValue(newValue, forKey: "IsEmailVerified")
        }
      }

      public var avatar: Avatar? {
        get {
          return (resultMap["Avatar"] as? ResultMap).flatMap { Avatar(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Avatar")
        }
      }

      public var profile: Profile? {
        get {
          return (resultMap["Profile"] as? ResultMap).flatMap { Profile(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Profile")
        }
      }

      public var createdAt: Time {
        get {
          return resultMap["CreatedAt"]! as! Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "CreatedAt")
        }
      }

      public var resellerInformation: ResellerInformation? {
        get {
          return (resultMap["ResellerInformation"] as? ResultMap).flatMap { ResellerInformation(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "ResellerInformation")
        }
      }

      public var isUserOnboardingCompleted: Bool? {
        get {
          return resultMap["IsUserOnboardingCompleted"] as? Bool
        }
        set {
          resultMap.updateValue(newValue, forKey: "IsUserOnboardingCompleted")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var userFields: UserFields {
          get {
            return UserFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }

      public struct Avatar: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["File"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("URL", type: .nonNull(.scalar(String.self))),
            GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
            GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
          self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var url: String {
          get {
            return resultMap["URL"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "URL")
          }
        }

        public var idType: FileIDType {
          get {
            return resultMap["IDType"]! as! FileIDType
          }
          set {
            resultMap.updateValue(newValue, forKey: "IDType")
          }
        }

        public var category: FileCategoryAll {
          get {
            return resultMap["Category"]! as! FileCategoryAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Category")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var fileFields: FileFields {
            get {
              return FileFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }

      public struct Profile: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["UserProfile"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("UserID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Gender", type: .scalar(GenderAll.self)),
            GraphQLField("BirthDate", type: .scalar(Int.self)),
            GraphQLField("Weight", type: .object(Weight.selections)),
            GraphQLField("Height", type: .object(Height.selections)),
            GraphQLField("Lifestyle", type: .scalar(LifestyleAll.self)),
            GraphQLField("FoodIntolerance", type: .list(.nonNull(.scalar(FoodIntoleranceAll.self)))),
            GraphQLField("FoodIntoleranceManual", type: .scalar(String.self)),
            GraphQLField("FavoriteMeat", type: .list(.nonNull(.scalar(FavoriteMeatAll.self)))),
            GraphQLField("MeatFrequency", type: .scalar(MeatFrequencyAll.self)),
            GraphQLField("Activity", type: .scalar(ActivityAll.self)),
            GraphQLField("WeightGoal", type: .object(WeightGoal.selections)),
            GraphQLField("Bmr", type: .scalar(Int.self)),
            GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, userId: Uint64, gender: GenderAll? = nil, birthDate: Int? = nil, weight: Weight? = nil, height: Height? = nil, lifestyle: LifestyleAll? = nil, foodIntolerance: [FoodIntoleranceAll]? = nil, foodIntoleranceManual: String? = nil, favoriteMeat: [FavoriteMeatAll]? = nil, meatFrequency: MeatFrequencyAll? = nil, activity: ActivityAll? = nil, weightGoal: WeightGoal? = nil, bmr: Int? = nil, createdAt: Time, updatedAt: Time? = nil) {
          self.init(unsafeResultMap: ["__typename": "UserProfile", "ID": id, "UserID": userId, "Gender": gender, "BirthDate": birthDate, "Weight": weight.flatMap { (value: Weight) -> ResultMap in value.resultMap }, "Height": height.flatMap { (value: Height) -> ResultMap in value.resultMap }, "Lifestyle": lifestyle, "FoodIntolerance": foodIntolerance, "FoodIntoleranceManual": foodIntoleranceManual, "FavoriteMeat": favoriteMeat, "MeatFrequency": meatFrequency, "Activity": activity, "WeightGoal": weightGoal.flatMap { (value: WeightGoal) -> ResultMap in value.resultMap }, "Bmr": bmr, "CreatedAt": createdAt, "UpdatedAt": updatedAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var userId: Uint64 {
          get {
            return resultMap["UserID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "UserID")
          }
        }

        public var gender: GenderAll? {
          get {
            return resultMap["Gender"] as? GenderAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Gender")
          }
        }

        public var birthDate: Int? {
          get {
            return resultMap["BirthDate"] as? Int
          }
          set {
            resultMap.updateValue(newValue, forKey: "BirthDate")
          }
        }

        public var weight: Weight? {
          get {
            return (resultMap["Weight"] as? ResultMap).flatMap { Weight(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Weight")
          }
        }

        public var height: Height? {
          get {
            return (resultMap["Height"] as? ResultMap).flatMap { Height(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Height")
          }
        }

        public var lifestyle: LifestyleAll? {
          get {
            return resultMap["Lifestyle"] as? LifestyleAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Lifestyle")
          }
        }

        public var foodIntolerance: [FoodIntoleranceAll]? {
          get {
            return resultMap["FoodIntolerance"] as? [FoodIntoleranceAll]
          }
          set {
            resultMap.updateValue(newValue, forKey: "FoodIntolerance")
          }
        }

        public var foodIntoleranceManual: String? {
          get {
            return resultMap["FoodIntoleranceManual"] as? String
          }
          set {
            resultMap.updateValue(newValue, forKey: "FoodIntoleranceManual")
          }
        }

        public var favoriteMeat: [FavoriteMeatAll]? {
          get {
            return resultMap["FavoriteMeat"] as? [FavoriteMeatAll]
          }
          set {
            resultMap.updateValue(newValue, forKey: "FavoriteMeat")
          }
        }

        public var meatFrequency: MeatFrequencyAll? {
          get {
            return resultMap["MeatFrequency"] as? MeatFrequencyAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "MeatFrequency")
          }
        }

        public var activity: ActivityAll? {
          get {
            return resultMap["Activity"] as? ActivityAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Activity")
          }
        }

        public var weightGoal: WeightGoal? {
          get {
            return (resultMap["WeightGoal"] as? ResultMap).flatMap { WeightGoal(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "WeightGoal")
          }
        }

        public var bmr: Int? {
          get {
            return resultMap["Bmr"] as? Int
          }
          set {
            resultMap.updateValue(newValue, forKey: "Bmr")
          }
        }

        public var createdAt: Time {
          get {
            return resultMap["CreatedAt"]! as! Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "CreatedAt")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var userProfileFields: UserProfileFields {
            get {
              return UserProfileFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Weight: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Weight"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Value", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Unit", type: .nonNull(.scalar(WeightUnitAll.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(value: Double, unit: WeightUnitAll) {
            self.init(unsafeResultMap: ["__typename": "Weight", "Value": value, "Unit": unit])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var value: Double {
            get {
              return resultMap["Value"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Value")
            }
          }

          public var unit: WeightUnitAll {
            get {
              return resultMap["Unit"]! as! WeightUnitAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Unit")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var weightFields: WeightFields {
              get {
                return WeightFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct Height: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Height"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Value", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Unit", type: .nonNull(.scalar(HeightUnitAll.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(value: Double, unit: HeightUnitAll) {
            self.init(unsafeResultMap: ["__typename": "Height", "Value": value, "Unit": unit])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var value: Double {
            get {
              return resultMap["Value"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Value")
            }
          }

          public var unit: HeightUnitAll {
            get {
              return resultMap["Unit"]! as! HeightUnitAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Unit")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var heightFields: HeightFields {
              get {
                return HeightFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct WeightGoal: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Weight"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Value", type: .nonNull(.scalar(Double.self))),
              GraphQLField("Unit", type: .nonNull(.scalar(WeightUnitAll.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(value: Double, unit: WeightUnitAll) {
            self.init(unsafeResultMap: ["__typename": "Weight", "Value": value, "Unit": unit])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var value: Double {
            get {
              return resultMap["Value"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Value")
            }
          }

          public var unit: WeightUnitAll {
            get {
              return resultMap["Unit"]! as! WeightUnitAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Unit")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var weightFields: WeightFields {
              get {
                return WeightFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }

      public struct ResellerInformation: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["ResellerInformation"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ResellerStoreName", type: .nonNull(.scalar(String.self))),
            GraphQLField("UnearnedBalance", type: .nonNull(.scalar(Double.self))),
            GraphQLField("ProfitBalance", type: .nonNull(.scalar(Double.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(resellerStoreName: String, unearnedBalance: Double, profitBalance: Double) {
          self.init(unsafeResultMap: ["__typename": "ResellerInformation", "ResellerStoreName": resellerStoreName, "UnearnedBalance": unearnedBalance, "ProfitBalance": profitBalance])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var resellerStoreName: String {
          get {
            return resultMap["ResellerStoreName"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "ResellerStoreName")
          }
        }

        public var unearnedBalance: Double {
          get {
            return resultMap["UnearnedBalance"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "UnearnedBalance")
          }
        }

        public var profitBalance: Double {
          get {
            return resultMap["ProfitBalance"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "ProfitBalance")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var resellerInformationFields: ResellerInformationFields {
            get {
              return ResellerInformationFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }
    }
  }

  struct CartErrorFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment cartErrorFields on CartError {
        __typename
        ItemID
        Message
      }
      """

    public static let possibleTypes: [String] = ["CartError"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
        GraphQLField("Message", type: .nonNull(.scalar(String.self))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(itemId: Uint64, message: String) {
      self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var itemId: Uint64 {
      get {
        return resultMap["ItemID"]! as! Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "ItemID")
      }
    }

    public var message: String {
      get {
        return resultMap["Message"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "Message")
      }
    }
  }

  struct CartFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment cartFields on Cart {
        __typename
        ID
        PayablePrice
        TotalAmount
        DiscountCodeAmount
        HasDiscount
        Discount {
          __typename
          ...DiscountFields
        }
        Discounts {
          __typename
          ...DiscountFields
        }
        DeliveryDiscount {
          __typename
          ...DiscountFields
        }
        Status
        Source
        SourceClose
        ZipCode
        ClosedAt
        UpdatedAt
        CreatedAt
      }
      """

    public static let possibleTypes: [String] = ["Cart"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
        GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
        GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
        GraphQLField("Discount", type: .object(Discount.selections)),
        GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
        GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
        GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
        GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
        GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
        GraphQLField("ZipCode", type: .scalar(String.self)),
        GraphQLField("ClosedAt", type: .scalar(Time.self)),
        GraphQLField("UpdatedAt", type: .scalar(Time.self)),
        GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
      self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var id: Uint64 {
      get {
        return resultMap["ID"]! as! Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "ID")
      }
    }

    public var payablePrice: Double {
      get {
        return resultMap["PayablePrice"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "PayablePrice")
      }
    }

    public var totalAmount: Double {
      get {
        return resultMap["TotalAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "TotalAmount")
      }
    }

    public var discountCodeAmount: Double {
      get {
        return resultMap["DiscountCodeAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
      }
    }

    public var hasDiscount: Bool {
      get {
        return resultMap["HasDiscount"]! as! Bool
      }
      set {
        resultMap.updateValue(newValue, forKey: "HasDiscount")
      }
    }

    public var discount: Discount? {
      get {
        return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
      }
      set {
        resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
      }
    }

    public var discounts: [Discount]? {
      get {
        return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
      }
      set {
        resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
      }
    }

    public var deliveryDiscount: DeliveryDiscount? {
      get {
        return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
      }
      set {
        resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
      }
    }

    public var status: CartStatusAll {
      get {
        return resultMap["Status"]! as! CartStatusAll
      }
      set {
        resultMap.updateValue(newValue, forKey: "Status")
      }
    }

    public var source: SourceAll {
      get {
        return resultMap["Source"]! as! SourceAll
      }
      set {
        resultMap.updateValue(newValue, forKey: "Source")
      }
    }

    public var sourceClose: SourceAll? {
      get {
        return resultMap["SourceClose"] as? SourceAll
      }
      set {
        resultMap.updateValue(newValue, forKey: "SourceClose")
      }
    }

    public var zipCode: String? {
      get {
        return resultMap["ZipCode"] as? String
      }
      set {
        resultMap.updateValue(newValue, forKey: "ZipCode")
      }
    }

    public var closedAt: Time? {
      get {
        return resultMap["ClosedAt"] as? Time
      }
      set {
        resultMap.updateValue(newValue, forKey: "ClosedAt")
      }
    }

    public var updatedAt: Time? {
      get {
        return resultMap["UpdatedAt"] as? Time
      }
      set {
        resultMap.updateValue(newValue, forKey: "UpdatedAt")
      }
    }

    public var createdAt: Time {
      get {
        return resultMap["CreatedAt"]! as! Time
      }
      set {
        resultMap.updateValue(newValue, forKey: "CreatedAt")
      }
    }

    public struct Discount: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Discount"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
          GraphQLField("Description", type: .object(Description.selections)),
          GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
          GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
          GraphQLField("PublicCode", type: .object(PublicCode.selections)),
          GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
        self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var id: Uint64 {
        get {
          return resultMap["ID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ID")
        }
      }

      public var name: String {
        get {
          return resultMap["Name"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Name")
        }
      }

      public var description: Description? {
        get {
          return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Description")
        }
      }

      public var type: DiscountTypeAll {
        get {
          return resultMap["Type"]! as! DiscountTypeAll
        }
        set {
          resultMap.updateValue(newValue, forKey: "Type")
        }
      }

      public var amount: Double {
        get {
          return resultMap["Amount"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "Amount")
        }
      }

      public var publicCode: PublicCode? {
        get {
          return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
        }
      }

      public var updatedAt: Time? {
        get {
          return resultMap["UpdatedAt"] as? Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "UpdatedAt")
        }
      }

      public var createdAt: Time {
        get {
          return resultMap["CreatedAt"]! as! Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "CreatedAt")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var discountFields: DiscountFields {
          get {
            return DiscountFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }

      public struct Description: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["DiscountDescription"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Template", type: .nonNull(.scalar(String.self))),
            GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(template: String, parameters: [String]? = nil) {
          self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var template: String {
          get {
            return resultMap["Template"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Template")
          }
        }

        public var parameters: [String]? {
          get {
            return resultMap["Parameters"] as? [String]
          }
          set {
            resultMap.updateValue(newValue, forKey: "Parameters")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountDescriptionFields: DiscountDescriptionFields {
            get {
              return DiscountDescriptionFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }

      public struct PublicCode: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["DiscountCode"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Code", type: .nonNull(.scalar(String.self))),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, code: String, updatedAt: Time? = nil) {
          self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var code: String {
          get {
            return resultMap["Code"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Code")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountCodeFields: DiscountCodeFields {
            get {
              return DiscountCodeFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }
    }

    public struct Discount: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Discount"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
          GraphQLField("Description", type: .object(Description.selections)),
          GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
          GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
          GraphQLField("PublicCode", type: .object(PublicCode.selections)),
          GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
        self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var id: Uint64 {
        get {
          return resultMap["ID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ID")
        }
      }

      public var name: String {
        get {
          return resultMap["Name"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Name")
        }
      }

      public var description: Description? {
        get {
          return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Description")
        }
      }

      public var type: DiscountTypeAll {
        get {
          return resultMap["Type"]! as! DiscountTypeAll
        }
        set {
          resultMap.updateValue(newValue, forKey: "Type")
        }
      }

      public var amount: Double {
        get {
          return resultMap["Amount"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "Amount")
        }
      }

      public var publicCode: PublicCode? {
        get {
          return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
        }
      }

      public var updatedAt: Time? {
        get {
          return resultMap["UpdatedAt"] as? Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "UpdatedAt")
        }
      }

      public var createdAt: Time {
        get {
          return resultMap["CreatedAt"]! as! Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "CreatedAt")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var discountFields: DiscountFields {
          get {
            return DiscountFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }

      public struct Description: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["DiscountDescription"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Template", type: .nonNull(.scalar(String.self))),
            GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(template: String, parameters: [String]? = nil) {
          self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var template: String {
          get {
            return resultMap["Template"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Template")
          }
        }

        public var parameters: [String]? {
          get {
            return resultMap["Parameters"] as? [String]
          }
          set {
            resultMap.updateValue(newValue, forKey: "Parameters")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountDescriptionFields: DiscountDescriptionFields {
            get {
              return DiscountDescriptionFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }

      public struct PublicCode: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["DiscountCode"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Code", type: .nonNull(.scalar(String.self))),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, code: String, updatedAt: Time? = nil) {
          self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var code: String {
          get {
            return resultMap["Code"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Code")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountCodeFields: DiscountCodeFields {
            get {
              return DiscountCodeFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }
    }

    public struct DeliveryDiscount: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Discount"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Name", type: .nonNull(.scalar(String.self))),
          GraphQLField("Description", type: .object(Description.selections)),
          GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
          GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
          GraphQLField("PublicCode", type: .object(PublicCode.selections)),
          GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
        self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var id: Uint64 {
        get {
          return resultMap["ID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ID")
        }
      }

      public var name: String {
        get {
          return resultMap["Name"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Name")
        }
      }

      public var description: Description? {
        get {
          return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Description")
        }
      }

      public var type: DiscountTypeAll {
        get {
          return resultMap["Type"]! as! DiscountTypeAll
        }
        set {
          resultMap.updateValue(newValue, forKey: "Type")
        }
      }

      public var amount: Double {
        get {
          return resultMap["Amount"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "Amount")
        }
      }

      public var publicCode: PublicCode? {
        get {
          return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
        }
      }

      public var updatedAt: Time? {
        get {
          return resultMap["UpdatedAt"] as? Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "UpdatedAt")
        }
      }

      public var createdAt: Time {
        get {
          return resultMap["CreatedAt"]! as! Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "CreatedAt")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var discountFields: DiscountFields {
          get {
            return DiscountFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }

      public struct Description: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["DiscountDescription"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("Template", type: .nonNull(.scalar(String.self))),
            GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(template: String, parameters: [String]? = nil) {
          self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var template: String {
          get {
            return resultMap["Template"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Template")
          }
        }

        public var parameters: [String]? {
          get {
            return resultMap["Parameters"] as? [String]
          }
          set {
            resultMap.updateValue(newValue, forKey: "Parameters")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountDescriptionFields: DiscountDescriptionFields {
            get {
              return DiscountDescriptionFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }

      public struct PublicCode: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["DiscountCode"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Code", type: .nonNull(.scalar(String.self))),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, code: String, updatedAt: Time? = nil) {
          self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var code: String {
          get {
            return resultMap["Code"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Code")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountCodeFields: DiscountCodeFields {
            get {
              return DiscountCodeFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }
      }
    }
  }

  struct CartResponseFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment cartResponseFields on CartResponse {
        __typename
        Items {
          __typename
          ...cartItemFields
        }
        Info {
          __typename
          ...cartFields
        }
        Errors {
          __typename
          ...cartErrorFields
        }
      }
      """

    public static let possibleTypes: [String] = ["CartResponse"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("Items", type: .list(.nonNull(.object(Item.selections)))),
        GraphQLField("Info", type: .nonNull(.object(Info.selections))),
        GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(items: [Item]? = nil, info: Info, errors: [Error]? = nil) {
      self.init(unsafeResultMap: ["__typename": "CartResponse", "Items": items.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, "Info": info.resultMap, "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var items: [Item]? {
      get {
        return (resultMap["Items"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Item] in value.map { (value: ResultMap) -> Item in Item(unsafeResultMap: value) } }
      }
      set {
        resultMap.updateValue(newValue.flatMap { (value: [Item]) -> [ResultMap] in value.map { (value: Item) -> ResultMap in value.resultMap } }, forKey: "Items")
      }
    }

    public var info: Info {
      get {
        return Info(unsafeResultMap: resultMap["Info"]! as! ResultMap)
      }
      set {
        resultMap.updateValue(newValue.resultMap, forKey: "Info")
      }
    }

    public var errors: [Error]? {
      get {
        return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
      }
      set {
        resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
      }
    }

    public struct Item: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["CartItem"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("CartID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Variant", type: .nonNull(.object(Variant.selections))),
          GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
          GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
          GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
          GraphQLField("Quantity", type: .nonNull(.scalar(Int.self))),
          GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
          GraphQLField("IsSubscription", type: .nonNull(.scalar(Bool.self))),
          GraphQLField("OrderShipments", type: .nonNull(.list(.nonNull(.scalar(Time.self))))),
          GraphQLField("CartToken", type: .scalar(String.self)),
          GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(id: Uint64, cartId: Uint64, variant: Variant, variantId: FID, variantPriceId: Uint64, sellingPrice: Double, discountAmount: Double, quantity: Int, source: SourceAll, isSubscription: Bool, orderShipments: [Time], cartToken: String? = nil, updatedAt: Time? = nil, createdAt: Time) {
        self.init(unsafeResultMap: ["__typename": "CartItem", "ID": id, "CartID": cartId, "Variant": variant.resultMap, "VariantID": variantId, "VariantPriceID": variantPriceId, "SellingPrice": sellingPrice, "DiscountAmount": discountAmount, "Quantity": quantity, "Source": source, "IsSubscription": isSubscription, "OrderShipments": orderShipments, "CartToken": cartToken, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var id: Uint64 {
        get {
          return resultMap["ID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ID")
        }
      }

      public var cartId: Uint64 {
        get {
          return resultMap["CartID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "CartID")
        }
      }

      public var variant: Variant {
        get {
          return Variant(unsafeResultMap: resultMap["Variant"]! as! ResultMap)
        }
        set {
          resultMap.updateValue(newValue.resultMap, forKey: "Variant")
        }
      }

      public var variantId: FID {
        get {
          return resultMap["VariantID"]! as! FID
        }
        set {
          resultMap.updateValue(newValue, forKey: "VariantID")
        }
      }

      public var variantPriceId: Uint64 {
        get {
          return resultMap["VariantPriceID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "VariantPriceID")
        }
      }

      public var sellingPrice: Double {
        get {
          return resultMap["SellingPrice"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "SellingPrice")
        }
      }

      public var discountAmount: Double {
        get {
          return resultMap["DiscountAmount"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "DiscountAmount")
        }
      }

      public var quantity: Int {
        get {
          return resultMap["Quantity"]! as! Int
        }
        set {
          resultMap.updateValue(newValue, forKey: "Quantity")
        }
      }

      public var source: SourceAll {
        get {
          return resultMap["Source"]! as! SourceAll
        }
        set {
          resultMap.updateValue(newValue, forKey: "Source")
        }
      }

      public var isSubscription: Bool {
        get {
          return resultMap["IsSubscription"]! as! Bool
        }
        set {
          resultMap.updateValue(newValue, forKey: "IsSubscription")
        }
      }

      public var orderShipments: [Time] {
        get {
          return resultMap["OrderShipments"]! as! [Time]
        }
        set {
          resultMap.updateValue(newValue, forKey: "OrderShipments")
        }
      }

      public var cartToken: String? {
        get {
          return resultMap["CartToken"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "CartToken")
        }
      }

      public var updatedAt: Time? {
        get {
          return resultMap["UpdatedAt"] as? Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "UpdatedAt")
        }
      }

      public var createdAt: Time {
        get {
          return resultMap["CreatedAt"]! as! Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "CreatedAt")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var cartItemFields: CartItemFields {
          get {
            return CartItemFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }

      public struct Variant: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["Variant"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
            GraphQLField("Description", type: .scalar(String.self)),
            GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
            GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
            GraphQLField("Product", type: .object(Product.selections)),
            GraphQLField("Inventory", type: .scalar(Int.self)),
            GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, product: Product? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
          self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Product": product.flatMap { (value: Product) -> ResultMap in value.resultMap }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: FID {
          get {
            return resultMap["ID"]! as! FID
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var description: String? {
          get {
            return resultMap["Description"] as? String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Description")
          }
        }

        public var attributesValues: [AttributesValue]? {
          get {
            return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
          }
        }

        public var variantPrices: [VariantPrice]? {
          get {
            return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
          }
          set {
            resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
          }
        }

        public var product: Product? {
          get {
            return (resultMap["Product"] as? ResultMap).flatMap { Product(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Product")
          }
        }

        public var inventory: Int? {
          get {
            return resultMap["Inventory"] as? Int
          }
          set {
            resultMap.updateValue(newValue, forKey: "Inventory")
          }
        }

        public var inventoryIsLow: Bool? {
          get {
            return resultMap["InventoryIsLow"] as? Bool
          }
          set {
            resultMap.updateValue(newValue, forKey: "InventoryIsLow")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var orderVariantFields: OrderVariantFields {
            get {
              return OrderVariantFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct AttributesValue: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["AttributeValue"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .scalar(Uint64.self)),
              GraphQLField("Value", type: .nonNull(.scalar(String.self))),
              GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
              GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
              GraphQLField("Attribute", type: .object(Attribute.selections)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
            self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64? {
            get {
              return resultMap["ID"] as? Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var value: String {
            get {
              return resultMap["Value"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Value")
            }
          }

          public var attributeId: Uint64 {
            get {
              return resultMap["AttributeID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "AttributeID")
            }
          }

          public var attributeHasThumbnail: Bool? {
            get {
              return resultMap["AttributeHasThumbnail"] as? Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
            }
          }

          public var sort: Uint64 {
            get {
              return resultMap["Sort"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "Sort")
            }
          }

          public var isVariationAttributeValue: Bool {
            get {
              return resultMap["IsVariationAttributeValue"]! as! Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
            }
          }

          public var attribute: Attribute? {
            get {
              return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var attributeValueFields: AttributeValueFields {
              get {
                return AttributeValueFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Attribute: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Attribute"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("DisplayName", type: .scalar(String.self)),
                GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                GraphQLField("ParentID", type: .scalar(Uint64.self)),
                GraphQLField("GroupID", type: .scalar(Uint64.self)),
                GraphQLField("Group", type: .object(Group.selections)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
              self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var displayName: String? {
              get {
                return resultMap["DisplayName"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "DisplayName")
              }
            }

            public var values: [Value]? {
              get {
                return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
              }
            }

            public var description: String {
              get {
                return resultMap["Description"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var inputType: InputTypeAll {
              get {
                return resultMap["InputType"]! as! InputTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "InputType")
              }
            }

            public var `required`: Bool {
              get {
                return resultMap["Required"]! as! Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "Required")
              }
            }

            public var hasThumbnail: Bool? {
              get {
                return resultMap["HasThumbnail"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "HasThumbnail")
              }
            }

            public var attributeType: AttributeTypeAll {
              get {
                return resultMap["AttributeType"]! as! AttributeTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeType")
              }
            }

            public var parentId: Uint64? {
              get {
                return resultMap["ParentID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ParentID")
              }
            }

            public var groupId: Uint64? {
              get {
                return resultMap["GroupID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "GroupID")
              }
            }

            public var group: Group? {
              get {
                return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Group")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                get {
                  return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Value: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                  get {
                    return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }

            public struct Group: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeGroup"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, name: String, sort: Uint64) {
                self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeGroupFields: AttributeGroupFields {
                  get {
                    return AttributeGroupFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct VariantPrice: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["VariantPrice"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
              GraphQLField("Description", type: .scalar(String.self)),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
              GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
              GraphQLField("RRPPrice", type: .scalar(Double.self)),
              GraphQLField("BasePrice", type: .scalar(Double.self)),
              GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
              GraphQLField("Commission", type: .scalar(Double.self)),
              GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
              GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
            self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var variantId: FID {
            get {
              return resultMap["VariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "VariantID")
            }
          }

          public var type: VariantPriceType {
            get {
              return resultMap["Type"]! as! VariantPriceType
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var description: String? {
            get {
              return resultMap["Description"] as? String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Description")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var minResellingPrice: Double? {
            get {
              return resultMap["MinResellingPrice"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "MinResellingPrice")
            }
          }

          public var maxResellingPrice: Double? {
            get {
              return resultMap["MaxResellingPrice"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
            }
          }

          public var rrpPrice: Double? {
            get {
              return resultMap["RRPPrice"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "RRPPrice")
            }
          }

          public var basePrice: Double? {
            get {
              return resultMap["BasePrice"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "BasePrice")
            }
          }

          public var discounts: [Discount]? {
            get {
              return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
            }
          }

          public var commission: Double? {
            get {
              return resultMap["Commission"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Commission")
            }
          }

          public var discountPercentage: Double? {
            get {
              return resultMap["DiscountPercentage"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountPercentage")
            }
          }

          public var discountedSellingPrice: Double? {
            get {
              return resultMap["DiscountedSellingPrice"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var variantPriceFields: VariantPriceFields {
              get {
                return VariantPriceFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Discount: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["VariantPriceDiscount"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                GraphQLField("StartCount", type: .scalar(Int.self)),
                GraphQLField("EndCount", type: .scalar(Int.self)),
                GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                GraphQLField("Description", type: .object(Description.selections)),
                GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
              self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var countType: VariantPriceDiscountCountType {
              get {
                return resultMap["CountType"]! as! VariantPriceDiscountCountType
              }
              set {
                resultMap.updateValue(newValue, forKey: "CountType")
              }
            }

            public var discountType: VariantPriceDiscountDiscountType {
              get {
                return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
              }
              set {
                resultMap.updateValue(newValue, forKey: "DiscountType")
              }
            }

            public var startCount: Int? {
              get {
                return resultMap["StartCount"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "StartCount")
              }
            }

            public var endCount: Int? {
              get {
                return resultMap["EndCount"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "EndCount")
              }
            }

            public var variantPriceId: Uint64 {
              get {
                return resultMap["VariantPriceID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "VariantPriceID")
              }
            }

            public var discountAmount: Double {
              get {
                return resultMap["DiscountAmount"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "DiscountAmount")
              }
            }

            public var description: Description? {
              get {
                return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Description")
              }
            }

            public var createdAt: Time {
              get {
                return resultMap["CreatedAt"]! as! Time
              }
              set {
                resultMap.updateValue(newValue, forKey: "CreatedAt")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                get {
                  return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Description: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["DiscountDescription"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(template: String, parameters: [String]? = nil) {
                self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var template: String {
                get {
                  return resultMap["Template"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Template")
                }
              }

              public var parameters: [String]? {
                get {
                  return resultMap["Parameters"] as? [String]
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Parameters")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var discountDescriptionFields: DiscountDescriptionFields {
                  get {
                    return DiscountDescriptionFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }
        }

        public struct Product: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["Product"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("Name", type: .nonNull(.scalar(String.self))),
              GraphQLField("Description", type: .nonNull(.scalar(String.self))),
              GraphQLField("Status", type: .nonNull(.scalar(String.self))),
              GraphQLField("SingleShipping", type: .scalar(Bool.self)),
              GraphQLField("Type", type: .nonNull(.scalar(TypeAll.self))),
              GraphQLField("CategoryID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Category", type: .nonNull(.object(Category.selections))),
              GraphQLField("Tags", type: .nonNull(.list(.nonNull(.scalar(String.self))))),
              GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
              GraphQLField("Badge", type: .list(.nonNull(.object(Badge.selections)))),
              GraphQLField("NoteIDs", type: .nonNull(.list(.nonNull(.scalar(Uint64.self))))),
              GraphQLField("Notes", type: .nonNull(.list(.nonNull(.object(Note.selections))))),
              GraphQLField("DefaultVariantID", type: .nonNull(.scalar(FID.self))),
              GraphQLField("DefaultVariant", type: .object(DefaultVariant.selections)),
              GraphQLField("Variants", type: .list(.nonNull(.object(Variant.selections)))),
              GraphQLField("Likes", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
              GraphQLField("RRPPrice", type: .scalar(Double.self)),
              GraphQLField("Commission", type: .scalar(Double.self)),
              GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
              GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
              GraphQLField("Images", type: .list(.nonNull(.object(Image.selections)))),
              GraphQLField("AttributeValueImages", type: .list(.nonNull(.object(AttributeValueImage.selections)))),
              GraphQLField("ReviewProvider", type: .object(ReviewProvider.selections)),
              GraphQLField("ReviewsSummary", type: .object(ReviewsSummary.selections)),
              GraphQLField("ProductLink", type: .nonNull(.scalar(String.self))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: FID, name: String, description: String, status: String, singleShipping: Bool? = nil, type: TypeAll, categoryId: Uint64, category: Category, tags: [String], attributesValues: [AttributesValue]? = nil, badge: [Badge]? = nil, noteIDs: [Uint64], notes: [Note], defaultVariantId: FID, defaultVariant: DefaultVariant? = nil, variants: [Variant]? = nil, likes: Uint64, sellingPrice: Double, rrpPrice: Double? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil, images: [Image]? = nil, attributeValueImages: [AttributeValueImage]? = nil, reviewProvider: ReviewProvider? = nil, reviewsSummary: ReviewsSummary? = nil, productLink: String) {
            self.init(unsafeResultMap: ["__typename": "Product", "ID": id, "Name": name, "Description": description, "Status": status, "SingleShipping": singleShipping, "Type": type, "CategoryID": categoryId, "Category": category.resultMap, "Tags": tags, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "Badge": badge.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, "NoteIDs": noteIDs, "Notes": notes.map { (value: Note) -> ResultMap in value.resultMap }, "DefaultVariantID": defaultVariantId, "DefaultVariant": defaultVariant.flatMap { (value: DefaultVariant) -> ResultMap in value.resultMap }, "Variants": variants.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, "Likes": likes, "SellingPrice": sellingPrice, "RRPPrice": rrpPrice, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice, "Images": images.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, "AttributeValueImages": attributeValueImages.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, "ReviewProvider": reviewProvider.flatMap { (value: ReviewProvider) -> ResultMap in value.resultMap }, "ReviewsSummary": reviewsSummary.flatMap { (value: ReviewsSummary) -> ResultMap in value.resultMap }, "ProductLink": productLink])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: FID {
            get {
              return resultMap["ID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var name: String {
            get {
              return resultMap["Name"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Name")
            }
          }

          public var description: String {
            get {
              return resultMap["Description"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Description")
            }
          }

          public var status: String {
            get {
              return resultMap["Status"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Status")
            }
          }

          public var singleShipping: Bool? {
            get {
              return resultMap["SingleShipping"] as? Bool
            }
            set {
              resultMap.updateValue(newValue, forKey: "SingleShipping")
            }
          }

          public var type: TypeAll {
            get {
              return resultMap["Type"]! as! TypeAll
            }
            set {
              resultMap.updateValue(newValue, forKey: "Type")
            }
          }

          public var categoryId: Uint64 {
            get {
              return resultMap["CategoryID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "CategoryID")
            }
          }

          public var category: Category {
            get {
              return Category(unsafeResultMap: resultMap["Category"]! as! ResultMap)
            }
            set {
              resultMap.updateValue(newValue.resultMap, forKey: "Category")
            }
          }

          public var tags: [String] {
            get {
              return resultMap["Tags"]! as! [String]
            }
            set {
              resultMap.updateValue(newValue, forKey: "Tags")
            }
          }

          public var attributesValues: [AttributesValue]? {
            get {
              return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
            }
          }

          public var badge: [Badge]? {
            get {
              return (resultMap["Badge"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Badge] in value.map { (value: ResultMap) -> Badge in Badge(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Badge]) -> [ResultMap] in value.map { (value: Badge) -> ResultMap in value.resultMap } }, forKey: "Badge")
            }
          }

          public var noteIDs: [Uint64] {
            get {
              return resultMap["NoteIDs"]! as! [Uint64]
            }
            set {
              resultMap.updateValue(newValue, forKey: "NoteIDs")
            }
          }

          public var notes: [Note] {
            get {
              return (resultMap["Notes"] as! [ResultMap]).map { (value: ResultMap) -> Note in Note(unsafeResultMap: value) }
            }
            set {
              resultMap.updateValue(newValue.map { (value: Note) -> ResultMap in value.resultMap }, forKey: "Notes")
            }
          }

          public var defaultVariantId: FID {
            get {
              return resultMap["DefaultVariantID"]! as! FID
            }
            set {
              resultMap.updateValue(newValue, forKey: "DefaultVariantID")
            }
          }

          public var defaultVariant: DefaultVariant? {
            get {
              return (resultMap["DefaultVariant"] as? ResultMap).flatMap { DefaultVariant(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "DefaultVariant")
            }
          }

          public var variants: [Variant]? {
            get {
              return (resultMap["Variants"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Variant] in value.map { (value: ResultMap) -> Variant in Variant(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Variant]) -> [ResultMap] in value.map { (value: Variant) -> ResultMap in value.resultMap } }, forKey: "Variants")
            }
          }

          public var likes: Uint64 {
            get {
              return resultMap["Likes"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "Likes")
            }
          }

          public var sellingPrice: Double {
            get {
              return resultMap["SellingPrice"]! as! Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "SellingPrice")
            }
          }

          public var rrpPrice: Double? {
            get {
              return resultMap["RRPPrice"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "RRPPrice")
            }
          }

          public var commission: Double? {
            get {
              return resultMap["Commission"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "Commission")
            }
          }

          public var discountPercentage: Double? {
            get {
              return resultMap["DiscountPercentage"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountPercentage")
            }
          }

          public var discountedSellingPrice: Double? {
            get {
              return resultMap["DiscountedSellingPrice"] as? Double
            }
            set {
              resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
            }
          }

          public var images: [Image]? {
            get {
              return (resultMap["Images"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Image] in value.map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [Image]) -> [ResultMap] in value.map { (value: Image) -> ResultMap in value.resultMap } }, forKey: "Images")
            }
          }

          public var attributeValueImages: [AttributeValueImage]? {
            get {
              return (resultMap["AttributeValueImages"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributeValueImage] in value.map { (value: ResultMap) -> AttributeValueImage in AttributeValueImage(unsafeResultMap: value) } }
            }
            set {
              resultMap.updateValue(newValue.flatMap { (value: [AttributeValueImage]) -> [ResultMap] in value.map { (value: AttributeValueImage) -> ResultMap in value.resultMap } }, forKey: "AttributeValueImages")
            }
          }

          public var reviewProvider: ReviewProvider? {
            get {
              return (resultMap["ReviewProvider"] as? ResultMap).flatMap { ReviewProvider(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "ReviewProvider")
            }
          }

          public var reviewsSummary: ReviewsSummary? {
            get {
              return (resultMap["ReviewsSummary"] as? ResultMap).flatMap { ReviewsSummary(unsafeResultMap: $0) }
            }
            set {
              resultMap.updateValue(newValue?.resultMap, forKey: "ReviewsSummary")
            }
          }

          public var productLink: String {
            get {
              return resultMap["ProductLink"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "ProductLink")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var productFields: ProductFields {
              get {
                return ProductFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }

          public struct Category: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Category"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                GraphQLField("MainParent", type: .object(MainParent.selections)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: String, mainParent: MainParent? = nil) {
              self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description, "MainParent": mainParent.flatMap { (value: MainParent) -> ResultMap in value.resultMap }])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: String {
              get {
                return resultMap["Description"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var mainParent: MainParent? {
              get {
                return (resultMap["MainParent"] as? ResultMap).flatMap { MainParent(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "MainParent")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var categoryFields: CategoryFields {
                get {
                  return CategoryFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct MainParent: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Category"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, name: String, description: String) {
                self.init(unsafeResultMap: ["__typename": "Category", "ID": id, "Name": name, "Description": description])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }
            }
          }

          public struct AttributesValue: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["AttributeValue"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .scalar(Uint64.self)),
                GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                GraphQLField("Attribute", type: .object(Attribute.selections)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
              self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64? {
              get {
                return resultMap["ID"] as? Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var value: String {
              get {
                return resultMap["Value"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Value")
              }
            }

            public var attributeId: Uint64 {
              get {
                return resultMap["AttributeID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeID")
              }
            }

            public var attributeHasThumbnail: Bool? {
              get {
                return resultMap["AttributeHasThumbnail"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
              }
            }

            public var sort: Uint64 {
              get {
                return resultMap["Sort"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "Sort")
              }
            }

            public var isVariationAttributeValue: Bool {
              get {
                return resultMap["IsVariationAttributeValue"]! as! Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
              }
            }

            public var attribute: Attribute? {
              get {
                return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
              }
              set {
                resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attributeValueFields: AttributeValueFields {
                get {
                  return AttributeValueFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Attribute: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["Attribute"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                  GraphQLField("DisplayName", type: .scalar(String.self)),
                  GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                  GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                  GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                  GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                  GraphQLField("ParentID", type: .scalar(Uint64.self)),
                  GraphQLField("GroupID", type: .scalar(Uint64.self)),
                  GraphQLField("Group", type: .object(Group.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var name: String {
                get {
                  return resultMap["Name"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Name")
                }
              }

              public var displayName: String? {
                get {
                  return resultMap["DisplayName"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DisplayName")
                }
              }

              public var values: [Value]? {
                get {
                  return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                }
              }

              public var description: String {
                get {
                  return resultMap["Description"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var inputType: InputTypeAll {
                get {
                  return resultMap["InputType"]! as! InputTypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "InputType")
                }
              }

              public var `required`: Bool {
                get {
                  return resultMap["Required"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Required")
                }
              }

              public var hasThumbnail: Bool? {
                get {
                  return resultMap["HasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "HasThumbnail")
                }
              }

              public var attributeType: AttributeTypeAll {
                get {
                  return resultMap["AttributeType"]! as! AttributeTypeAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeType")
                }
              }

              public var parentId: Uint64? {
                get {
                  return resultMap["ParentID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ParentID")
                }
              }

              public var groupId: Uint64? {
                get {
                  return resultMap["GroupID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "GroupID")
                }
              }

              public var group: Group? {
                get {
                  return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                  get {
                    return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Value: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeValue"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .scalar(Uint64.self)),
                    GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                    GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                  self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64? {
                  get {
                    return resultMap["ID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var value: String {
                  get {
                    return resultMap["Value"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Value")
                  }
                }

                public var attributeId: Uint64 {
                  get {
                    return resultMap["AttributeID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeID")
                  }
                }

                public var attributeHasThumbnail: Bool? {
                  get {
                    return resultMap["AttributeHasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var isVariationAttributeValue: Bool {
                  get {
                    return resultMap["IsVariationAttributeValue"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                    get {
                      return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }

              public struct Group: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["AttributeGroup"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, sort: Uint64) {
                  self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var sort: Uint64 {
                  get {
                    return resultMap["Sort"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Sort")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeGroupFields: AttributeGroupFields {
                    get {
                      return AttributeGroupFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }
              }
            }
          }

          public struct Badge: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Badge"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("Image", type: .nonNull(.object(Image.selections))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, description: String? = nil, image: Image) {
              self.init(unsafeResultMap: ["__typename": "Badge", "ID": id, "Name": name, "Description": description, "Image": image.resultMap])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var image: Image {
              get {
                return Image(unsafeResultMap: resultMap["Image"]! as! ResultMap)
              }
              set {
                resultMap.updateValue(newValue.resultMap, forKey: "Image")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var badgeFields: BadgeFields {
                get {
                  return BadgeFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Image: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["File"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                  GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                  GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var url: String {
                get {
                  return resultMap["URL"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "URL")
                }
              }

              public var idType: FileIDType {
                get {
                  return resultMap["IDType"]! as! FileIDType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IDType")
                }
              }

              public var category: FileCategoryAll {
                get {
                  return resultMap["Category"]! as! FileCategoryAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Category")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var fileFields: FileFields {
                  get {
                    return FileFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct Note: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["StaticPage"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                GraphQLField("Position", type: .nonNull(.scalar(String.self))),
                GraphQLField("Content", type: .nonNull(.scalar(String.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, name: String, position: String, content: String) {
              self.init(unsafeResultMap: ["__typename": "StaticPage", "ID": id, "Name": name, "Position": position, "Content": content])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var name: String {
              get {
                return resultMap["Name"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Name")
              }
            }

            public var position: String {
              get {
                return resultMap["Position"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Position")
              }
            }

            public var content: String {
              get {
                return resultMap["Content"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Content")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var staticPageFields: StaticPageFields {
                get {
                  return StaticPageFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct DefaultVariant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var variantFields: VariantFields {
                get {
                  return VariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }
          }

          public struct Variant: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["Variant"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(FID.self))),
                GraphQLField("Description", type: .scalar(String.self)),
                GraphQLField("AttributesValues", type: .list(.nonNull(.object(AttributesValue.selections)))),
                GraphQLField("VariantPrices", type: .list(.nonNull(.object(VariantPrice.selections)))),
                GraphQLField("Inventory", type: .scalar(Int.self)),
                GraphQLField("InventoryIsLow", type: .scalar(Bool.self)),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: FID, description: String? = nil, attributesValues: [AttributesValue]? = nil, variantPrices: [VariantPrice]? = nil, inventory: Int? = nil, inventoryIsLow: Bool? = nil) {
              self.init(unsafeResultMap: ["__typename": "Variant", "ID": id, "Description": description, "AttributesValues": attributesValues.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, "VariantPrices": variantPrices.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, "Inventory": inventory, "InventoryIsLow": inventoryIsLow])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: FID {
              get {
                return resultMap["ID"]! as! FID
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var description: String? {
              get {
                return resultMap["Description"] as? String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Description")
              }
            }

            public var attributesValues: [AttributesValue]? {
              get {
                return (resultMap["AttributesValues"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [AttributesValue] in value.map { (value: ResultMap) -> AttributesValue in AttributesValue(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [AttributesValue]) -> [ResultMap] in value.map { (value: AttributesValue) -> ResultMap in value.resultMap } }, forKey: "AttributesValues")
              }
            }

            public var variantPrices: [VariantPrice]? {
              get {
                return (resultMap["VariantPrices"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [VariantPrice] in value.map { (value: ResultMap) -> VariantPrice in VariantPrice(unsafeResultMap: value) } }
              }
              set {
                resultMap.updateValue(newValue.flatMap { (value: [VariantPrice]) -> [ResultMap] in value.map { (value: VariantPrice) -> ResultMap in value.resultMap } }, forKey: "VariantPrices")
              }
            }

            public var inventory: Int? {
              get {
                return resultMap["Inventory"] as? Int
              }
              set {
                resultMap.updateValue(newValue, forKey: "Inventory")
              }
            }

            public var inventoryIsLow: Bool? {
              get {
                return resultMap["InventoryIsLow"] as? Bool
              }
              set {
                resultMap.updateValue(newValue, forKey: "InventoryIsLow")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var variantFields: VariantFields {
                get {
                  return VariantFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct AttributesValue: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["AttributeValue"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .scalar(Uint64.self)),
                  GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                  GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                  GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                  GraphQLField("Attribute", type: .object(Attribute.selections)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool, attribute: Attribute? = nil) {
                self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue, "Attribute": attribute.flatMap { (value: Attribute) -> ResultMap in value.resultMap }])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64? {
                get {
                  return resultMap["ID"] as? Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var value: String {
                get {
                  return resultMap["Value"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Value")
                }
              }

              public var attributeId: Uint64 {
                get {
                  return resultMap["AttributeID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeID")
                }
              }

              public var attributeHasThumbnail: Bool? {
                get {
                  return resultMap["AttributeHasThumbnail"] as? Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                }
              }

              public var sort: Uint64 {
                get {
                  return resultMap["Sort"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Sort")
                }
              }

              public var isVariationAttributeValue: Bool {
                get {
                  return resultMap["IsVariationAttributeValue"]! as! Bool
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                }
              }

              public var attribute: Attribute? {
                get {
                  return (resultMap["Attribute"] as? ResultMap).flatMap { Attribute(unsafeResultMap: $0) }
                }
                set {
                  resultMap.updateValue(newValue?.resultMap, forKey: "Attribute")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var attributeValueFields: AttributeValueFields {
                  get {
                    return AttributeValueFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Attribute: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["Attribute"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                    GraphQLField("DisplayName", type: .scalar(String.self)),
                    GraphQLField("Values", type: .list(.nonNull(.object(Value.selections)))),
                    GraphQLField("Description", type: .nonNull(.scalar(String.self))),
                    GraphQLField("InputType", type: .nonNull(.scalar(InputTypeAll.self))),
                    GraphQLField("Required", type: .nonNull(.scalar(Bool.self))),
                    GraphQLField("HasThumbnail", type: .scalar(Bool.self)),
                    GraphQLField("AttributeType", type: .nonNull(.scalar(AttributeTypeAll.self))),
                    GraphQLField("ParentID", type: .scalar(Uint64.self)),
                    GraphQLField("GroupID", type: .scalar(Uint64.self)),
                    GraphQLField("Group", type: .object(Group.selections)),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, name: String, displayName: String? = nil, values: [Value]? = nil, description: String, inputType: InputTypeAll, `required`: Bool, hasThumbnail: Bool? = nil, attributeType: AttributeTypeAll, parentId: Uint64? = nil, groupId: Uint64? = nil, group: Group? = nil) {
                  self.init(unsafeResultMap: ["__typename": "Attribute", "ID": id, "Name": name, "DisplayName": displayName, "Values": values.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, "Description": description, "InputType": inputType, "Required": `required`, "HasThumbnail": hasThumbnail, "AttributeType": attributeType, "ParentID": parentId, "GroupID": groupId, "Group": group.flatMap { (value: Group) -> ResultMap in value.resultMap }])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var name: String {
                  get {
                    return resultMap["Name"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Name")
                  }
                }

                public var displayName: String? {
                  get {
                    return resultMap["DisplayName"] as? String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DisplayName")
                  }
                }

                public var values: [Value]? {
                  get {
                    return (resultMap["Values"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Value] in value.map { (value: ResultMap) -> Value in Value(unsafeResultMap: value) } }
                  }
                  set {
                    resultMap.updateValue(newValue.flatMap { (value: [Value]) -> [ResultMap] in value.map { (value: Value) -> ResultMap in value.resultMap } }, forKey: "Values")
                  }
                }

                public var description: String {
                  get {
                    return resultMap["Description"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Description")
                  }
                }

                public var inputType: InputTypeAll {
                  get {
                    return resultMap["InputType"]! as! InputTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "InputType")
                  }
                }

                public var `required`: Bool {
                  get {
                    return resultMap["Required"]! as! Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "Required")
                  }
                }

                public var hasThumbnail: Bool? {
                  get {
                    return resultMap["HasThumbnail"] as? Bool
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "HasThumbnail")
                  }
                }

                public var attributeType: AttributeTypeAll {
                  get {
                    return resultMap["AttributeType"]! as! AttributeTypeAll
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "AttributeType")
                  }
                }

                public var parentId: Uint64? {
                  get {
                    return resultMap["ParentID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ParentID")
                  }
                }

                public var groupId: Uint64? {
                  get {
                    return resultMap["GroupID"] as? Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "GroupID")
                  }
                }

                public var group: Group? {
                  get {
                    return (resultMap["Group"] as? ResultMap).flatMap { Group(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Group")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var attributeValueAtrributeFields: AttributeValueAtrributeFields {
                    get {
                      return AttributeValueAtrributeFields(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Value: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeValue"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .scalar(Uint64.self)),
                      GraphQLField("Value", type: .nonNull(.scalar(String.self))),
                      GraphQLField("AttributeID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("AttributeHasThumbnail", type: .scalar(Bool.self)),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("IsVariationAttributeValue", type: .nonNull(.scalar(Bool.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64? = nil, value: String, attributeId: Uint64, attributeHasThumbnail: Bool? = nil, sort: Uint64, isVariationAttributeValue: Bool) {
                    self.init(unsafeResultMap: ["__typename": "AttributeValue", "ID": id, "Value": value, "AttributeID": attributeId, "AttributeHasThumbnail": attributeHasThumbnail, "Sort": sort, "IsVariationAttributeValue": isVariationAttributeValue])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64? {
                    get {
                      return resultMap["ID"] as? Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var value: String {
                    get {
                      return resultMap["Value"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Value")
                    }
                  }

                  public var attributeId: Uint64 {
                    get {
                      return resultMap["AttributeID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeID")
                    }
                  }

                  public var attributeHasThumbnail: Bool? {
                    get {
                      return resultMap["AttributeHasThumbnail"] as? Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "AttributeHasThumbnail")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var isVariationAttributeValue: Bool {
                    get {
                      return resultMap["IsVariationAttributeValue"]! as! Bool
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "IsVariationAttributeValue")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attibuteValueAttributeAttributeValueFields: AttibuteValueAttributeAttributeValueFields {
                      get {
                        return AttibuteValueAttributeAttributeValueFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }

                public struct Group: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["AttributeGroup"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                      GraphQLField("Name", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Sort", type: .nonNull(.scalar(Uint64.self))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(id: Uint64, name: String, sort: Uint64) {
                    self.init(unsafeResultMap: ["__typename": "AttributeGroup", "ID": id, "Name": name, "Sort": sort])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var id: Uint64 {
                    get {
                      return resultMap["ID"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "ID")
                    }
                  }

                  public var name: String {
                    get {
                      return resultMap["Name"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Name")
                    }
                  }

                  public var sort: Uint64 {
                    get {
                      return resultMap["Sort"]! as! Uint64
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Sort")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var attributeGroupFields: AttributeGroupFields {
                      get {
                        return AttributeGroupFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }

            public struct VariantPrice: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["VariantPrice"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("VariantID", type: .nonNull(.scalar(FID.self))),
                  GraphQLField("Type", type: .nonNull(.scalar(VariantPriceType.self))),
                  GraphQLField("Description", type: .scalar(String.self)),
                  GraphQLField("SellingPrice", type: .nonNull(.scalar(Double.self))),
                  GraphQLField("MinResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("MaxResellingPrice", type: .scalar(Double.self)),
                  GraphQLField("RRPPrice", type: .scalar(Double.self)),
                  GraphQLField("BasePrice", type: .scalar(Double.self)),
                  GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
                  GraphQLField("Commission", type: .scalar(Double.self)),
                  GraphQLField("DiscountPercentage", type: .scalar(Double.self)),
                  GraphQLField("DiscountedSellingPrice", type: .scalar(Double.self)),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, variantId: FID, type: VariantPriceType, description: String? = nil, sellingPrice: Double, minResellingPrice: Double? = nil, maxResellingPrice: Double? = nil, rrpPrice: Double? = nil, basePrice: Double? = nil, discounts: [Discount]? = nil, commission: Double? = nil, discountPercentage: Double? = nil, discountedSellingPrice: Double? = nil) {
                self.init(unsafeResultMap: ["__typename": "VariantPrice", "ID": id, "VariantID": variantId, "Type": type, "Description": description, "SellingPrice": sellingPrice, "MinResellingPrice": minResellingPrice, "MaxResellingPrice": maxResellingPrice, "RRPPrice": rrpPrice, "BasePrice": basePrice, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "Commission": commission, "DiscountPercentage": discountPercentage, "DiscountedSellingPrice": discountedSellingPrice])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var variantId: FID {
                get {
                  return resultMap["VariantID"]! as! FID
                }
                set {
                  resultMap.updateValue(newValue, forKey: "VariantID")
                }
              }

              public var type: VariantPriceType {
                get {
                  return resultMap["Type"]! as! VariantPriceType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Type")
                }
              }

              public var description: String? {
                get {
                  return resultMap["Description"] as? String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Description")
                }
              }

              public var sellingPrice: Double {
                get {
                  return resultMap["SellingPrice"]! as! Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "SellingPrice")
                }
              }

              public var minResellingPrice: Double? {
                get {
                  return resultMap["MinResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MinResellingPrice")
                }
              }

              public var maxResellingPrice: Double? {
                get {
                  return resultMap["MaxResellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "MaxResellingPrice")
                }
              }

              public var rrpPrice: Double? {
                get {
                  return resultMap["RRPPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "RRPPrice")
                }
              }

              public var basePrice: Double? {
                get {
                  return resultMap["BasePrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "BasePrice")
                }
              }

              public var discounts: [Discount]? {
                get {
                  return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
                }
                set {
                  resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
                }
              }

              public var commission: Double? {
                get {
                  return resultMap["Commission"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Commission")
                }
              }

              public var discountPercentage: Double? {
                get {
                  return resultMap["DiscountPercentage"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountPercentage")
                }
              }

              public var discountedSellingPrice: Double? {
                get {
                  return resultMap["DiscountedSellingPrice"] as? Double
                }
                set {
                  resultMap.updateValue(newValue, forKey: "DiscountedSellingPrice")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var variantPriceFields: VariantPriceFields {
                  get {
                    return VariantPriceFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }

              public struct Discount: GraphQLSelectionSet {
                public static let possibleTypes: [String] = ["VariantPriceDiscount"]

                public static var selections: [GraphQLSelection] {
                  return [
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                    GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("CountType", type: .nonNull(.scalar(VariantPriceDiscountCountType.self))),
                    GraphQLField("DiscountType", type: .nonNull(.scalar(VariantPriceDiscountDiscountType.self))),
                    GraphQLField("StartCount", type: .scalar(Int.self)),
                    GraphQLField("EndCount", type: .scalar(Int.self)),
                    GraphQLField("VariantPriceID", type: .nonNull(.scalar(Uint64.self))),
                    GraphQLField("DiscountAmount", type: .nonNull(.scalar(Double.self))),
                    GraphQLField("Description", type: .object(Description.selections)),
                    GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
                  ]
                }

                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public init(id: Uint64, countType: VariantPriceDiscountCountType, discountType: VariantPriceDiscountDiscountType, startCount: Int? = nil, endCount: Int? = nil, variantPriceId: Uint64, discountAmount: Double, description: Description? = nil, createdAt: Time) {
                  self.init(unsafeResultMap: ["__typename": "VariantPriceDiscount", "ID": id, "CountType": countType, "DiscountType": discountType, "StartCount": startCount, "EndCount": endCount, "VariantPriceID": variantPriceId, "DiscountAmount": discountAmount, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "CreatedAt": createdAt])
                }

                public var __typename: String {
                  get {
                    return resultMap["__typename"]! as! String
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "__typename")
                  }
                }

                public var id: Uint64 {
                  get {
                    return resultMap["ID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "ID")
                  }
                }

                public var countType: VariantPriceDiscountCountType {
                  get {
                    return resultMap["CountType"]! as! VariantPriceDiscountCountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CountType")
                  }
                }

                public var discountType: VariantPriceDiscountDiscountType {
                  get {
                    return resultMap["DiscountType"]! as! VariantPriceDiscountDiscountType
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountType")
                  }
                }

                public var startCount: Int? {
                  get {
                    return resultMap["StartCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "StartCount")
                  }
                }

                public var endCount: Int? {
                  get {
                    return resultMap["EndCount"] as? Int
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "EndCount")
                  }
                }

                public var variantPriceId: Uint64 {
                  get {
                    return resultMap["VariantPriceID"]! as! Uint64
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "VariantPriceID")
                  }
                }

                public var discountAmount: Double {
                  get {
                    return resultMap["DiscountAmount"]! as! Double
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "DiscountAmount")
                  }
                }

                public var description: Description? {
                  get {
                    return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
                  }
                  set {
                    resultMap.updateValue(newValue?.resultMap, forKey: "Description")
                  }
                }

                public var createdAt: Time {
                  get {
                    return resultMap["CreatedAt"]! as! Time
                  }
                  set {
                    resultMap.updateValue(newValue, forKey: "CreatedAt")
                  }
                }

                public var fragments: Fragments {
                  get {
                    return Fragments(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }

                public struct Fragments {
                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public var variantPriceDiscountFeilds: VariantPriceDiscountFeilds {
                    get {
                      return VariantPriceDiscountFeilds(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }
                }

                public struct Description: GraphQLSelectionSet {
                  public static let possibleTypes: [String] = ["DiscountDescription"]

                  public static var selections: [GraphQLSelection] {
                    return [
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Template", type: .nonNull(.scalar(String.self))),
                      GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
                    ]
                  }

                  public private(set) var resultMap: ResultMap

                  public init(unsafeResultMap: ResultMap) {
                    self.resultMap = unsafeResultMap
                  }

                  public init(template: String, parameters: [String]? = nil) {
                    self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
                  }

                  public var __typename: String {
                    get {
                      return resultMap["__typename"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "__typename")
                    }
                  }

                  public var template: String {
                    get {
                      return resultMap["Template"]! as! String
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Template")
                    }
                  }

                  public var parameters: [String]? {
                    get {
                      return resultMap["Parameters"] as? [String]
                    }
                    set {
                      resultMap.updateValue(newValue, forKey: "Parameters")
                    }
                  }

                  public var fragments: Fragments {
                    get {
                      return Fragments(unsafeResultMap: resultMap)
                    }
                    set {
                      resultMap += newValue.resultMap
                    }
                  }

                  public struct Fragments {
                    public private(set) var resultMap: ResultMap

                    public init(unsafeResultMap: ResultMap) {
                      self.resultMap = unsafeResultMap
                    }

                    public var discountDescriptionFields: DiscountDescriptionFields {
                      get {
                        return DiscountDescriptionFields(unsafeResultMap: resultMap)
                      }
                      set {
                        resultMap += newValue.resultMap
                      }
                    }
                  }
                }
              }
            }
          }

          public struct Image: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["File"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
              self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var id: Uint64 {
              get {
                return resultMap["ID"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var url: String {
              get {
                return resultMap["URL"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "URL")
              }
            }

            public var idType: FileIDType {
              get {
                return resultMap["IDType"]! as! FileIDType
              }
              set {
                resultMap.updateValue(newValue, forKey: "IDType")
              }
            }

            public var category: FileCategoryAll {
              get {
                return resultMap["Category"]! as! FileCategoryAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Category")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var fileFields: FileFields {
                get {
                  return FileFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct AttributeValueImage: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["AttributeValueImage"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Key", type: .nonNull(.scalar(String.self))),
                GraphQLField("Images", type: .nonNull(.list(.nonNull(.object(Image.selections))))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(key: String, images: [Image]) {
              self.init(unsafeResultMap: ["__typename": "AttributeValueImage", "Key": key, "Images": images.map { (value: Image) -> ResultMap in value.resultMap }])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var key: String {
              get {
                return resultMap["Key"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "Key")
              }
            }

            public var images: [Image] {
              get {
                return (resultMap["Images"] as! [ResultMap]).map { (value: ResultMap) -> Image in Image(unsafeResultMap: value) }
              }
              set {
                resultMap.updateValue(newValue.map { (value: Image) -> ResultMap in value.resultMap }, forKey: "Images")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var attributeValueImageFields: AttributeValueImageFields {
                get {
                  return AttributeValueImageFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }

            public struct Image: GraphQLSelectionSet {
              public static let possibleTypes: [String] = ["File"]

              public static var selections: [GraphQLSelection] {
                return [
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                  GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
                  GraphQLField("URL", type: .nonNull(.scalar(String.self))),
                  GraphQLField("IDType", type: .nonNull(.scalar(FileIDType.self))),
                  GraphQLField("Category", type: .nonNull(.scalar(FileCategoryAll.self))),
                ]
              }

              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public init(id: Uint64, url: String, idType: FileIDType, category: FileCategoryAll) {
                self.init(unsafeResultMap: ["__typename": "File", "ID": id, "URL": url, "IDType": idType, "Category": category])
              }

              public var __typename: String {
                get {
                  return resultMap["__typename"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "__typename")
                }
              }

              public var id: Uint64 {
                get {
                  return resultMap["ID"]! as! Uint64
                }
                set {
                  resultMap.updateValue(newValue, forKey: "ID")
                }
              }

              public var url: String {
                get {
                  return resultMap["URL"]! as! String
                }
                set {
                  resultMap.updateValue(newValue, forKey: "URL")
                }
              }

              public var idType: FileIDType {
                get {
                  return resultMap["IDType"]! as! FileIDType
                }
                set {
                  resultMap.updateValue(newValue, forKey: "IDType")
                }
              }

              public var category: FileCategoryAll {
                get {
                  return resultMap["Category"]! as! FileCategoryAll
                }
                set {
                  resultMap.updateValue(newValue, forKey: "Category")
                }
              }

              public var fragments: Fragments {
                get {
                  return Fragments(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }

              public struct Fragments {
                public private(set) var resultMap: ResultMap

                public init(unsafeResultMap: ResultMap) {
                  self.resultMap = unsafeResultMap
                }

                public var fileFields: FileFields {
                  get {
                    return FileFields(unsafeResultMap: resultMap)
                  }
                  set {
                    resultMap += newValue.resultMap
                  }
                }
              }
            }
          }

          public struct ReviewProvider: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["ReviewProvider"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Platform", type: .nonNull(.scalar(ReviewProviderPlatformAll.self))),
                GraphQLField("Type", type: .nonNull(.scalar(ProductReviewTypeAll.self))),
                GraphQLField("ID", type: .nonNull(.scalar(String.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(platform: ReviewProviderPlatformAll, type: ProductReviewTypeAll, id: String) {
              self.init(unsafeResultMap: ["__typename": "ReviewProvider", "Platform": platform, "Type": type, "ID": id])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var platform: ReviewProviderPlatformAll {
              get {
                return resultMap["Platform"]! as! ReviewProviderPlatformAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Platform")
              }
            }

            public var type: ProductReviewTypeAll {
              get {
                return resultMap["Type"]! as! ProductReviewTypeAll
              }
              set {
                resultMap.updateValue(newValue, forKey: "Type")
              }
            }

            public var id: String {
              get {
                return resultMap["ID"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "ID")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var reviewProviderFields: ReviewProviderFields {
                get {
                  return ReviewProviderFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }

          public struct ReviewsSummary: GraphQLSelectionSet {
            public static let possibleTypes: [String] = ["ReviewsSummary"]

            public static var selections: [GraphQLSelection] {
              return [
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
                GraphQLField("Total", type: .nonNull(.scalar(Uint64.self))),
                GraphQLField("Stars", type: .nonNull(.scalar(Double.self))),
              ]
            }

            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public init(total: Uint64, stars: Double) {
              self.init(unsafeResultMap: ["__typename": "ReviewsSummary", "Total": total, "Stars": stars])
            }

            public var __typename: String {
              get {
                return resultMap["__typename"]! as! String
              }
              set {
                resultMap.updateValue(newValue, forKey: "__typename")
              }
            }

            public var total: Uint64 {
              get {
                return resultMap["Total"]! as! Uint64
              }
              set {
                resultMap.updateValue(newValue, forKey: "Total")
              }
            }

            public var stars: Double {
              get {
                return resultMap["Stars"]! as! Double
              }
              set {
                resultMap.updateValue(newValue, forKey: "Stars")
              }
            }

            public var fragments: Fragments {
              get {
                return Fragments(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }

            public struct Fragments {
              public private(set) var resultMap: ResultMap

              public init(unsafeResultMap: ResultMap) {
                self.resultMap = unsafeResultMap
              }

              public var reviewsSummaryFields: ReviewsSummaryFields {
                get {
                  return ReviewsSummaryFields(unsafeResultMap: resultMap)
                }
                set {
                  resultMap += newValue.resultMap
                }
              }
            }
          }
        }
      }
    }

    public struct Info: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["Cart"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
          GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
          GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
          GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
          GraphQLField("Discount", type: .object(Discount.selections)),
          GraphQLField("Discounts", type: .list(.nonNull(.object(Discount.selections)))),
          GraphQLField("DeliveryDiscount", type: .object(DeliveryDiscount.selections)),
          GraphQLField("Status", type: .nonNull(.scalar(CartStatusAll.self))),
          GraphQLField("Source", type: .nonNull(.scalar(SourceAll.self))),
          GraphQLField("SourceClose", type: .scalar(SourceAll.self)),
          GraphQLField("ZipCode", type: .scalar(String.self)),
          GraphQLField("ClosedAt", type: .scalar(Time.self)),
          GraphQLField("UpdatedAt", type: .scalar(Time.self)),
          GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(id: Uint64, payablePrice: Double, totalAmount: Double, discountCodeAmount: Double, hasDiscount: Bool, discount: Discount? = nil, discounts: [Discount]? = nil, deliveryDiscount: DeliveryDiscount? = nil, status: CartStatusAll, source: SourceAll, sourceClose: SourceAll? = nil, zipCode: String? = nil, closedAt: Time? = nil, updatedAt: Time? = nil, createdAt: Time) {
        self.init(unsafeResultMap: ["__typename": "Cart", "ID": id, "PayablePrice": payablePrice, "TotalAmount": totalAmount, "DiscountCodeAmount": discountCodeAmount, "HasDiscount": hasDiscount, "Discount": discount.flatMap { (value: Discount) -> ResultMap in value.resultMap }, "Discounts": discounts.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, "DeliveryDiscount": deliveryDiscount.flatMap { (value: DeliveryDiscount) -> ResultMap in value.resultMap }, "Status": status, "Source": source, "SourceClose": sourceClose, "ZipCode": zipCode, "ClosedAt": closedAt, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var id: Uint64 {
        get {
          return resultMap["ID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ID")
        }
      }

      public var payablePrice: Double {
        get {
          return resultMap["PayablePrice"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "PayablePrice")
        }
      }

      public var totalAmount: Double {
        get {
          return resultMap["TotalAmount"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "TotalAmount")
        }
      }

      public var discountCodeAmount: Double {
        get {
          return resultMap["DiscountCodeAmount"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
        }
      }

      public var hasDiscount: Bool {
        get {
          return resultMap["HasDiscount"]! as! Bool
        }
        set {
          resultMap.updateValue(newValue, forKey: "HasDiscount")
        }
      }

      public var discount: Discount? {
        get {
          return (resultMap["Discount"] as? ResultMap).flatMap { Discount(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "Discount")
        }
      }

      public var discounts: [Discount]? {
        get {
          return (resultMap["Discounts"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Discount] in value.map { (value: ResultMap) -> Discount in Discount(unsafeResultMap: value) } }
        }
        set {
          resultMap.updateValue(newValue.flatMap { (value: [Discount]) -> [ResultMap] in value.map { (value: Discount) -> ResultMap in value.resultMap } }, forKey: "Discounts")
        }
      }

      public var deliveryDiscount: DeliveryDiscount? {
        get {
          return (resultMap["DeliveryDiscount"] as? ResultMap).flatMap { DeliveryDiscount(unsafeResultMap: $0) }
        }
        set {
          resultMap.updateValue(newValue?.resultMap, forKey: "DeliveryDiscount")
        }
      }

      public var status: CartStatusAll {
        get {
          return resultMap["Status"]! as! CartStatusAll
        }
        set {
          resultMap.updateValue(newValue, forKey: "Status")
        }
      }

      public var source: SourceAll {
        get {
          return resultMap["Source"]! as! SourceAll
        }
        set {
          resultMap.updateValue(newValue, forKey: "Source")
        }
      }

      public var sourceClose: SourceAll? {
        get {
          return resultMap["SourceClose"] as? SourceAll
        }
        set {
          resultMap.updateValue(newValue, forKey: "SourceClose")
        }
      }

      public var zipCode: String? {
        get {
          return resultMap["ZipCode"] as? String
        }
        set {
          resultMap.updateValue(newValue, forKey: "ZipCode")
        }
      }

      public var closedAt: Time? {
        get {
          return resultMap["ClosedAt"] as? Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "ClosedAt")
        }
      }

      public var updatedAt: Time? {
        get {
          return resultMap["UpdatedAt"] as? Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "UpdatedAt")
        }
      }

      public var createdAt: Time {
        get {
          return resultMap["CreatedAt"]! as! Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "CreatedAt")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var cartFields: CartFields {
          get {
            return CartFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }

      public struct Discount: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["Discount"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Name", type: .nonNull(.scalar(String.self))),
            GraphQLField("Description", type: .object(Description.selections)),
            GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
            GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("PublicCode", type: .object(PublicCode.selections)),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
          self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var name: String {
          get {
            return resultMap["Name"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Name")
          }
        }

        public var description: Description? {
          get {
            return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Description")
          }
        }

        public var type: DiscountTypeAll {
          get {
            return resultMap["Type"]! as! DiscountTypeAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Type")
          }
        }

        public var amount: Double {
          get {
            return resultMap["Amount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "Amount")
          }
        }

        public var publicCode: PublicCode? {
          get {
            return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var createdAt: Time {
          get {
            return resultMap["CreatedAt"]! as! Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "CreatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountFields: DiscountFields {
            get {
              return DiscountFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Description: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["DiscountDescription"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Template", type: .nonNull(.scalar(String.self))),
              GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(template: String, parameters: [String]? = nil) {
            self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var template: String {
            get {
              return resultMap["Template"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Template")
            }
          }

          public var parameters: [String]? {
            get {
              return resultMap["Parameters"] as? [String]
            }
            set {
              resultMap.updateValue(newValue, forKey: "Parameters")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountDescriptionFields: DiscountDescriptionFields {
              get {
                return DiscountDescriptionFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct PublicCode: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["DiscountCode"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Code", type: .nonNull(.scalar(String.self))),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, code: String, updatedAt: Time? = nil) {
            self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var code: String {
            get {
              return resultMap["Code"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Code")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountCodeFields: DiscountCodeFields {
              get {
                return DiscountCodeFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }

      public struct Discount: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["Discount"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Name", type: .nonNull(.scalar(String.self))),
            GraphQLField("Description", type: .object(Description.selections)),
            GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
            GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("PublicCode", type: .object(PublicCode.selections)),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
          self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var name: String {
          get {
            return resultMap["Name"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Name")
          }
        }

        public var description: Description? {
          get {
            return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Description")
          }
        }

        public var type: DiscountTypeAll {
          get {
            return resultMap["Type"]! as! DiscountTypeAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Type")
          }
        }

        public var amount: Double {
          get {
            return resultMap["Amount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "Amount")
          }
        }

        public var publicCode: PublicCode? {
          get {
            return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var createdAt: Time {
          get {
            return resultMap["CreatedAt"]! as! Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "CreatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountFields: DiscountFields {
            get {
              return DiscountFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Description: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["DiscountDescription"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Template", type: .nonNull(.scalar(String.self))),
              GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(template: String, parameters: [String]? = nil) {
            self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var template: String {
            get {
              return resultMap["Template"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Template")
            }
          }

          public var parameters: [String]? {
            get {
              return resultMap["Parameters"] as? [String]
            }
            set {
              resultMap.updateValue(newValue, forKey: "Parameters")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountDescriptionFields: DiscountDescriptionFields {
              get {
                return DiscountDescriptionFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct PublicCode: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["DiscountCode"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Code", type: .nonNull(.scalar(String.self))),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, code: String, updatedAt: Time? = nil) {
            self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var code: String {
            get {
              return resultMap["Code"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Code")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountCodeFields: DiscountCodeFields {
              get {
                return DiscountCodeFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }

      public struct DeliveryDiscount: GraphQLSelectionSet {
        public static let possibleTypes: [String] = ["Discount"]

        public static var selections: [GraphQLSelection] {
          return [
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
            GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
            GraphQLField("Name", type: .nonNull(.scalar(String.self))),
            GraphQLField("Description", type: .object(Description.selections)),
            GraphQLField("Type", type: .nonNull(.scalar(DiscountTypeAll.self))),
            GraphQLField("Amount", type: .nonNull(.scalar(Double.self))),
            GraphQLField("PublicCode", type: .object(PublicCode.selections)),
            GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            GraphQLField("CreatedAt", type: .nonNull(.scalar(Time.self))),
          ]
        }

        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public init(id: Uint64, name: String, description: Description? = nil, type: DiscountTypeAll, amount: Double, publicCode: PublicCode? = nil, updatedAt: Time? = nil, createdAt: Time) {
          self.init(unsafeResultMap: ["__typename": "Discount", "ID": id, "Name": name, "Description": description.flatMap { (value: Description) -> ResultMap in value.resultMap }, "Type": type, "Amount": amount, "PublicCode": publicCode.flatMap { (value: PublicCode) -> ResultMap in value.resultMap }, "UpdatedAt": updatedAt, "CreatedAt": createdAt])
        }

        public var __typename: String {
          get {
            return resultMap["__typename"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "__typename")
          }
        }

        public var id: Uint64 {
          get {
            return resultMap["ID"]! as! Uint64
          }
          set {
            resultMap.updateValue(newValue, forKey: "ID")
          }
        }

        public var name: String {
          get {
            return resultMap["Name"]! as! String
          }
          set {
            resultMap.updateValue(newValue, forKey: "Name")
          }
        }

        public var description: Description? {
          get {
            return (resultMap["Description"] as? ResultMap).flatMap { Description(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "Description")
          }
        }

        public var type: DiscountTypeAll {
          get {
            return resultMap["Type"]! as! DiscountTypeAll
          }
          set {
            resultMap.updateValue(newValue, forKey: "Type")
          }
        }

        public var amount: Double {
          get {
            return resultMap["Amount"]! as! Double
          }
          set {
            resultMap.updateValue(newValue, forKey: "Amount")
          }
        }

        public var publicCode: PublicCode? {
          get {
            return (resultMap["PublicCode"] as? ResultMap).flatMap { PublicCode(unsafeResultMap: $0) }
          }
          set {
            resultMap.updateValue(newValue?.resultMap, forKey: "PublicCode")
          }
        }

        public var updatedAt: Time? {
          get {
            return resultMap["UpdatedAt"] as? Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "UpdatedAt")
          }
        }

        public var createdAt: Time {
          get {
            return resultMap["CreatedAt"]! as! Time
          }
          set {
            resultMap.updateValue(newValue, forKey: "CreatedAt")
          }
        }

        public var fragments: Fragments {
          get {
            return Fragments(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }

        public struct Fragments {
          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public var discountFields: DiscountFields {
            get {
              return DiscountFields(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }
        }

        public struct Description: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["DiscountDescription"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("Template", type: .nonNull(.scalar(String.self))),
              GraphQLField("Parameters", type: .list(.nonNull(.scalar(String.self)))),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(template: String, parameters: [String]? = nil) {
            self.init(unsafeResultMap: ["__typename": "DiscountDescription", "Template": template, "Parameters": parameters])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var template: String {
            get {
              return resultMap["Template"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Template")
            }
          }

          public var parameters: [String]? {
            get {
              return resultMap["Parameters"] as? [String]
            }
            set {
              resultMap.updateValue(newValue, forKey: "Parameters")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountDescriptionFields: DiscountDescriptionFields {
              get {
                return DiscountDescriptionFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }

        public struct PublicCode: GraphQLSelectionSet {
          public static let possibleTypes: [String] = ["DiscountCode"]

          public static var selections: [GraphQLSelection] {
            return [
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
              GraphQLField("ID", type: .nonNull(.scalar(Uint64.self))),
              GraphQLField("Code", type: .nonNull(.scalar(String.self))),
              GraphQLField("UpdatedAt", type: .scalar(Time.self)),
            ]
          }

          public private(set) var resultMap: ResultMap

          public init(unsafeResultMap: ResultMap) {
            self.resultMap = unsafeResultMap
          }

          public init(id: Uint64, code: String, updatedAt: Time? = nil) {
            self.init(unsafeResultMap: ["__typename": "DiscountCode", "ID": id, "Code": code, "UpdatedAt": updatedAt])
          }

          public var __typename: String {
            get {
              return resultMap["__typename"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "__typename")
            }
          }

          public var id: Uint64 {
            get {
              return resultMap["ID"]! as! Uint64
            }
            set {
              resultMap.updateValue(newValue, forKey: "ID")
            }
          }

          public var code: String {
            get {
              return resultMap["Code"]! as! String
            }
            set {
              resultMap.updateValue(newValue, forKey: "Code")
            }
          }

          public var updatedAt: Time? {
            get {
              return resultMap["UpdatedAt"] as? Time
            }
            set {
              resultMap.updateValue(newValue, forKey: "UpdatedAt")
            }
          }

          public var fragments: Fragments {
            get {
              return Fragments(unsafeResultMap: resultMap)
            }
            set {
              resultMap += newValue.resultMap
            }
          }

          public struct Fragments {
            public private(set) var resultMap: ResultMap

            public init(unsafeResultMap: ResultMap) {
              self.resultMap = unsafeResultMap
            }

            public var discountCodeFields: DiscountCodeFields {
              get {
                return DiscountCodeFields(unsafeResultMap: resultMap)
              }
              set {
                resultMap += newValue.resultMap
              }
            }
          }
        }
      }
    }

    public struct Error: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["CartError"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Message", type: .nonNull(.scalar(String.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(itemId: Uint64, message: String) {
        self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var itemId: Uint64 {
        get {
          return resultMap["ItemID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ItemID")
        }
      }

      public var message: String {
        get {
          return resultMap["Message"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Message")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var cartErrorFields: CartErrorFields {
          get {
            return CartErrorFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }
    }
  }

  struct CartBillingFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment CartBillingFields on CartBillingDetail {
        __typename
        TotalAmount
        PayablePrice
        DiscountCodeAmount
        VoucherAmount
        UsedVoucher
        ShippingCost
        HasDiscount
      }
      """

    public static let possibleTypes: [String] = ["CartBillingDetail"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("TotalAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("PayablePrice", type: .nonNull(.scalar(Double.self))),
        GraphQLField("DiscountCodeAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("VoucherAmount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("UsedVoucher", type: .nonNull(.scalar(Double.self))),
        GraphQLField("ShippingCost", type: .nonNull(.scalar(Double.self))),
        GraphQLField("HasDiscount", type: .nonNull(.scalar(Bool.self))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(totalAmount: Double, payablePrice: Double, discountCodeAmount: Double, voucherAmount: Double, usedVoucher: Double, shippingCost: Double, hasDiscount: Bool) {
      self.init(unsafeResultMap: ["__typename": "CartBillingDetail", "TotalAmount": totalAmount, "PayablePrice": payablePrice, "DiscountCodeAmount": discountCodeAmount, "VoucherAmount": voucherAmount, "UsedVoucher": usedVoucher, "ShippingCost": shippingCost, "HasDiscount": hasDiscount])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var totalAmount: Double {
      get {
        return resultMap["TotalAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "TotalAmount")
      }
    }

    public var payablePrice: Double {
      get {
        return resultMap["PayablePrice"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "PayablePrice")
      }
    }

    public var discountCodeAmount: Double {
      get {
        return resultMap["DiscountCodeAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "DiscountCodeAmount")
      }
    }

    public var voucherAmount: Double {
      get {
        return resultMap["VoucherAmount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "VoucherAmount")
      }
    }

    public var usedVoucher: Double {
      get {
        return resultMap["UsedVoucher"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "UsedVoucher")
      }
    }

    public var shippingCost: Double {
      get {
        return resultMap["ShippingCost"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "ShippingCost")
      }
    }

    public var hasDiscount: Bool {
      get {
        return resultMap["HasDiscount"]! as! Bool
      }
      set {
        resultMap.updateValue(newValue, forKey: "HasDiscount")
      }
    }
  }

  struct ResellingPriceFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment ResellingPriceFields on ResellingPrice {
        __typename
        CartItemID
        Price
        ResellerPrice
        SetAt
        IsSet
      }
      """

    public static let possibleTypes: [String] = ["ResellingPrice"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("CartItemID", type: .nonNull(.scalar(Uint64.self))),
        GraphQLField("Price", type: .nonNull(.scalar(Double.self))),
        GraphQLField("ResellerPrice", type: .nonNull(.scalar(Double.self))),
        GraphQLField("SetAt", type: .scalar(Time.self)),
        GraphQLField("IsSet", type: .nonNull(.scalar(Bool.self))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(cartItemId: Uint64, price: Double, resellerPrice: Double, setAt: Time? = nil, isSet: Bool) {
      self.init(unsafeResultMap: ["__typename": "ResellingPrice", "CartItemID": cartItemId, "Price": price, "ResellerPrice": resellerPrice, "SetAt": setAt, "IsSet": isSet])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var cartItemId: Uint64 {
      get {
        return resultMap["CartItemID"]! as! Uint64
      }
      set {
        resultMap.updateValue(newValue, forKey: "CartItemID")
      }
    }

    public var price: Double {
      get {
        return resultMap["Price"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "Price")
      }
    }

    public var resellerPrice: Double {
      get {
        return resultMap["ResellerPrice"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "ResellerPrice")
      }
    }

    public var setAt: Time? {
      get {
        return resultMap["SetAt"] as? Time
      }
      set {
        resultMap.updateValue(newValue, forKey: "SetAt")
      }
    }

    public var isSet: Bool {
      get {
        return resultMap["IsSet"]! as! Bool
      }
      set {
        resultMap.updateValue(newValue, forKey: "IsSet")
      }
    }
  }

  struct ResellingPriceResponseFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment ResellingPriceResponseFields on ResellingPriceResponse {
        __typename
        Errors {
          __typename
          ...cartErrorFields
        }
        ResellingPrices {
          __typename
          ...ResellingPriceFields
        }
      }
      """

    public static let possibleTypes: [String] = ["ResellingPriceResponse"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("Errors", type: .list(.nonNull(.object(Error.selections)))),
        GraphQLField("ResellingPrices", type: .nonNull(.list(.nonNull(.object(ResellingPrice.selections))))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(errors: [Error]? = nil, resellingPrices: [ResellingPrice]) {
      self.init(unsafeResultMap: ["__typename": "ResellingPriceResponse", "Errors": errors.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, "ResellingPrices": resellingPrices.map { (value: ResellingPrice) -> ResultMap in value.resultMap }])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var errors: [Error]? {
      get {
        return (resultMap["Errors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [Error] in value.map { (value: ResultMap) -> Error in Error(unsafeResultMap: value) } }
      }
      set {
        resultMap.updateValue(newValue.flatMap { (value: [Error]) -> [ResultMap] in value.map { (value: Error) -> ResultMap in value.resultMap } }, forKey: "Errors")
      }
    }

    public var resellingPrices: [ResellingPrice] {
      get {
        return (resultMap["ResellingPrices"] as! [ResultMap]).map { (value: ResultMap) -> ResellingPrice in ResellingPrice(unsafeResultMap: value) }
      }
      set {
        resultMap.updateValue(newValue.map { (value: ResellingPrice) -> ResultMap in value.resultMap }, forKey: "ResellingPrices")
      }
    }

    public struct Error: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["CartError"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Message", type: .nonNull(.scalar(String.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(itemId: Uint64, message: String) {
        self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var itemId: Uint64 {
        get {
          return resultMap["ItemID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ItemID")
        }
      }

      public var message: String {
        get {
          return resultMap["Message"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Message")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var cartErrorFields: CartErrorFields {
          get {
            return CartErrorFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }
    }

    public struct ResellingPrice: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["ResellingPrice"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("CartItemID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Price", type: .nonNull(.scalar(Double.self))),
          GraphQLField("ResellerPrice", type: .nonNull(.scalar(Double.self))),
          GraphQLField("SetAt", type: .scalar(Time.self)),
          GraphQLField("IsSet", type: .nonNull(.scalar(Bool.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(cartItemId: Uint64, price: Double, resellerPrice: Double, setAt: Time? = nil, isSet: Bool) {
        self.init(unsafeResultMap: ["__typename": "ResellingPrice", "CartItemID": cartItemId, "Price": price, "ResellerPrice": resellerPrice, "SetAt": setAt, "IsSet": isSet])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var cartItemId: Uint64 {
        get {
          return resultMap["CartItemID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "CartItemID")
        }
      }

      public var price: Double {
        get {
          return resultMap["Price"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "Price")
        }
      }

      public var resellerPrice: Double {
        get {
          return resultMap["ResellerPrice"]! as! Double
        }
        set {
          resultMap.updateValue(newValue, forKey: "ResellerPrice")
        }
      }

      public var setAt: Time? {
        get {
          return resultMap["SetAt"] as? Time
        }
        set {
          resultMap.updateValue(newValue, forKey: "SetAt")
        }
      }

      public var isSet: Bool {
        get {
          return resultMap["IsSet"]! as! Bool
        }
        set {
          resultMap.updateValue(newValue, forKey: "IsSet")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var resellingPriceFields: ResellingPriceFields {
          get {
            return ResellingPriceFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }
    }
  }

  struct CartSummaryResponseFields: GraphQLFragment {
    /// The raw GraphQL definition of this fragment.
    public static let fragmentDefinition: String =
      """
      fragment CartSummaryResponseFields on CartSummaryResponse {
        __typename
        ShipmentCost
        Discount
        TotalRRPPrice
        TotalSellingPrice
        TotalCommission
        OrderTotal
        CartErrors {
          __typename
          ...cartErrorFields
        }
      }
      """

    public static let possibleTypes: [String] = ["CartSummaryResponse"]

    public static var selections: [GraphQLSelection] {
      return [
        GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
        GraphQLField("ShipmentCost", type: .nonNull(.scalar(Double.self))),
        GraphQLField("Discount", type: .nonNull(.scalar(Double.self))),
        GraphQLField("TotalRRPPrice", type: .nonNull(.scalar(Double.self))),
        GraphQLField("TotalSellingPrice", type: .nonNull(.scalar(Double.self))),
        GraphQLField("TotalCommission", type: .nonNull(.scalar(Double.self))),
        GraphQLField("OrderTotal", type: .nonNull(.scalar(Double.self))),
        GraphQLField("CartErrors", type: .list(.nonNull(.object(CartError.selections)))),
      ]
    }

    public private(set) var resultMap: ResultMap

    public init(unsafeResultMap: ResultMap) {
      self.resultMap = unsafeResultMap
    }

    public init(shipmentCost: Double, discount: Double, totalRrpPrice: Double, totalSellingPrice: Double, totalCommission: Double, orderTotal: Double, cartErrors: [CartError]? = nil) {
      self.init(unsafeResultMap: ["__typename": "CartSummaryResponse", "ShipmentCost": shipmentCost, "Discount": discount, "TotalRRPPrice": totalRrpPrice, "TotalSellingPrice": totalSellingPrice, "TotalCommission": totalCommission, "OrderTotal": orderTotal, "CartErrors": cartErrors.flatMap { (value: [CartError]) -> [ResultMap] in value.map { (value: CartError) -> ResultMap in value.resultMap } }])
    }

    public var __typename: String {
      get {
        return resultMap["__typename"]! as! String
      }
      set {
        resultMap.updateValue(newValue, forKey: "__typename")
      }
    }

    public var shipmentCost: Double {
      get {
        return resultMap["ShipmentCost"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "ShipmentCost")
      }
    }

    public var discount: Double {
      get {
        return resultMap["Discount"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "Discount")
      }
    }

    public var totalRrpPrice: Double {
      get {
        return resultMap["TotalRRPPrice"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "TotalRRPPrice")
      }
    }

    public var totalSellingPrice: Double {
      get {
        return resultMap["TotalSellingPrice"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "TotalSellingPrice")
      }
    }

    public var totalCommission: Double {
      get {
        return resultMap["TotalCommission"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "TotalCommission")
      }
    }

    public var orderTotal: Double {
      get {
        return resultMap["OrderTotal"]! as! Double
      }
      set {
        resultMap.updateValue(newValue, forKey: "OrderTotal")
      }
    }

    public var cartErrors: [CartError]? {
      get {
        return (resultMap["CartErrors"] as? [ResultMap]).flatMap { (value: [ResultMap]) -> [CartError] in value.map { (value: ResultMap) -> CartError in CartError(unsafeResultMap: value) } }
      }
      set {
        resultMap.updateValue(newValue.flatMap { (value: [CartError]) -> [ResultMap] in value.map { (value: CartError) -> ResultMap in value.resultMap } }, forKey: "CartErrors")
      }
    }

    public struct CartError: GraphQLSelectionSet {
      public static let possibleTypes: [String] = ["CartError"]

      public static var selections: [GraphQLSelection] {
        return [
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("__typename", type: .nonNull(.scalar(String.self))),
          GraphQLField("ItemID", type: .nonNull(.scalar(Uint64.self))),
          GraphQLField("Message", type: .nonNull(.scalar(String.self))),
        ]
      }

      public private(set) var resultMap: ResultMap

      public init(unsafeResultMap: ResultMap) {
        self.resultMap = unsafeResultMap
      }

      public init(itemId: Uint64, message: String) {
        self.init(unsafeResultMap: ["__typename": "CartError", "ItemID": itemId, "Message": message])
      }

      public var __typename: String {
        get {
          return resultMap["__typename"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "__typename")
        }
      }

      public var itemId: Uint64 {
        get {
          return resultMap["ItemID"]! as! Uint64
        }
        set {
          resultMap.updateValue(newValue, forKey: "ItemID")
        }
      }

      public var message: String {
        get {
          return resultMap["Message"]! as! String
        }
        set {
          resultMap.updateValue(newValue, forKey: "Message")
        }
      }

      public var fragments: Fragments {
        get {
          return Fragments(unsafeResultMap: resultMap)
        }
        set {
          resultMap += newValue.resultMap
        }
      }

      public struct Fragments {
        public private(set) var resultMap: ResultMap

        public init(unsafeResultMap: ResultMap) {
          self.resultMap = unsafeResultMap
        }

        public var cartErrorFields: CartErrorFields {
          get {
            return CartErrorFields(unsafeResultMap: resultMap)
          }
          set {
            resultMap += newValue.resultMap
          }
        }
      }
    }
  }
}
